SystemOrganization addCategory: #'Seaside-Builder'!
SystemOrganization addCategory: #'Seaside-Canvas'!
SystemOrganization addCategory: #'Seaside-Canvas-Tags'!
SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Components-Tools'!
SystemOrganization addCategory: #'Seaside-Components-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Configuration'!
SystemOrganization addCategory: #'Seaside-Continuations'!
SystemOrganization addCategory: #'Seaside-Document'!
SystemOrganization addCategory: #'Seaside-Examples-Store'!
SystemOrganization addCategory: #'Seaside-Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside-Examples-Test'!
SystemOrganization addCategory: #'Seaside-HTTP'!
SystemOrganization addCategory: #'Seaside-Libraries'!
SystemOrganization addCategory: #'Seaside-Platform'!
SystemOrganization addCategory: #'Seaside-Rendering'!
SystemOrganization addCategory: #'Seaside-RenderLoop'!
SystemOrganization addCategory: #'Seaside-RequestHandler'!
SystemOrganization addCategory: #'Seaside-Session'!
SystemOrganization addCategory: #'Seaside-StateRegistry'!
SystemOrganization addCategory: #'Seaside-Utilities'!

!ByteArray methodsFor: '*seaside2' stamp: 'avi 1/8/2006 14:54'!
displayString
	^ self asString! !

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 00:09'!
fromString: aString
	| id |
	id _ super new: aString size.
	aString withIndexDo: [:ea :i | id at: i put: ea asInteger].
	^ id
! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'al 6/29/2005 09:07'!
initialize
	"WAExternalID initialize"

	GeneratorMutex _ Semaphore forMutualExclusion.
	Smalltalk addToStartUpList: self.
	self startUp.! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new: aNumber
	^ (super new: aNumber) initialize! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'al 6/29/2005 09:08'!
startUp
	Generator _ Random new.! !

!WAExternalID methodsFor: 'private' stamp: 'jf 3/4/2004 00:34'!
initialize
	GeneratorMutex critical:
		[1 to: self size do: [:i | self at: i put: ((($a to: $z), ($A to: $Z)) atRandom: Generator) asInteger]]! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Amb class methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 01:59'!
new
	^ super new initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev _ failureContinuation.
	results _ OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation _ [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation _ kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:28'!
initialize
	failureContinuation _ [:v | self error: 'Amb tree exhausted'].! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev _ failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation _
					[:v | failureContinuation _ kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #AnswerContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

Continuation subclass: #EscapeContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

Continuation subclass: #ResponseContinuation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Object methodsFor: '*seaside2-squeak' stamp: 'lr 7/12/2005 17:01'!
displayString
	^ self asString! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do:
		[:i | (anObject instVarAt: i) == (self instVarAt: i) ifFalse: [^ false]].
	self class isVariable ifTrue:
		[1 to: self size do: [:i | (anObject at: i) == (self at: i) ifFalse: [^ false]]].
	^ true! !

!Object methodsFor: '*seaside2' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/26/2002 20:05'!
renderOn: aRenderer
	aRenderer text: self! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:19'!
restoreFromSnapshot: anObject
	1 to: self class instSize do: [:i | self instVarAt: i put: (anObject instVarAt: i)].
	self class isVariable ifTrue: [1 to: self size do: [:i | self at: i put: (anObject at: i)]].
! !

!Object methodsFor: '*seaside2' stamp: 'avi 9/1/2004 21:20'!
snapshotCopy
	^ self shallowCopy! !

!Object methodsFor: '*seaside2' stamp: 'cds 7/25/2005 10:21'!
validationError: message
	^WAValidationNotification new signal: message! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:13'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:40'!
ensureAuthorInitials: aBlock
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: aBlock value].
! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 1/1/2005 15:05'!
isProxy: anObject
	^ (anObject class allSuperclasses includes: Object) not! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:25'!
readWriteStream
	^ RWBinaryOrTextStream on: String new! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:10'!
smtpServer
	^ MailSender smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'tonyg 1/3/2006 10:40'!
vmStatisticsReportString
	^ SmalltalkImage current vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified ' stamp: 'ab 7/3/2003 13:02'!
weakDictionaryOfSize: aNumber
	| dict |
	dict _ WeakIdentityKeyDictionary new: aNumber.
	WeakArray addWeakDependent: dict.
	^ dict! !

Object subclass: #WAAbstractHtmlBuilder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAAbstractHtmlBuilder commentStamp: '<historical>' prior: 0!
I am abstract class providing methods to build xhtml.  My most commonly used subclass is WAHtmlRenderer.!

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:19'!
encode: anObject
	| charOrString |
	^ String streamContents:
		[:s |
		anObject displayString do:
			[:char |
			charOrString _ 
				HtmlCharacters at: char asInteger + 1 ifAbsent: [char asCharacter].
			charOrString isString
				ifTrue: [s nextPutAll: charOrString]
				ifFalse: [s nextPut: charOrString]]]! !

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'avi 6/25/2004 20:46'!
initialize
	"WAHtmlBuilder initialize"
	HtmlCharacters _ Array new: 256.
	
	0 to: 255 do: [:ea | HtmlCharacters at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | HtmlCharacters at: (c asInteger + 1) put: ('&',s,';') ]
	! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 01:08'!
acronym: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self tag: 'acronym' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:49'!
anchorWithMailto: emailString
	self anchorWithUrl: 'mailto:', emailString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:50'!
anchorWithMailto: emailString subject: subjectString
	self anchorWithUrl: 'mailto:', emailString, '?subject=', subjectString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 4/15/2004 12:06'!
anchorWithName: aString
	self attributes name: aString.
	self tag: #a.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'lr 5/3/2005 08:50'!
anchorWithPopupUrl: urlString extent: aPoint do: anObject
	self 
		anchorWithPopupUrl: urlString 
		name: ''
		extent: aPoint 
		toggles: #(menubar resizable scrollbars) 
		do: anObject
! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupUrl: urlString extent: aPoint text: aString
	self 
		anchorWithPopupUrl: urlString 
		extent: aPoint 
		do: aString! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'ac 12/23/2004 04:42'!
anchorWithPopupUrl: urlString name: nameString extent: aPoint toggles: aCollection do: anObject
	self attributes
		at: 'onClick' 
		put: (self popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection), '; return false'.
	
	self anchorWithUrl: urlString do: anObject. ! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:20'!
anchorWithUrl: urlString do: aBlock
	self attributes href: urlString.
	self tag: 'a' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:19'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes	title: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:05'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer _ WAHtmlAttributes new]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mbany 4/14/2005 12:22'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key displayString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'mbany 4/14/2005 12:22'!
buttonWithType: typeString named: nameString value: valueString do: aBlock
	nameString ifNotNil:
		[self attributes
			at: 'name' put: nameString;
			at: 'id' ifAbsentPut: nameString].
	valueString ifNotNil: [self attributes value: valueString displayString].
		
	self attributes type: typeString.
	
	self tag: 'button' do: aBlock.
! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:44'!
closeTag: aString
	self document closeTag: aString ! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:45'!
document
	self subclassResponsibility ! !

!WAAbstractHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'mbany 4/14/2005 12:21'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:02'!
encodeText: anObject
	"deprecated"
	self text: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'avi 5/24/2004 14:25'!
fieldsetWithLegend: aString do: aBlock
	self tag: 'fieldset' do: [
		self tag: 'legend' do: aString.
		aBlock value.
	]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:16'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'post' action: actionUrl do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 11/20/2003 18:41'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes method: methodString;
			action: actionUrl.
	self tag: 'form' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'mbany 4/14/2005 12:20'!
heading: anObject level: aNumber
	self tag: 'h', aNumber displayString do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:01'!
html: aString
	self document text: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString
	self image: urlString altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	self attributeAt: 'src' put: urlString.
	
	self tag: #img.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:23'!
image: urlString width: width height: height
	self image: urlString width: width height: height altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/13/2004 22:42'!
image: urlString width: width height: height altText: altString
	self attributeAt: 'width' put: width.
	self attributeAt: 'height' put: height.
	self attributeAt: 'border' put: 0.
	
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'lr 5/10/2005 16:15'!
inputWithType: type named: name value: value
	name ifNotNil: [self attributes at: 'name' put: name].
	value ifNotNil: [self attributes value: value displayString].
		
	self attributes type: type; addClass: type.
	
	self tag: 'input'.
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 10/27/2004 12:01'!
labelFor: idString do: aBlock
	self attributes at: 'for' put: idString.
	self tag: 'label' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTable: aBlock
	self attributes
		border: 0;
		cellspacing: 0;
		cellpadding: 0.
	self table: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTableOfWidth: width do: aBlock
	self attributes width: width.
	self layoutTable: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:24'!
list: aCollection do: aBlock
	self unorderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:51'!
openTag: aString
	self document openTag: aString attributes: self attributes.
	attributeBuffer _ nil.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:51'!
orderedList: aBlock
	self tag: 'ol' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/26/2004 12:52'!
orderedList: aCollection do: aBlock
	self orderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'mbany 4/14/2005 12:24'!
popupStringWithUrl: urlString name: nameString extent: aPoint toggles: aCollection
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: urlString;
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: nameString;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: aPoint x displayString;
			nextPutAll: ',height=';
			nextPutAll: aPoint y displayString;
			nextPut: $,;
			nextPutAll: (self toggleStringFor: aCollection);
			nextPut: $';
			nextPutAll: ')']! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 7/2/2004 14:21'!
script: aString
	self tag: 'script' do: [self html: aString]! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'avi 6/21/2004 22:31'!
scriptWithUrl: urlString
	self attributes
		at: 'type' put: 'text/javascript';
		at: 'src' put: urlString.
	self tag: 'script'.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/17/2004 12:32'!
shouldCloseTag: aString
	^ #(#hr #br #input #img #link)! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 2/18/2004 15:04'!
space
	self html: '&nbsp;'! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 18:20'!
space: aNumber
	aNumber timesRepeat: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanClass: aString with: anObject
		self cssClass: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ac 11/26/2004 16:55'!
style: aString
	self attributeAt: 'style' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:19'!
submitButtonWithText: aString
	self attributes value: aString.
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:11'!
tableData: aBlock span: aNumber
	aNumber > 0 ifTrue:
		[self attributes at: 'colspan' put: aNumber.
		self tableData: aBlock]
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:10'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self tableData: aBlock span: aNumber]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString
	self openTag: aString.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:03'!
text: anObject
	self html: (self class encode: anObject)! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'mbany 4/14/2005 12:24'!
toggleStringFor: aCollection
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea | stream nextPutAll: ea displayString, '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:23'!
unorderedList: aBlock
	self tag: 'ul' do: aBlock! !

WAAbstractHtmlBuilder subclass: #WAHtmlBuilder
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
on: aDocument
	^ self new document: aDocument! !

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
document: aDocument
	document _ aDocument! !

WAAbstractHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context callbacks'
	classVariableNames: 'Transparent1X1Form'
	poolDictionaries: ''
	category: 'Seaside-Builder'!

!WAHtmlRenderer commentStamp: '<historical>' prior: 0!
I am passed to the method #renderContentOn: of components unless #rendererClass has been redefined. On top of the basic XHTML construction methods inherited from WAAbstractHtmlBuilder, I provide an interface to attach event handlers to anchors and to form-elements.

To render any kind of squeak object call the message #render: It will do a double dispatch and call #renderOn: on this object.  For example:

	html render: 'Some text'.
	html render: 123.					" will print the child "
	html render: nil. 					" will do nothing "
	html render: #( 'a' 'b' 'c' ).			" will print every element "	
	html render: businessObject.			" will print the #displayString of your object "
	html render: childComponent.		" will render the child component "
	
This kind of double dispatch can be used with any xhtml-generating method:

	html divNamed: 'child' with: childComponent.
	html bold: #( 1 'First' ).!

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 12:20'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'ac 3/5/2005 15:23'!
transparent1X1Form
	^ Transparent1X1Form ifNil: [Transparent1X1Form _ Form extent: 1@1]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:42'!
anchorOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'pmm 6/7/2005 15:34'!
anchorWithAction: actionBlock do: linkBlock	
	self openAnchorWithAction: actionBlock.
	self render: linkBlock.
	self closeTag: 'a'.

! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:09'!
anchorWithAction: actionBlock image: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock text: aString
	self anchorWithAction: actionBlock do: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/10/2005 14:33'!
anchorWithAction: actionBlock text: aString submitFormNamed: formName
	| key |
	key _ self context nextKey.
	self attributes at: 'onClick' put: 'submitFormTriggeringCallback(' , formName printString, ', ' , key displayString printString, '); return false;'.
	self anchorWithAction: actionBlock text: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'lr 6/8/2005 09:44'!
anchorWithCallback: actionBlock do: linkBlock
	self anchorWithUrl: (self urlForIdempotentAction: actionBlock) do: linkBlock! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:43'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self closeTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:15'!
anchorWithPopupAction: aBlock extent: aPoint do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		extent: aPoint
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:20'!
anchorWithPopupAction: aBlock extent: aPoint text: aString
	self
		anchorWithPopupAction: aBlock 
		extent: aPoint 
		do: aString! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 12/10/2004 17:17'!
anchorWithPopupAction: aBlock name: nameString extent: aPoint toggles: aCollection do: anObject
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		name: nameString 
		extent: aPoint
		toggles: aCollection
		do: anObject! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'avi 6/8/2004 00:40'!
anchorWithScript: aString do: linkBlock
	self attributes at: 'onClick' put: aString.
	self anchorWithUrl: '#' do: linkBlock! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'mbany 4/14/2005 12:32'!
autofocus: aBlock
	| id |
	id _ self ensureId.
	aBlock value.
	self script: 'document.getElementById("', id displayString, '").focus()'! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 2/12/2003 17:21'!
booleanMenuOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:29'!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/7/2004 22:50'!
cancelButtonWithAction: aBlock
	self attributes value: 'Cancel'.
	self inputWithType: 'submit' named: (self callbacks registerCancelActionCallback: aBlock)
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'jf 1/12/2004 14:35'!
checkboxOn: aSymbol of: anObject
	self
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/25/2004 20:47'!
checkboxWithValue: aBoolean callback: callbackBlock
   | value originalAttributes |
   value _ ValueHolder new.
   originalAttributes _ attributeBuffer.
   attributeBuffer _ nil.
   self
       hiddenInputWithCallback: [value contents: false].
   attributeBuffer _ originalAttributes.
   self attributeAt: 'checked' put: aBoolean.
   self
       valueInputOfType: 'checkbox'
       value: 'true'
       callback: [value contents: true].
   callbackBlock fixTemps.
   self
       hiddenInputWithCallback: [callbackBlock value: value contents]
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 7/5/2004 11:57'!
close! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 3/13/2004 22:49'!
dateInputWithValue: aDate callback: aBlock
	| values |
	aBlock fixTemps.
	
	values _ Array new: 3.
	self
		selectFromList: (1 to: 12)
		selected: aDate monthIndex 
		callback: [ :month | values at: 2 put: month ]
		labels: [:ea | Date nameOfMonth: ea].
	self space.
	self
		textInputWithValue: aDate dayOfMonth 
		callback: [ :day | values at: 1 put: day ]
		maxLength: 2.
	self space.
	self 
		textInputWithValue: aDate year
		callback: [ :year | values at: 3 put: year]
		maxLength: 4.
	self hiddenInputWithCallback:
		[aBlock value: (Date
				newDay: (values first min: (Date daysInMonth: values second forYear: values third))
				monthNumber: values second
				year: values third)].
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/7/2004 22:50'!
defaultAction: actionBlock
	self
		inputWithType: 'hidden'
		named: (self callbacks registerDefaultActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 9/29/2005 10:59'!
divWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	linkId _ self ensureId.
	divId _ self ensureId.
	onClick _ 'swapDisplay(', linkId printString, ', ', divId printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self div: [
		self anchorWithScript: onClick do: hideLink.
		self div: aBlock.
	]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:46'!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'avi 7/23/2004 18:26'!
ensureId
	^ (self attributes at: 'id' ifAbsentPut: ['id', self context advanceKey]) value! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 5/18/2004 13:41'!
fileUploadWithCallback: aBlock
	aBlock fixTemps.
	self
		inputWithType: 'file'
		named: (self callbacks registerCallback: [:f | aBlock value: (f = '' ifFalse: [f])])
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/3/2004 19:23'!
form: aBlock
	self
		formWithMethod: 'post'
		action: context actionUrl urlString
		do: [
			self div: [
				context actionUrl parameters keysAndValuesDo:
				[:k :v |
				self inputWithType: 'hidden' named: k value: v].
			aBlock value
		]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 4/2/2005 22:27'!
formWithDefaultAction: defaultBlock do: aBlock
	self form:
		[self
               inputWithType: 'hidden'
               named: (self callbacks registerDefaultActionCallback: defaultBlock). 
		self attributes value: ''; width: 1; size: 1.
		self submitButtonWithAction: defaultBlock image: self transparent1X1Form.
		aBlock value]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:51'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (self callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 3/22/2004 01:18'!
imageMapWithAction: aBlock form: aForm
	|point pointKey url |
	aBlock fixTemps.
	point _ ValueHolder new.
	pointKey _ self callbacks registerCallback:
								[:ptString |
								point contents: (self parseImageMap: ptString)].
	url _ self urlForAction: [aBlock value: point contents].
	
	self
		attributeAt: 'href'
		put: url, '&', pointKey, '='.
	self tag: 'a' do: [
		self attributeAt: 'border' put: 0; attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'mb 2/17/2005 17:57'!
imageWithDocument: anObject mimeType: mimeType fileName: fileName
	self image: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:04'!
imageWithForm: aForm
	self image: (self context urlForDocument: aForm) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:20'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context _ aRenderingContext.
	callbacks _ aCallbackStore.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 10/28/2004 00:53'!
label: aString input: aBlock
	| id |
	id _ 'id', self context advanceKey.
	self labelFor: id do:
		[self text: aString.
		self space.
		self cssId: id.
		aBlock value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'dc 8/11/2005 15:36'!
labelAfter: aString input: aBlock 
	| id |
	id := 'id' , self context advanceKey.
	self
		labelFor: id
		do: [self cssId: id.
			aBlock value.
			self space. self text: aString]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:42'!
labelForSelector: aSymbol of: anObject

	^ anObject labelForSelector: aSymbol! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:43'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject) column: 
		[self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:43'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self tableRowWithLabel: (anObject labelForSelector: aSymbol of: anObject) column: 
		[self
			selectFromList: aCollection
			selected: (anObject perform: aSymbol)
			callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:43'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject) column: 
		[self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:44'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol of: anObject) column: 
		[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
		self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/21/2004 00:03'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock).
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:03'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self context urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 6/13/2004 23:16'!
openSelect
	| name |
	name _ self callbacks registerDispatchCallback.
	self attributes at: 'name' put: name.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:50'!
optionGroupWithLabel: aString do: aBlock
	self attributes at: 'label' put: aString.
	self tag: 'optgroup' do: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/15/2005 00:49'!
optionWithLabel: aString callback: aBlock
	self optionWithLabel: aString selected: false callback: aBlock! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (self callbacks registerCallback: callbackBlock).
	
	self tag: 'option' do: labelString.! !

!WAHtmlRenderer methodsFor: 'canvas compatibility' stamp: 'avi 3/18/2005 21:56'!
painter: aComponent
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s _ aString readStream.
	s upTo: $?.
	x _ s upTo: $,.
	y _ s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 7/26/2004 12:53'!
parseNumber: aString
	^ [aString asNumber]
		on: Error
		do: [:e | aString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/2/2004 13:18'!
passwordInputWithCallback: callbackBlock
	self passwordInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 9/30/2004 21:50'!
passwordInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'password'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (self callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/22/2004 18:45'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
radioGroup
	^ self callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 19:48'!
registry
	^ WACurrentSession value application ! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ self context request! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:01'!
response
	^ self context response! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:30'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:54'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock
	self openSelect.
	callbackBlock fixTemps.

	aCollection do:
		[:item |
		self
			optionWithLabel: (labelsBlock value: item)
			selected: (item = selectedObject)
			callback: [callbackBlock value: item]].
	self closeTag: 'select'.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:58'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock nilLabel: aString
	self selectFromList: (Array with: nil), aCollection asArray
		selected: selectedObject
		callback: callbackBlock
		labels: [:ea | ea ifNil: [aString] ifNotNil: [labelsBlock value: ea]]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'ac 9/29/2005 11:00'!
spanWithShow: showLink hide: hideLink do: aBlock
	| linkId divId onClick |
	linkId _ self ensureId.
	divId _ self ensureId.
	onClick _ 'swapDisplay(', linkId printString, ', ', divId printString, '); return false;'.
	self attributes id: linkId; style: 'display: block'.
	self anchorWithScript: onClick do: showLink.
	self attributes id: divId; style: 'display: none'.
	self span: [
		self anchorWithScript: onClick do: hideLink.
		aBlock value.
	]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'mb 2/17/2005 10:44'!
submitButtonOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 2/7/2004 02:07'!
submitButtonWithAction: actionBlock do: aBlock
	self buttonWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
		value: nil
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 9/2/2004 14:43'!
submitButtonWithAction: actionBlock image: aForm
	self attributes
		src: (self context urlForDocument: aForm);
		width: aForm width;
		height: aForm height.
	self inputWithType: 'image'
		named: (self callbacks registerImageCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textAreaOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 7/21/2004 22:18'!
textAreaWithValue: value callback: callbackBlock
	|callback name |
	callback _ value
					ifNil: [[:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]]
					ifNotNil: [callbackBlock].
	name _ self callbacks registerCallback: callback.
	self attributes
		at: 'name' put: name;
		at: 'rows' ifAbsentPut: [3];
		at: 'cols' ifAbsentPut: [25].
	
	self tag: 'textarea' do: value.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'avi 10/22/2004 16:25'!
textInputOn: aSymbol of: anObject
	self
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:17'!
textInputWithValue: anObject callback: callbackBlock maxLength: aNumber
	self attributes
		at: 'size' put: aNumber;
		at: 'maxlength' put: aNumber.
	self textInputWithValue: anObject callback: callbackBlock.! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 3/13/2004 14:19'!
timeInputWithValue: aTime callback: aBlock
	| values |
	aBlock fixTemps.
	values _ Array new: 2.
	self
		textInputWithValue: aTime hour
		callback: [:hour | values at: 1 put: hour]
		maxLength: 2.
	self space; text: ':'; space.
	self
		textInputWithValue: aTime minutes asTwoCharacterString
		callback: [:minute | values at: 2 put: minute asNumber]
		maxLength: 2.
	self hiddenInputWithCallback:
		[aBlock value:
			(Time
				hour: values first
				minute: (values second min: 59)
				second: 0)]
		
	
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ac 3/5/2005 15:22'!
transparent1X1Form
	^ self class transparent1X1Form! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'mbany 4/14/2005 12:31'!
unorderedList: aCollection selected: anObject callback: aBlock
	self unorderedList: aCollection selected: anObject  callback: aBlock labels: [:ea | ea displayString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:31'!
unorderedList: aCollection selected: anObject callback: aBlock labels: labelBlock
	aBlock fixTemps.
	self cssClass: 'options'.
	self unorderedList: [
		aCollection do:
			[:ea |
			self cssClass: 'option'.
			ea = anObject ifTrue: [self cssId: 'option-selected'].
			self listItem: [self anchorWithAction: [aBlock value: ea] text: (labelBlock value: ea)]].
	]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:10'!
unorderedListOn: aSymbol of: anObject list: aCollection
	self
		unorderedList: aCollection
		selected: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/7/2005 13:12'!
urlForAction: actionBlock
	| url |
	url _ context actionUrl withParameter: (self callbacks registerActionCallback: actionBlock).
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'lr 6/8/2005 16:50'!
urlForAction: actionBlock andPath: aString
	| url |
	url _ context actionUrl withParameter:  (self callbacks 
		registerActionCallback: actionBlock).
	url addToPath: aString.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 5/22/2004 18:05'!
urlForDocument: anObject
	^ self context urlForDocument: anObject! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/27/2005 17:44'!
urlForIdempotentAction: actionBlock
	| url |
	url _ (context actionUrl
			withParameter:  (self callbacks registerActionCallback: actionBlock))
			withParameter: '_n'.
	^ url displayString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'mbany 4/14/2005 12:57'!
valueInputOfType: typeString value: anObject callback: callbackBlock
	|updateKey callback value|
	value _ anObject.
	callback _ callbackBlock.
	anObject isNumber ifTrue:
		[anObject isFraction
			ifTrue:
				[value _ anObject asFloat displayString.
				callback _ [:v | callbackBlock value:
									(v = value ifTrue: [anObject] ifFalse: [(self parseNumber: v)])]]
			ifFalse:
				[callback _ [:v | callbackBlock value: (self parseNumber: v)]]].
	anObject isNil ifTrue:
		[value _ ''.
		callback _ [:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]].
					
	updateKey _ self callbacks registerCallback: callback.
	self inputWithType: typeString named: updateKey value: value.
	^ updateKey
! !

Object subclass: #WABrush
	instanceVariableNames: 'parent canvas isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WABrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:18'!
close
	self isClosed ifFalse: [self with: []]! !

!WABrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:17'!
isClosed
	^ isClosed ifNil: [false]! !

!WABrush methodsFor: 'as yet unclassified' stamp: 'lr 9/14/2005 22:33'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol.! !

!WABrush methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent _ aBrush.
	canvas _ aCanvas! !

!WABrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:17'!
with: aBlock
	canvas nest: aBlock.
	isClosed _ true.! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url isNavigation callbackKey extraParameters promptString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 21:04'!
actionUrl
	| actionUrl |
	^ callbackKey ifNotNil:
		[actionUrl _ canvas context actionUrl withParameter: callbackKey.
		self isNavigation ifTrue: [actionUrl _ actionUrl withParameter: '_n'].
		extraParameters ifNotNil:
			[extraParameters associationsDo: [:k :v | actionUrl addParameter: k value: v]]. 
		actionUrl queryString]! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:26'!
callback: aBlock
	callbackKey _ canvas callbacks registerActionCallback: aBlock! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:36'!
extraParameters: aCollection
	extraParameters _ aCollection! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 10/5/2005 00:13'!
handlerForForm: aString
	^ promptString
		ifNil: ['submitFormTriggeringCallback(' , aString printString, ', ' , callbackKey displayString printString, ');']
		ifNotNil: ['if(x = prompt(', promptString printString, ')) submitFormTriggeringCallback(', aString printString, ', ' , callbackKey displayString printString, ', x);']! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 21:05'!
isNavigation
	^ isNavigation ifNil: [false]! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 10/30/2005 00:50'!
mailto: aString
	self url: 'mailto:', aString.
	self text: aString! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 20:50'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:30'!
navigation
	isNavigation _ true! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2005 22:10'!
newTarget
	self target: '_new'! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'lr 9/14/2005 23:51'!
on: aSymbol of: anObject
	self callback: [ anObject perform: aSymbol ].
	self with: (self labelForSelector: aSymbol of: anObject).! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 10:17'!
onClick: aString
	super onClick: aString.
	self attributes at: 'href' ifAbsentPut: 'javascript:void(0)'! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/4/2005 00:41'!
onMouseover: aString
	super onMouseover: aString.
	self attributes at: 'href' ifAbsentPut: 'javascript:void(0)'! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 10/5/2005 15:21'!
prompt: aString callback: aBlock
	callbackKey _ canvas callbacks registerCallback: aBlock.
	promptString _ aString.! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 14:46'!
submitFormNamed: aString
	self onClick: (self handlerForForm: aString)! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:56'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2005 22:10'!
target: aString
	self attributeAt: 'target' put: aString! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 3/16/2005 14:28'!
text: aString
	self with: aString.! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 3/20/2005 01:23'!
title: aString
	self attributeAt: 'title' put: aString.! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 15:51'!
toggleStringFor: aCollection
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea | stream nextPutAll: ea displayString, '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:26'!
url: aString
	url _ aString! !

!WAAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:32'!
with: aBlock
	self attributes at: 'href' ifAbsentPut: [url ifNil: [self actionUrl]].
	^ super with: aBlock! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name extent dependent showToolbar resizable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/8/2005 19:15'!
beDependent
	dependent _ true! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 9/11/2005 13:08'!
beResizable
	resizable _ true! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/3/2005 16:08'!
extent: aPoint
	extent _ aPoint! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/8/2005 19:15'!
isDependent
	^ dependent ifNil: [false]! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 9/11/2005 13:07'!
isResizable
	^ resizable ifNil: [resizable _ false]! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/3/2005 16:07'!
name: aString
	name _ aString! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 16:32'!
popupString
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: (url ifNil: [self actionUrl]);
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: name;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: extent x displayString;
			nextPutAll: ',height=';
			nextPutAll: extent y displayString;
			nextPut: $,;
			nextPutAll: self toggleString;
			nextPut: $';
			nextPutAll: ')']! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 9/11/2005 13:05'!
shouldShowToolbar
	^ showToolbar ifNil: [showToolbar _ false]! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 9/11/2005 13:04'!
showToolbar
	showToolbar _ true! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 9/11/2005 13:10'!
toggleArray
	^ Array streamContents:
		[:stream |
		self isDependent ifTrue: [stream nextPut: #dependent].
		self shouldShowToolbar ifTrue: [stream nextPut: #toolbar].
		self isResizable ifTrue: [stream nextPut: #resizable]]! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/8/2005 19:21'!
toggleString
	^ String streamContents:
		[:stream | 
		self toggleArray 
			do: [:ea | stream nextPutAll: ea, '=yes'] 
			separatedBy: [stream nextPutAll: ',']]! !

!WAPopupAnchorTag methodsFor: 'as yet unclassified' stamp: 'ac 7/3/2005 15:48'!
with: aBlock
	self onClick: self popupString.
	^ super with: aBlock.! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelsBlock multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:31'!
add: anObject
	^ list add: anObject.! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:32'!
addAll: aCollection
	^ list addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 13:44'!
beMultiple
	multiple := true.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 9/25/2005 11:34'!
callback: aBlock
	callbackBlock := aBlock fixTemps.! !

!WACollectionTag methodsFor: 'initialization' stamp: 'lr 9/25/2005 11:39'!
initialize
	super initialize.
	list := OrderedCollection new.
	labelsBlock := [ :value | value ].
! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 9/26/2005 13:44'!
isMultiple
	^ multiple ifNil: [ false ].! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 9/26/2005 14:48'!
isSelected: anObject
	^ self isMultiple
		ifTrue: [ selected includes: anObject ]
		ifFalse: [ selected = anObject ].! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 9/25/2005 11:40'!
labelForOption: anObject
	^ labelsBlock value: anObject.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 9/25/2005 11:35'!
labels: aBlock
	labelsBlock := aBlock fixTemps.! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:34'!
list: aCollection
	self addAll: aCollection.! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 9/26/2005 14:50'!
selected: anObject
	selected := anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beOrdered
	tag := 'ol'.! !

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beUnordered
	tag := 'ul'.! !

!WAListTag methodsFor: 'private' stamp: 'lr 9/26/2005 15:18'!
callbackForOption: anObject
	self isMultiple 
		ifTrue: [ 
			selected := (self isSelected: anObject)
				ifTrue: [ selected copyWithout: anObject ]
				ifFalse: [ selected copyWith: anObject ].
			callbackBlock value: selected ]
		ifFalse: [ callbackBlock value: anObject ].! !

!WAListTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:37'!
tag
	^ tag ifNil: [ 'ul' ].! !

!WAListTag methodsFor: 'public' stamp: 'lr 9/26/2005 15:17'!
with: aBlock
	super with: [
		list do: [ :each |
			canvas listItem 
				class: ((self isSelected: each)
					ifFalse: [ 'option' ]
					ifTrue: [ 'option-selected' ]);
				with: [
					callbackBlock isNil
						ifTrue: [ canvas render: (self labelForOption: each) ]
						ifFalse: [
							canvas anchor
								callback: [ self callbackForOption: each ];
								with: (self labelForOption: each) ] ] ].
		aBlock value ].! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'isOptional optionalLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WASelectTag methodsFor: 'attributes' stamp: 'ac 4/13/2005 12:38'!
beOptional
	isOptional _ true! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 1/8/2006 01:17'!
beSubmitOnChange
	self onChange: 'submit()'! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/13/2005 13:05'!
hasOther
	^ otherLabel notNil! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/13/2005 12:39'!
isOptional
	^ isOptional ifNil: [false]! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/15/2005 01:45'!
isSubmitOnChange
	^ isSubmitOnChange ifNil: [false]! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 20:27'!
numberOfOptions
	| count |
	count _ 0.
	self isOptional ifTrue: [count _ count + 1].
	count _ count + list size.
	self hasOther ifTrue: [count _ count + 1].
	^ count! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 1/8/2006 01:16'!
onChange: aString
	self attributes at: 'onchange' append: aString separator: ';'! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 8/30/2005 13:27'!
optionalLabel: aString
	optionalLabel _ aString! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 1/8/2006 01:39'!
optionsOn: html
	self isOptional ifTrue: 
		[html option 
			selected: (selected = nil); 
			callback: [callbackBlock value: nil];
			with: optionalLabel].

	list do: 
		[:each | 
		html option 
			selected: (self isSelected: each); 
			callback: [ self isMultiple
				ifTrue: [ selected add: each ]
				ifFalse: [ callbackBlock value: each ] ];
			with: (self labelForOption: each)]! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 1/8/2006 01:29'!
otherLabel: labelString otherCallback: aBlock promptString: aString
	| other hidden value |
	other := (canvas context nextKey asNumber + self numberOfOptions + 2) displayString.
	hidden := canvas context nextKey asString.
	value := ValueHolder new.
	canvas insert:
		[canvas hiddenInput id: hidden; value: nil; callback: [:n | value contents: n]; with: []].
	self onChange: 'if(this.value == ', other printString, ') {chooseOther(this, ', hidden printString, ', ', aString printString, ')};'.
	self with:
		[canvas option 
			callback: [aBlock value: value contents];
			with: labelString]! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 09:55'!
size: anInteger
	self attributes at: 'size' put: anInteger.! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 1/8/2006 01:39'!
with: aBlock
	self attributes 
		at: 'name' put: (self isMultiple
			ifTrue: [ canvas callbacks registerMultiDispatchCallback ]
			ifFalse: [ canvas callbacks registerDispatchCallback ]);
		at: 'multiple' put: self isMultiple.
	super with: [self optionsOn: canvas. aBlock value].

	self isMultiple ifTrue: [
		selected := OrderedCollection new.
		canvas hiddenInput 
			callback: [ callbackBlock value: selected ];
			with: [] ].! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WADivTag methodsFor: 'as yet unclassified' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'as yet unclassified' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WACheckboxTag methodsFor: 'private' stamp: 'avi 4/28/2005 14:16'!
after
	canvas hiddenInput callback:
		[callback value: value.
		value _ false]! !

!WACheckboxTag methodsFor: 'callbacks' stamp: 'avi 4/28/2005 14:17'!
callback: aBlock
	value _ false.
	callback _ aBlock fixTemps.
	super callback: [value _ true]! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 11/11/2005 13:59'!
onTrue: trueBlock onFalse: falseBlock
	trueBlock fixTemps. falseBlock fixTemps.
	self callback: [ :v | v ifTrue: [ trueBlock value ] ifFalse: [ falseBlock value ] ].! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:47'!
value: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 9/23/2005 13:45'!
callback: aBlock
	aBlock fixTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ].! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/19/2005 00:13'!
on: selector of: anObject
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 9/26/2005 12:47'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:41'!
name: aString
	self attributes at: 'name' put: aString.! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'lr 9/23/2005 13:41'!
on: selector of: anObject
	self value: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 17:43'!
readonly: aBoolean
	self attributes at: 'readonly' put: aBoolean.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:44'!
submitOnClick
	self onClick: 'submit()'.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
tabindex: anInteger
	self attributes at: 'tabindex' put: anInteger.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
text: aString
	self value: aString.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
type: aString
	self attributes at: 'type' put: aString.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ].! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 9/23/2005 14:10'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock.! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:39'!
beChecked
	self attributeAt: 'checked' put: true.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:40'!
beUnchecked
	self attributeAt: 'checked' put: false.! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'ac 7/6/2005 11:24'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:32'!
group: aRadioGroup
	self name: aRadioGroup key.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:01'!
selected: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WASubmitButtonTag subclass: #WAButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:37'!
type
	^ 'button'! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
extent: aPoint
	self width: aPoint x; height: aPoint y.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:04'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm).! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 14:35'!
height: aNumber
	self attributes at: 'height' put: aNumber.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:03'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString).! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
url: aString
	self attributes at: 'src' put: aString.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 14:35'!
width: aNumber
	self attributes at: 'width' put: aNumber.! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 9/23/2005 14:51'!
callback: aBlock
	self attributes at: 'name' ifAbsentPut: (canvas callbacks registerActionCallback: aBlock).
	
! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'lr 9/23/2005 14:53'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: [ anObject perform: aSymbol ].! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

WAFormInputTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATextAreaTag methodsFor: 'as yet unclassified' stamp: 'ac 3/22/2005 17:49'!
columns: anInteger
	self attributeAt: 'cols' put: anInteger.! !

!WATextAreaTag methodsFor: 'as yet unclassified' stamp: 'ac 3/22/2005 17:50'!
rows: anInteger
	self attributeAt: 'rows' put: anInteger.! !

!WATextAreaTag methodsFor: 'as yet unclassified' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'as yet unclassified' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value _ aString! !

!WATextAreaTag methodsFor: 'as yet unclassified' stamp: 'ac 8/30/2005 16:29'!
with: aBlock
	^ value ifNotNil: [super with: value] ifNil: [super with: aBlock]! !

WAFormInputTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beRangeInput
	self type: 'range'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beSearchInput
	self type: 'search'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'ac 11/2/2005 18:06'!
disableEnter
	self onEnter: ''.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 7/10/2005 22:15'!
exampleText: aString
	self attributes at: 'value' ifAbsent:
		[self attributes
			at: 'onfocus' put: 'value=''''; style.color=''black''';
			at: 'style' put: 'color: #aaa';
			at: 'value' put: aString]! !

!WATextInputTag methodsFor: 'attributes' stamp: 'ac 11/30/2005 12:22'!
onEnter: aString
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){', aString displayString, '; return false}; return true'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 9/29/2005 00:09'!
onKeyPress: anObject
	self attributeAt: 'onkeypress' put: anObject! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 11/7/2005 14:09'!
size: aNumber
	self attributeAt: 'size' put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAFormTag methodsFor: 'private' stamp: 'avi 11/4/2005 12:21'!
after
	canvas context actionUrl parameters keysAndValuesDo:
		[:k :v |
		canvas hiddenInput name: k; value: v.
		canvas text: ' ']! !

!WAFormTag methodsFor: 'private' stamp: 'lr 9/23/2005 14:57'!
before
	defaultAction ifNotNil: [
		canvas imageButton
			form: WAHtmlRenderer transparent1X1Form;
			callback: defaultAction;
			value: 'default';
			with: nil ].! !

!WAFormTag methodsFor: 'attributes' stamp: 'ac 4/13/2005 00:02'!
defaultAction: aBlock
	defaultAction _ aBlock.! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/8/2005 21:46'!
multipart
	self attributeAt: 'enctype' put: 'multipart/form-data'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:37'!
multipart: aBoolean
	aBoolean ifTrue: [ self multipart ].! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/9/2005 16:02'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 12:54'!
post
	self attributes method: 'post'! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'avi 10/6/2005 10:01'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post! !

!WAFormTag methodsFor: 'private' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAGenericTag class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:53'!
tag: aString
	^ self basicNew initializeWithTag: aString! !

!WAGenericTag methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag _ aString! !

!WAGenericTag methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAHeadingTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 14:12'!
level
	^ level ifNil: [1]! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level1
	level _ 1.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level2
	level _ 2.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level3
	level _ 3.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level4
	level _ 4.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:33'!
level: anInteger
	level := anInteger! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'avi 5/10/2005 14:33'!
tag
	^ 'h', self level displayString ! !

WATagBrush subclass: #WAImageTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:33'!
altText: aString
	self attributes at: 'alt' put: aString
! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:56'!
border: aNumber
	self attributeAt: 'border' put: aNumber! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:55'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'gk 1/10/2006 11:16'!
fileName: aFileName
	"Create a document handler for the file contents and insert
	a URL for it. The document will be served binary and with
	a non expiring cache. The mimeType will be guessed by
	WACachedDocument using the filename extension."

	^self fileName: aFileName mimeType: nil! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'gk 1/10/2006 11:15'!
fileName: aFileName mimeType: mimeString
	"Create a document handler for the file contents and insert
	a URL for it. The document will be served binary and with
	a non expiring cache. If <mimeString> is nil it will be
	guessed by WACachedDocument using the filename extension."

	| doc |
	doc _ WACachedDocument fileName: aFileName.
	mimeString ifNotNil: [doc mimeType: mimeString].
	^self url: (canvas context
				urlForDocument: doc
				mimeType: mimeString
				fileName: aFileName)! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'lr 9/14/2005 22:04'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm).! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'pmm 12/23/2005 16:25'!
height: aNumber
	self attributeAt: 'height' put: aNumber displayString! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:56'!
noBorder
	self border: 0! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:33'!
url: aString
	self attributes at: 'src' put: aString
! !

!WAImageTag methodsFor: 'as yet unclassified' stamp: 'pmm 12/23/2005 16:26'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WALabelTag methodsFor: 'attributes' stamp: 'ac 7/9/2005 04:36'!
for: aString
	self attributeAt: 'for' put: aString.! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:53'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:13'!
selected: aBoolean
	self attributeAt: 'selected' put: aBoolean.! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WAScriptTag methodsFor: 'as yet unclassified' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'as yet unclassified' stamp: 'avi 10/6/2005 11:24'!
with: aBlock
	isClosed := true.
	self attributes at: 'type' ifAbsentPut: 'text/javascript'.
	self document openTag: self tag attributes: attributes.
	canvas html: aBlock.
	self document closeTag: self tag.! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
align: aString
	self attributes at: 'align' put: aString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
colSpan: anInteger
	self attributes at: 'colspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
rowSpan: anInteger
	self attributes at: 'rowspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:09'!
verticalAlign: aString
	self attributes at: 'valign' put: aString.! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableCellTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas-Tags'!

!WATableTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 15:22'!
layout
	self attributes
		border: 0;
		cellspacing: 0;
		cellpadding: 0.! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 3/17/2005 18:18'!
after! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:40'!
attributeAt: key put: value
	self attributes at: key put: value! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:03'!
attributes
	^ attributes ifNil: [attributes _ WAHtmlAttributes new]! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 14:15'!
attributes: anHtmlAttributes
	attributes _ anHtmlAttributes
! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 3/17/2005 18:18'!
before! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 01:49'!
class: aString
	self attributes addClass: aString! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 10/16/2005 19:55'!
disabled
	self disabled: true.! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 10/16/2005 19:55'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean.! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'dwj 6/9/2005 16:18'!
ensureId
	^ (self attributes at: 'id' ifAbsentPut: ['id', canvas context advanceKey]) value! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 3/16/2005 11:51'!
id: aString
	self attributeAt: 'id' put: aString! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 10/5/2005 00:16'!
ignoreURL
	^ self onClick: 'return false'! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 10:16'!
onClick: aString
	self attributes at: 'onclick' append: aString separator: '; '! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 7/29/2005 17:49'!
onMouseout: aString
	self attributes at: 'onmouseout' put: aString.! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 11/5/2005 19:33'!
onMouseover: aString
	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 3/18/2005 22:10'!
section: aSymbol
	self class: (canvas painter classForSection: aSymbol).
	self with: [canvas painter perform: aSymbol with: canvas]! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:40'!
style: aString
	self attributeAt: 'style' put: aString! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'lr 9/23/2005 13:51'!
tooltip: aString
	aString ifNotNil: [ self attributeAt: 'title' put: aString ].! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 4/13/2005 00:28'!
with: aBlock
	self document openTag: self tag attributes: attributes.
	super with: [self within: aBlock].
	self document closeTag: self tag.! !

!WATagBrush methodsFor: 'as yet unclassified' stamp: 'ac 4/13/2005 00:44'!
within: aBlock
	self before.
	aBlock renderOn: canvas.
	self after.! !

Object subclass: #WACachedDocument
	instanceVariableNames: 'fullFileName mimeDocument mimeType'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WACachedDocument commentStamp: '<historical>' prior: 0!
This class is for serving smallish files like PNG images etc using WADocumentHandler. Using the Canvas API for HTML generation you simply do this:

	html image fileName: 'myimage.png'

or:

	html image fileName: 'myimage.blurp' mimeType: 'blurp'

This will create a request handler in your WAApplication registry that is accessible on a unique URL and does not expire.
The actual contents of the file will only be read upon first access, we could augment this class with smarter caching, like checking the modification time on disk.

The class has a Cache class var holding a Dictionary of created instances so you can clear and preload files into the image using:

	WACachedDocument
		clearCache;
		fileName: 'myimage.png';
		fileName: 'another.gif'; "etc"
		preloadCache!

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:15'!
clearCache
	"Clear the cache of instances. This will cause
	the files to be lazily reread from disk."

	Cache _ Dictionary new! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/12/2006 14:17'!
fileName: aFileName
	"Check the cache to see if we already have this file loaded.
	We only rely on the local filename!!"

	^Cache at: aFileName ifAbsentPut: [self fullFileName: aFileName]! !

!WACachedDocument class methodsFor: 'instance-creation' stamp: 'gk 1/10/2006 13:22'!
fullFileName: fullFileName

	^self new fullFileName: fullFileName! !

!WACachedDocument class methodsFor: 'initialize-release' stamp: 'gk 1/12/2006 14:05'!
initialize
	self clearCache! !

!WACachedDocument class methodsFor: 'cache' stamp: 'gk 1/19/2006 08:14'!
preloadCache
	"Load the files into the image for the currently
	created instances in the Cache."

	Cache valuesDo: [:d | d asMIMEDocument ]! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:13'!
= other
	"Currently we do not take file modification time on disk into account."

	^other species = self species and: [other fullFileName = fullFileName]! !

!WACachedDocument methodsFor: 'public' stamp: 'gk 1/11/2006 10:48'!
asMIMEDocument
	"Lazy caching."

	| content |
	mimeDocument ifNil: [
		mimeType ifNil:  [mimeType _ MIMEDocument guessTypeFromExtension: (FileDirectory extensionFor: fullFileName)].
		content _ (StandardFileStream readOnlyFileNamed: fullFileName) contentsOfEntireFile.
		mimeDocument _ MIMEDocument contentType: mimeType content: content].
	^mimeDocument
	! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:19'!
fullFileName
	^fullFileName! !

!WACachedDocument methodsFor: 'initialize-release' stamp: 'gk 1/10/2006 11:12'!
fullFileName: aFileName
	fullFileName _ aFileName
	! !

!WACachedDocument methodsFor: 'comparing' stamp: 'gk 1/10/2006 13:14'!
hash
	"Currently we do not take file modification time on disk into account.
	Note that mimeType and mimeDocument are set lazily later, so we can't use
	the mimeType in the hash."

	^fullFileName hash! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:18'!
mimeType
	^mimeType! !

!WACachedDocument methodsFor: 'accessing' stamp: 'gk 1/10/2006 11:14'!
mimeType: anObject
	^mimeType := anObject! !

Object subclass: #WACallback
	instanceVariableNames: 'context owner key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:05'!
block: aZeroArgBlock
	block _ aZeroArgBlock fixTemps.! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:51'!
evaluateWithArgument: anObject
	block value.
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
isFinal
	^ true! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 8! !

!WAActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:52'!
signalRenderNotification 
	WARenderNotification new raiseSignal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACancelActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 3! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADefaultActionCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAImageCallback methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString, '.x'! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:38'!
<= other
	^ self priority < other priority or: [self priority = other priority and: [self key asNumber <= other key asNumber]]! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:48'!
context
	^ context! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:49'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:52'!
evaluateWithField: anObject 
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:46'!
key
	^ (self convertKey: key)! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:48'!
owner
	^ owner! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:17'!
priority
	self subclassResponsibility ! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:39'!
setContext: aRenderingContext owner: anObject key: aString
	context _ aRenderingContext.
	owner _ anObject.
	key _ aString! !

!WACallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 21:51'!
valueForField: anObject
	^ anObject
		ifNil: ['']
		ifNotNil:
			[(anObject isCollection and: [anObject isString not])
					ifTrue: [anObject isEmpty
								ifTrue: ['']
								ifFalse: [anObject first]]
					ifFalse: [anObject]]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:07'!
evaluateWithArgument: anObject
	(context callbackAt: anObject) evaluateWithArgument: nil! !

!WADispatchCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:42'!
priority
	^ 5! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAMultiDispatchCallback methodsFor: 'as yet unclassified' stamp: 'lr 10/10/2005 19:56'!
evaluateWithField: anObject
	(anObject isCollection and: [ anObject isString not ]) 
		ifFalse: [ ^ super evaluateWithField: anObject ].
	anObject do: [ :each | 
		self evaluateWithArgument: (self valueForField: each) ].! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:06'!
block: aOneArgBlock
	block _ aOneArgBlock fixTemps! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:17'!
evaluateWithArgument: anObject
	block valueWithPossibleArgs: (Array with: anObject)! !

!WAValueCallback methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
priority
	^ 5! !

Object subclass: #WACallbackRegistry
	instanceVariableNames: 'context owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackRegistry class methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:04'!
context: aContext owner: anObject
	^ self basicNew initializeWithContext: aContext owner: anObject! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:04'!
initializeWithContext: aContext owner: anObject
	context _ aContext.
	owner _ anObject! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerActionCallback: aBlock
	^ self storeCallback: (WAActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerCallback: aBlock
	^ self storeCallback: (WAValueCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
registerCancelActionCallback: aBlock
	^ self storeCallback: (WACancelActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:41'!
registerDefaultActionCallback: aBlock
	^ self storeCallback: (WADefaultActionCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:10'!
registerDispatchCallback
	^ self storeCallback: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:42'!
registerImageCallback: aBlock
	^ self storeCallback: (WAImageCallback new block: aBlock)! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'lr 10/10/2005 20:00'!
registerMultiDispatchCallback
	^ self storeCallback: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2004 22:43'!
storeCallback: aCallback
	| key |
	key _ context storeCallback: aCallback.
	aCallback setContext: context owner: owner key: key.
	^ key
! !

Object subclass: #WACallbackStream
	instanceVariableNames: 'callbacks request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackStream class methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:58'!
callbacks: aDictionary request: aRequest
	^ self basicNew initializeWithCallbacks: aDictionary request: aRequest! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:59'!
atEnd
	^ callbacks atEnd! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'lr 9/26/2005 14:10'!
initializeWithCallbacks: aDictionary request: aRequest
	| collection |
	collection := SortedCollection new.
	aRequest fields keys do:
		[:ea |
		aDictionary at: ea ifPresent: [:callback | collection add: callback]].
	callbacks := ReadStream on: collection asArray.
	request := aRequest! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 01:59'!
position
	^ callbacks position! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'avi 6/12/2004 00:21'!
processCallbacksWithOwner: anObject
	| callback |
	[callbacks atEnd not and: [callbacks peek owner == anObject]] whileTrue:
		[callback _ callbacks next.
		callback evaluateWithField: (request fields at: callback key)]! !

!WACallbackStream methodsFor: 'as yet unclassified' stamp: 'avi 6/12/2004 00:25'!
upToEnd
	^ callbacks upToEnd! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush painter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush _ aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush _ nil]! !

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 23:19'!
insert: aBlock
	| oldBrush |
	oldBrush _ currentBrush.
	currentBrush _ nil.
	aBlock value.
	currentBrush _ oldBrush! !

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:37'!
nest: aBlock
	parentBrush _ currentBrush.
	currentBrush _ nil.
	aBlock renderOn: self.
	self flush.
	parentBrush _ parentBrush parent.
! !

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 3/18/2005 21:56'!
painter
	^ painter! !

!WACanvas methodsFor: 'as yet unclassified' stamp: 'avi 3/18/2005 21:56'!
painter: anObject
	painter _ anObject! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:31'!
generateBinaryFor: aCollection
	(aCollection size = 3 and: [(self includesSelector: aCollection third) not]) ifTrue:
		[self 
			compile: aCollection third, ' aBlock
	self ', aCollection second, ' with: aBlock'
			classified: self generatedCategory].
! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:32'!
generateTags
	"WAHtmlCanvas generateTags"
	self tags do:
		[:spec |
		self generateUnaryFor: spec.
		self generateBinaryFor: spec].! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:29'!
generateUnaryFor: aCollection
	(self includesSelector: aCollection second) ifFalse:
		[self 
			compile: aCollection second, '
	^ self ', (self patternFor: aCollection first)
			classified: self generatedCategory]! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:30'!
generatedCategory
	^ 'html-generated'! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 10:57'!
patternFor: aString
	WATagBrush allSubclassesDo: [:ea | ea new tag = aString ifTrue: [^ 'brush: ', ea name, ' new']].
	^ 'tag: ', aString printString! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 3/24/2005 22:49'!
tags
	"
	self generateTags
	"

	^ #(
		('a' anchor)
		
		('p' paragraph paragraph:)
		('div' div div:)
		('span' span span:)

		('blockquote' blockquote blockquote:)
		
		('code' code code:)
		('pre' preformatted preformatted:)
		('b' bold bold:)
		('i' italic italic:)
		('small' small small:)
		('label' label label:)
						
		('ul' unorderedList unorderedList:)
		('li' listItem listItem:)
		
		('br' break)
		('hr' horizontalRule)
		
		('form' form form:)
		
		('table' table table:)
		('tr' tableRow tableRow:)
		('td' tableData tableData:)
		('tbody' tableBody tableBody:)
		('thead' tableHead tableHead:)
		('tfoot' tableFoot tableFoot:)
		
		('script' script script:)
		)! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:43'!
address
	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'dwj 6/11/2005 06:04'!
anchor
	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote
	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
bold
	^ self tag: 'b'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
bold: aBlock
	self bold with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
break
	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code
	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:43'!
definitionDefinition
	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:43'!
definitionDefinition: aBlock
	self definitionDefinition with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:39'!
definitionList
	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm
	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div
	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mb 1/5/2006 18:27'!
encode: anObject
	"This is needed by the SeasideAsync package"
	^WAAbstractHtmlBuilder encode: anObject! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 1/9/2006 21:56'!
form
	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 14:14'!
heading
	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 12/24/2005 17:38'!
heading: aBlock level: aNumber
	self heading
		level: aNumber;
		with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
horizontalRule
	^ self tag: 'hr'! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
html: aString
	self flush.
	self document text: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 12:01'!
image
	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 11:53'!
image: aBlock
	^ self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/14/2005 22:22'!
imageForm: aForm
	self image form: aForm.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
italic
	^ self tag: 'i'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
italic: aBlock
	self italic with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 7/9/2005 04:37'!
label
	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem
	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:52'!
orderedList
	^ self brush: WAListTag new beOrdered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph
	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted
	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'dwj 6/10/2005 13:11'!
script
	^ self brush: WAScriptTag new.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small
	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 6/17/2004 15:07'!
space
	self html: '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span
	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong
	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:05'!
submitButton
	^ self brush: WASubmitButtonTag new.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table
	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody
	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData
	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot
	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot: aBlock
	self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead
	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/17/2005 22:10'!
tableHeading
	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow
	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 12:19'!
tag: aString
	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mb 1/5/2006 18:26'!
text: anObject
	self html: (self encode: anObject)! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:07'!
textInput
	^ self brush: WATextInputTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:51'!
unorderedList
	^ self brush: WAListTag new beUnordered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARenderCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/23/2005 18:07'!
button
	^ self brush: WAButtonTag new.! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:01'!
callbacks
	^ callbacks! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 4/28/2005 14:01'!
checkbox
	^ self brush: WACheckboxTag new	! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 11:56'!
close
	self flush.! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:01'!
context
	^ context! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:08'!
document
	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 6/8/2005 21:49'!
fileUpload
	^ self brush: WAFileUploadTag new	! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 1/9/2006 21:52'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
hiddenInput
	^ self brush: WAHiddenInputTag new.! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/14/2005 22:01'!
imageButton
	^ self brush: WAImageButtonTag new.! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context _ aRenderingContext.
	callbacks _ aCallbackStore! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:13'!
option
	^ self brush: WAOptionTag new.! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
passwordInput
	^ self brush: WAPasswordInputTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:45'!
radioButton
	^ self brush: WARadioButtonTag new.! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 14:00'!
render: anObject
	self flush.
	anObject renderOn: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:15'!
select
	^ self brush: WASelectTag new	! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'dwj 6/11/2005 07:07'!
textInput
	^ self brush: WATextInputTag new! !

WAHtmlCanvas subclass: #WAStaticHtmlCanvas
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WAStaticHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:20'!
document: aDocument
	^ self basicNew initializeWithDocument: aDocument! !

!WAStaticHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:28'!
root: anHtmlRoot
	^ self document: (WAHtmlStreamDocument root: anHtmlRoot)! !

!WAStaticHtmlCanvas methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:20'!
document
	^ document! !

!WAStaticHtmlCanvas methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:20'!
initializeWithDocument: aDocument
	document _ aDocument! !

Object subclass: #WAConditionalComment
	instanceVariableNames: 'isStart condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAConditionalComment methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 09:05'!
end: aString
	isStart _ false.
	condition _ aString! !

!WAConditionalComment methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 09:05'!
start: aString
	isStart _ true.
	condition _ aString! !

!WAConditionalComment methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 09:06'!
writeOn: aStream
	aStream nextPutAll: '<!!'.
	isStart ifTrue: [aStream nextPutAll: '--'].
	aStream nextPut: $[; nextPutAll: condition; nextPut: $].
	isStart ifFalse: [aStream nextPutAll: '--'].
	aStream nextPut: $>! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:46'!
readUserConfigurationsFrom: aStream
	| ini |
	ini _ INIFile readFrom: aStream.
	self registeredConfigurationsDo:
		[:config |
		(ini includesSection: config name) ifTrue:
			[config clear.
			(ini section: config name) associationsDo:
				[:assoc | assoc value ifNotNil:
					[(config hasAttributeNamed: assoc key)
						ifTrue: [config valueAt: assoc key put: assoc value]]]]]! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:20'!
writeUserConfigurationsOn: aStream
	| ini |
	ini _ INIFile new.
	self registry keysAndValuesDo:
		[:key :value | (ini section: key) addAll: value localValues].
	ini writeOn: aStream! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp _ OrderedCollection new.
	linear _ OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict _ Dictionary new.
	sorted _ SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:32'!
ancestors
	^ Array with: (WARenderLoopConfiguration new)! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 13:00'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol group: #server) options: #(http https))
		with: (WAStringAttribute key: #serverHostname group: #server)
		with: (WANumberAttribute key: #serverPort group: #server)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 18:20'!
deploymentMode
	^ false! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: (WASessionConfiguration new)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:30'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)
		with: (WAStringAttribute key: #resourceBaseUrl group: #server)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
ancestors
	^ Array with: WAGlobalConfiguration new! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:57'!
attributes
	^ Array
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)
		with: (WABooleanAttribute key: #useSessionCookie)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/12/2005 21:42'!
useSessionCookie
	^ false! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
instance
	^ instance ifNil: [instance _ self basicNew]! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
new
	^ self instance! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:31'!
name
	^ self class name! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'values ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAUserConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 11/17/2005 00:27'!
initialize
	self allInstances do: [:ea | ea instVarNamed: 'ancestors' put: (ea ancestors collect: [:c  | [c instVarNamed: 'parent'] ifError: [c]])] 
	! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
allPotentialAncestors
	^ WASystemConfiguration allSubclasses collect: [:ea | ea new]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clear
	values _ Dictionary new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
initialize
	super initialize.
	values _ Dictionary new.
	ancestors _ OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict _ Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:39'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key _ keySymbol.
	group _ groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:28'!
stringForValue: anObject
	^ anObject displayString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options _ aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:29'!
valueFromString: aString
	^ self options
		detect: [:ea | ea displayString = aString]
		ifNone: [self error: 'No matching list option']! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:09'!
valueFromString: aString
	^ aString! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WACookie class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:59'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:13'!
expireIn: aDuration
	self expiry: DateAndTime now + aDuration! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:12'!
expiry: aDateTime
	expiry _ aDateTime asUTC! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:18'!
expiryString
	^ String streamContents:
		[:s |
		s
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth displayString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year displayString;
			space;
			nextPutAll: expiry hour24 displayString;
			nextPut: $:;
			nextPutAll: expiry minute displayString; 
			nextPut: $:;
			nextPutAll: expiry second displayString;
			nextPutAll: ' GMT']! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
key
	^ key! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
key: aString
	key _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
path
	^ path ifNil: ['/']! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
path: aString
	path _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
value
	^ value! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
value: aString
	value _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:05'!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [self value, '; expires=', self expiryString]! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleError: anError
	anError pass! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASimpleErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
handleError: anError
	WACurrentSession value returnResponse: (WAResponse internalError: anError)! !

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 10/9/2005 23:45'!
handleError: anError
	| process |
	WARenderLoop new call: (WAWalkback new exception: anError) withToolFrame: false.
	process := Processor activeProcess.
	WorldState addDeferredUIMessage:
		[process debug: anError signalerContext  title: anError description full: true ].
	process suspend! !

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:07'!
handleWarning: aWarning
	WARenderLoop new call: (WAFormDialog new addMessage: aWarning messageText).
	aWarning resume.! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAFile methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:13'!
contentType: aString
	contentType _ aString! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents
	^ contents! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents: aStream
	contents _ aStream! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName: aString
	fileName _ aString! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 9/30/2005 19:17'!
addClass: aString
	aString ifNotNil: [ self at: 'class' append: aString ].! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:17'!
alignBottom
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'ab 5/12/2003 22:08'!
alignCenter
	self at: 'align' put: 'center'! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:55'!
associations
	^ self attributes associations! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 9/10/2005 16:02'!
at: keyString
	^ (self at: keyString ifAbsent: [keyString -> nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 18:11'!
at: keyString append: aString
	^ self at: keyString append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:52'!
at: keyString append: aString separator: separatorString
	^ self at: keyString put: 
		(String streamContents:
			[:stream |
			self at: keyString ifPresent: 
				[:s | stream nextPutAll: s; nextPutAll: separatorString].
			stream nextPutAll: aString displayString])! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 3/16/2005 11:49'!
at: keyString ifAbsent: aBlock
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: aBlock! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 6/22/2005 01:57'!
at: keyString ifAbsentPut: errBlock
	^ self at: keyString ifAbsent: [self attributes add: keyString -> errBlock value]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 17:50'!
at: keyString ifPresent: aBlock
	^ aBlock value: (self at: keyString ifAbsent: [^ nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 6/22/2005 01:48'!
at: keyString put: valueString
	self attributes at: keyString put: valueString! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:49'!
attributes
	^ attributes ifNil: [attributes _ Dictionary new]! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'copying' stamp: 'lr 11/8/2005 21:58'!
postCopy
	super postCopy.
	attributes := attributes copy.! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 3/12/2004 17:25'!
submitOnChange
	self at: 'onChange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 2/7/2004 02:18'!
submitOnClick
	self at: 'onClick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'mbany 4/14/2005 12:04'!
writeAttribute: assoc on: aStream
	assoc value = false ifFalse:
		[aStream nextPut: $ .
		aStream nextPutAll: assoc key asLowercase.
		aStream nextPutAll: '="'.
		assoc value = true
			ifFalse: [aStream nextPutAll: (WAAbstractHtmlBuilder encode: assoc value displayString)]
			ifTrue: [aStream nextPutAll: assoc key asLowercase].
		aStream nextPut: $"]! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'avi 6/22/2005 01:55'!
writeOn: aStream
	self associations do:
			[:assoc |
			self writeAttribute: assoc on: aStream].! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlDocument class methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:23'!
new
	^ self root: WAHtmlRoot new! !

!WAHtmlDocument class methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:22'!
root: anHtmlRoot
	^ self basicNew initializeWithRoot: anHtmlRoot! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:02'!
close! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:29'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:04'!
initializeWithRoot: aRoot
	root _ aRoot! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:28'!
openTag: aString attributes: anAttributes
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:24'!
root
	^ root! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:52'!
shouldPrintCloseTagFor: aString
	^(#('hr' 'br' 'input' 'img' 'link') includes: aString) not! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'state stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:40'!
bodyStream
	state = #head ifTrue:
		[state _ #body.
		root writeOn: stream].
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:41'!
close
	self bodyStream nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
closeTag: aString
	self writeCloseTag: aString on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:38'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	stream _ String new writeStream.
	state _ #head! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
openTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:38'!
stream: aStream
	stream _ aStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
text: aString
	self bodyStream nextPutAll: aString! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:52'!
writeCloseTag: aString on: aStream
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [aStream nextPutAll: '</'; nextPutAll: aString; nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:04'!
writeOpenTag: aString attributes: anAttributes on: aStream
	aStream
		nextPut: $<;
		nextPutAll: aString.
	anAttributes ifNotNil: [anAttributes writeOn: aStream].
	(self shouldPrintCloseTagFor: aString) ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

WAHtmlDocument subclass: #WAHtmlTreeDocument
	instanceVariableNames: 'head stack body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlTreeDocument class methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 12:27'!
new
	^ super new initialize! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:46'!
addElement: anObject
	stack last add: anObject! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 11/20/2003 18:36'!
closeTag: aString
	self popElement name = aString ifFalse: [self error: 'Mismatched tags']! !

!WAHtmlTreeDocument methodsFor: 'accessing' stamp: 'avi 6/18/2004 18:31'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	body _ WAHtmlElement named: 'body'.
	stack _ OrderedCollection with: body! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 5/18/2004 13:51'!
openTag: aString attributes: anAttributes
	| element |
	element _ WAHtmlElement named: aString attributes: anAttributes.
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [element beClosed]
		ifFalse: [element notClosed].
	self pushElement: element! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'avi 11/20/2003 18:36'!
popElement
	^ stack removeLast! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:57'!
pushElement: anObject
	self addElement: anObject.
	stack add: anObject.! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 11/20/2003 18:50'!
text: aString
	self addElement: aString! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:58'!
withElement: anElement do: aBlock
	self pushElement: anElement.
	aBlock value.
	self popElement.! !

!WAHtmlTreeDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:35'!
writeBodyOn: aStream
	body childrenDo: [:ea | ea writeOn: aStream]
! !

!WAHtmlTreeDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:37'!
writeOn: aStream
	root writeOn: aStream.
	self writeBodyOn: aStream.
	aStream nextPutAll: '</body></html>'! !

WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPrettyPrintedDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
renderer: aRenderer
	^ self basicNew initializeWithRenderer: aRenderer! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'ac 9/23/2005 22:01'!
attribute: anAssociation
	| attr value |
	attr _ anAssociation key asLowercase.
	value _ anAssociation value.
	
	value = false ifFalse:
		[html space.
		html spanClass: (self cssClassForAttribute: attr) with:
			[html text: attr].
		html text: '='.
		html spanClass: 'attribute-value' with:
			[html text: '"'.
			attr = 'href'
				ifTrue: [value ifNotNil: [html anchorWithUrl: value do: (value size > 8 ifTrue: ['...', (value last: 8)] ifFalse: [value])]]
				ifFalse:
					[value = true
						ifFalse: [html text: value displayString]
						ifTrue: [html text: attr]].
			html text: '"']]! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 21:07'!
attributes: anAttributes
	anAttributes ifNotNil: [anAttributes associations do: [:ea | self attribute: ea]]! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
closeTag: aString
	indentLevel _ indentLevel - 1.
	indentCloseTags removeLast ifTrue:
		[html break.
		indentLevel timesRepeat: [html space]].

	(self shouldPrintCloseTagFor: aString) ifTrue:
		[html text: '</'.
		html spanClass: (self cssClassFor: aString) with: [html text: aString].
		html text: '>'].
! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
cssClassFor: aString
	^ (self isKnownTag: aString) ifTrue: ['tag-known'] ifFalse: ['tag-unknown']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString) ifTrue: ['attribute-known'] ifFalse: ['attribute-unknown']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/3/2004 19:25'!
initializeWithRenderer: aRenderer
	html _ aRenderer.
	indentCloseTags _ OrderedCollection with: false.
	indentLevel _ 0! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 4/2/2005 22:20'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 4/2/2005 22:20'!
isKnownTag: aString
	^ self knownTags includes: aString asSymbol! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
openTag: aString attributes: anAttributes
	html break.
	indentLevel timesRepeat: [html space].
	
	html text: '<'.
	html spanClass: (self cssClassFor: aString) with: [html text: aString].
	
	self attributes: anAttributes.
	
	(self shouldPrintCloseTagFor: aString)
		ifFalse: [html space; text: '/'].
	html text: '>'.
	
	indentLevel _ indentLevel + 1.
	indentCloseTags removeLast; addLast: true; addLast: false.! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'ac 9/23/2005 22:08'!
root
	^ html context document root! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
text: aString
	html text: aString! !

WAHtmlDocument subclass: #WAStyleCollector
	instanceVariableNames: 'styles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 11:03'!
closeTag: aString! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 11:52'!
openTag: aString attributes: anAttributes
	anAttributes ifNil: [^ self].
	anAttributes associations do:
		[:assoc |
		assoc key = 'class' ifTrue:
			[self styles addAll: ((assoc value findTokens: ' ') collect: [:ea | '.', ea])].
		assoc key = 'id' ifTrue: [self styles add: '#', assoc value]]! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 11:05'!
styles
	^ styles ifNil: [styles _ Set new]! !

!WAStyleCollector methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 11:03'!
text: aString! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children _ OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:49'!
beClosed
	isClosed _ true! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:49'!
initializeWithName: aString attributes: anAttributes
	name _ aString.
	attributes _ anAttributes.
	isClosed _ true.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:50'!
notClosed
	isClosed _ false! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:17'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:07'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes ifNotNil: [attributes writeOn: aStream].
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:51'!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:10'!
writeOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea isString ifTrue: [aStream nextPutAll: ea] ifFalse: [ea writeOn: aStream]].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

Object subclass: #WAHtmlRoot
	instanceVariableNames: 'docType title htmlAttrs headAttrs bodyAttrs headElements scripts styles resourceBaseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Document'!

!WAHtmlRoot class methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
absoluteUrlForResource: aString
	(aString beginsWith: 'http') ifTrue: [^ aString].
	resourceBaseUrl ifNil: [^ aString].
	^ resourceBaseUrl, aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 17:01'!
addHeadElement: anHtmlElement
	headElements add: anHtmlElement! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 17:02'!
addScript: aString
	(scripts includes: aString) ifFalse: [scripts add: aString]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 17:02'!
addStyle: aString
	(styles includes: aString) ifFalse: [styles add: aString]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:56'!
bodyAttributes
	^ bodyAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:09'!
contentBase: urlString
	self addHeadElement:
		((WAHtmlElement named: 'base')
				attributeAt: 'href' put: urlString;
				yourself)! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
docType: aString
	docType _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 09:07'!
forIE5Do: aBlock
	self addHeadElement: (WAConditionalComment new start: 'if gte IE 5').
	aBlock value.
	self addHeadElement: (WAConditionalComment new end: 'endif').! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'gk 1/9/2006 17:28'!
forIE6Do: aBlock
	self addHeadElement: (WAConditionalComment new start: 'if IE 6').
	aBlock value.
	self addHeadElement: (WAConditionalComment new end: 'endif').! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:57'!
headAttributes
	^ headAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:54'!
htmlAttributes
	^ htmlAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:33'!
initialize
	htmlAttrs _ WAHtmlAttributes new.
	headAttrs _ WAHtmlAttributes new.
	bodyAttrs _ WAHtmlAttributes new.
	headElements _ OrderedCollection new.
	scripts _ OrderedCollection new.
	styles _ OrderedCollection new.
	docType _ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title _ ''.! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
linkToScript: url
	self addHeadElement:
		((WAHtmlElement named: 'script')
			attributeAt: 'src' put: (self absoluteUrlForResource: url asString);
			attributeAt: 'type' put: 'text/javascript';
			yourself)! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
linkToStyle: url
	self addHeadElement:
		((WAHtmlElement named: 'link')
			attributeAt: 'href' put: (self absoluteUrlForResource: url asString);
			attributeAt: 'rel' put: 'stylesheet';
			attributeAt: 'type' put: 'text/css';
			yourself)
! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
resourceBaseUrl
	^ resourceBaseUrl! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:38'!
resourceBaseUrl: aString
	resourceBaseUrl _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:54'!
title: aString
	title _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:19'!
writeHeadOn: aStream
	aStream nextPutAll: '<title>', title, '</title>'.
	styles do: [:ea | self writeStyle: ea on: aStream].
	scripts do: [:ea | self writeScript: ea on: aStream].
	headElements do: [:ea | ea writeOn: aStream]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 11:45'!
writeOn: aStream
	aStream nextPutAll: docType.
	aStream nextPutAll: '<html'.
	htmlAttrs writeOn: aStream.
	aStream nextPutAll: '><head'.
	headAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
	self writeHeadOn: aStream. 
	aStream nextPutAll: '</head><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 1/22/2005 22:00'!
writeScript: aString on: aStream
	aStream
		nextPutAll: '<script type="text/javascript">';
		nextPutAll: aString;
		nextPutAll: '</script>'! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:37'!
writeStyle: aString on: aStream
	aStream
		nextPutAll: '<style>';
		nextPutAll: aString;
		nextPutAll: '</style>'! !

WAHtmlRoot subclass: #WARenderedHtmlRoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderedHtmlRoot class methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 01:21'!
context: aRenderingContext
	^ self basicNew initializeWithContext: aRenderingContext! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:29'!
context
	^ context! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 01:18'!
initializeWithContext: aRenderingContext
	context _ aRenderingContext.
	self initialize.! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 1/22/2005 22:00'!
writeScript: aString on: aStream
	| url |
	url _ context urlForDocument: aString mimeType: 'text/javascript'.
	aStream nextPutAll: '<script type="text/javascript" src="', url, '"></script>'.! !

!WARenderedHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 16:41'!
writeStyle: aString on: aStream
	| url |
	url _ context urlForDocument: aString mimeType: 'text/css'.
	aStream nextPutAll: '<link rel="stylesheet" type="text/css" href="', url, '" />'.! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom commentStamp: '<historical>' prior: 0!
I provide an adapter between Seaside and the Comanche web server. To start a new server on port 8080, evaluate

	WAKom startOn: 8080.
	
and to stop it, evaluate

	WAKom stop.
	
The state of the service (running or stopped) is automatically restored when quitting and reopening an image.

If you want to reset the password of the config application (reachable at /seaside/config) evaluate

	WADispatcherEditor initialize.!

!WAKom class methodsFor: 'service' stamp: 'avi 4/2/2005 22:18'!
createService
   Smalltalk at: #HttpService ifPresent:
       [:hs |
       ^ (hs on: port named: 'seaside') plug: self default].
   Smalltalk at: #ComancheNetService ifPresent:
       [:cns |
       ^ (cns named: 'seaside' onPort: port) module: self default].
   self error: 'Comanche is not installed.  Install Comanche from
SqueakMap and try again.'
! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:44'!
default
	^ self entryPoint: WADispatcher default! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryComponent: aClass path: aString
	^ self dispatcher: (aClass applicationWithPath: aString)! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	^ self new entryPoint: anEntryPoint! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
initialize
		Smalltalk addToStartUpList: self after: AutoStart.
		Smalltalk addToShutDownList: self! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service _ nil]! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 10/6/2005 21:26'!
port
	^ port! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/30/2005 16:40'!
shutDown
	self pause! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port _ aPort.
	service _ self createService.
	service start.
! !

!WAKom class methodsFor: 'service' stamp: 'avi 10/7/2005 16:23'!
startUp
	port _ (SmalltalkImage current extractParameters at: 'PORT' ifAbsent: [port]).
	port ifNotNil: [self startOn: port asNumber]! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port _ nil.
! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
convertRequest: aKomRequest
	| request |
	self processMultipartFields: aKomRequest.

	request _ WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (aKomRequest method = 'POST'
					ifTrue: [aKomRequest postFields]
					ifFalse: [aKomRequest getFields])
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:52'!
convertResponse: aResponse
	| komResponse |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse _  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].
	komResponse contents: aResponse contents.
	komResponse contentType: aResponse contentType.

	^ komResponse
! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	entryPoint _ anEntryPoint! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'cwp 3/26/2004 23:03'!
handleRequest: aRequest
	^ (entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 00:43'!
log: aRequest
	Transcript cr; show: aRequest url! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2005 00:22'!
process: komRequest
	|request response komResponse |
	^ WAReadWriteLock global read:
		[self log: komRequest.
		request _ self convertRequest: komRequest.

		response _ self handleRequest: request.
		komResponse _ self convertResponse: response.

		response release.
		komResponse]! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:14'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream _ WriteStream on: String new.
			chunk saveToStream: stream.
			file _ WAFile new fileName: chunk fileName; contents: stream contents; contentType: chunk contentType.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

WAKom subclass: #WAKomEncoded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAKomEncoded commentStamp: '<historical>' prior: 0!
I provide an adapter between Seaside and the Comanche web server with response/request conversion from UTF-8 to MultiString and back in Squeak 3.8 and higher.

see WAKom!

!WAKomEncoded methodsFor: 'as yet unclassified' stamp: 'pk 4/11/2005 18:43'!
convertRequest: aKomRequest

	| request fields |

	self processMultipartFields: aKomRequest.

	fields := aKomRequest method = 'POST'
					ifTrue: [aKomRequest postFields]
					ifFalse: [aKomRequest getFields].

	" UTF-8 conversion of form inputs "
	fields associationsDo: [ :association |
			(association value isKindOf: OrderedCollection) ifTrue: [
				association value: (association value collect: [ :s |
					| multiString |	
					multiString := (MultiByteBinaryOrTextStream with: s) reset.
					multiString converter: UTF8TextConverter new.
					multiString contents] ) ] ].
	
	request := WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: fields
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKomEncoded methodsFor: 'as yet unclassified' stamp: 'avi 6/20/2005 16:28'!
convertResponse: aResponse
	| komResponse responseStream |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse :=  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].

	" conversion to UTF-8 "
	responseStream _ aResponse.
	(aResponse contentType upTo: $/) = 'text' ifTrue:
		[responseStream _ MultiByteBinaryOrTextStream on: WideString new encoding: #utf8.
		responseStream nextPutAll: aResponse contents.
		responseStream binary reset].
	
	komResponse contents: responseStream contents readStream.
	komResponse contentType: aResponse contentType.

	^ komResponse! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
new
	^ super new initialize! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val _ table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals _ OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max _ aNumber! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 19:07'!
initialize
	max _ 20.
	table _ Dictionary new.
	ageTable _ Dictionary new.! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:44'!
nextKey
	|key|
	[table includesKey: (key _ WAExternalID new displayString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key _ self nextKey.
	self at: key put: anObject.
	^ key! !

Object subclass: #WAListener
	instanceVariableNames: 'port process dispatcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^ WADispatcher default! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:20'!
initialize
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
port: aNumber
	^ self basicNew initializeWithPort: aNumber! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:20'!
shutDown
	self allInstancesDo: [:listener | listener stop]! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
startOn: aNumber
	default ifNotNil: [default stop].
	default _ self port: aNumber.
	default dispatcher: self dispatcher.
	default start! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:20'!
startUp
	self allInstancesDo: [:listener | listener start]! !

!WAListener class methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
stop
	default ifNotNil: [default stop].
	default _ nil! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
convertRequest: aKomRequest
	| request |
	request _ WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (aKomRequest method = 'POST'
					ifTrue: [aKomRequest postFields]
					ifFalse: [aKomRequest getFields])
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
dispatcher
	^dispatcher! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
dispatcher: anObject
	dispatcher := anObject! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
initializeWithPort: aNumber
	port _ aNumber.! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
listenLoop
	| socket |
	socket _ Socket newTCP.
	socket listenOn: port backlogSize: 50.
	socket isValid ifFalse: [self error: 'Cannot create socket on port ', port asString].
	
	[[self waitForConnectionOn: socket] repeat]
		ensure: [socket destroy].
	(Delay forMilliseconds: 10) wait.
	self listenLoop.! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
processConnection: aSocket
	| stream request |	
	stream _ FastSocketStream on: aSocket.
	stream autoFlush: true.
	[request _ HttpRequest readFromStream: stream.
	self writeResponseForRequest: request on: stream]
		ensure: [stream close]
		! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
responseForRequest: aRequest
	^ HTTPResponse notFound! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
start
	self stop.
	process _ [self listenLoop] forkAt: Processor highIOPriority.! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
stop
	process ifNotNil: [process terminate. process _ nil]! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:18'!
waitForConnectionOn: serverSocket
	| connection |
	[connection _ serverSocket waitForAcceptFor: 10.
	[self processConnection: connection] fork]
		on: ConnectionTimedOut
		do: [:n]
		! !

!WAListener methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:19'!
writeResponseForRequest: swazooRequest on: aStream
	| request response |
	request _ self convertRequest: swazooRequest.
	request responseStream: aStream.
	response _ dispatcher handleRequest: request.	
	response ifNotNil:
		[response writeOn: aStream.
		response release]! !

Object subclass: #WAMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:37'!
application
	^ self session application! !

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:31'!
session
	^ WACurrentSession value! !

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:25'!
start: aRequest
	self subclassResponsibility! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
createRoot
	| root |
	root _ super createRoot.
	root addDecoration: (WABasicAuthentication new authenticator: self).
	^ root! !

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 15:55'!
verifyPassword: password forUser: username
	^(self application preferenceAt: #login) = username and: [(self application preferenceAt: #password) = password]! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:09'!
call: aComponent
	^ WARenderLoop new call: aComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:59'!
createRoot
	^ self rootClass new! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 17:45'!
rootClass
	^ self application preferenceAt: #rootComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 11:51'!
start: aRequest
	| root |
	root _ self createRoot.
	root visiblePresentersDo: [:ea | ea initialRequest: aRequest].
	(WARenderLoop new root: root) run
! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAModelProxy commentStamp: '<historical>' prior: 0!
I am a fake object that can be interposed between the real model object and the client, so that the data can be validated or collected before commiting to the real model.

If you have a model instance like

	model := WAStoreAddress new.
	model street: 'Rathausgasse 34'.

create a model proxy by evaluating the following code:

	proxy := WAModelProxy on: model.
	
Then use the accessors of the proxy as you would do with your model:

	proxy country: 'Switzerland'.
	proxy street -> 'Rathausgasse 34'
	...
	
To propagate the values into your model send #commit :

	proxy commit.
	model country -> 'Switzerland'!

!WAModelProxy class methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache _ Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:53'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse:
			[(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:50'!
performRead: aSymbol
	^ cache at: aSymbol ifAbsent: [model perform: aSymbol]! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 18:39'!
performRealWrite: aSymbol with: anObject
	model perform: (aSymbol,':') asSymbol with: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol put: anObject! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model _ anObject.
	cache _ Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:27'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model _ anObject! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderOn: html
	|array|
	array _ (model perform: list) asArray.
	html divClass: 'column-choice' with:	
		[html form:
			[html attributeAt: 'size' put: size.
			html attributeAt: 'onChange' put: 'submit()'.
			html
				selectFromList: array
				selected: (array at: (model perform: selected) ifAbsent: [])
				callback: [:item | model perform: changeSelected with: (array indexOf: item)]]].	! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size _ aNumber! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAComponent commentStamp: '<historical>' prior: 0!
I am a class representing a graphical element of a seaside application. A component has state (instance variables, that might be backtracked using #registerObjectForBacktracking:), behavior decorations, children and an appearance that is specified in #renderContentOn:. A component might chose to display another component with #call:.

Child Components:
It is common for a component to display instances of other components while rendering itself.  It does this by passing them into the #render: method of WAHtmlRenderer.  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading: 'My Counter' level: 3.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading: 'My Counter' level: 3.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These subcomponents are usually instance variables of the component that is "embedding" them.  They are commonly created as part of the components #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of subcomponents that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent component *must* implement a #children method that returns a collection of all of the subcomponents that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Call/Answer:
If a subcomponent makes a #call: to another component, that component will appear in place of the subcomponent.  In the first example, if myCounter made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading 
above it.

Since a subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].!

WAComponent subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'avi 12/18/2004 18:26'!
allPages
	^ $A to: $Z! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
batch
	^ items select: [:ea | ea displayString asUppercase first = self currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage _ self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage _ aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'initialization' stamp: 'avi 12/18/2004 18:20'!
initialize
	self session registerObjectForBacktracking: self.! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items _ aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage _ self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
previousPage
	self isOnFirstPage ifFalse: [currentPage _ self validPages before: currentPage]
! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'avi 12/18/2004 18:21'!
renderContentOn: html
	items isEmpty ifFalse: [
		html divNamed: 'batch' with: [
			self renderPreviousOn: html.
			self renderPagesOn: html. 
			self renderNextOn: html ] ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'avi 12/18/2004 18:13'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'avi 12/18/2004 18:24'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse:
					[(self validPages includes: char)
						ifTrue: [html anchorWithAction: [self currentPage: char] text: char]
						ifFalse: [html text: char]]
				ifTrue: [html bold: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'avi 12/18/2004 18:13'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'mbany 4/14/2005 12:37'!
validPages
	^ (items collect: [:ea | ea displayString asUppercase first]) asSet asSortedCollection! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WABatchSelection class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:23'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:18'!
items: aCollection
	batcher _ WABatchedList new items: aCollection; batchSize: 8! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector _ aSymbol! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:38'!
renderContentOn: html
	html list: batcher batch do:
		[:ea |
		html anchorWithAction: [self choose: ea] text: (ea perform: linkSelector).
		html break; text: (ea perform: textSelector).
		html paragraph].
	html attributes alignCenter.
	html div: batcher.! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector _ aSymbol! !

WAComponent subclass: #WABatchTest
	instanceVariableNames: 'batcher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WABatchTest methodsFor: 'as yet unclassified' stamp: 'avi 12/18/2004 18:33'!
children
	^ Array with: batcher! !

!WABatchTest methodsFor: 'as yet unclassified' stamp: 'avi 12/18/2004 18:30'!
initialize
	batcher _ WAAlphabeticBatchedList new items: Collection allSubclasses! !

!WABatchTest methodsFor: 'as yet unclassified' stamp: 'avi 12/18/2004 18:30'!
renderContentOn: html
	html render: batcher.
	html list: batcher batch! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WABatchedList class methodsFor: 'as yet unclassified' stamp: 'avi 12/18/2004 18:13'!
example
	^self new
		items: (1 to: 100);
		yourself.
		! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:05'!
batch
	^ items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize _ aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage _ aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:17'!
endIndex
	^ currentPage * batchSize min: items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'avi 12/9/2003 13:17'!
initialize
	batchSize _ 10.
	currentPage _ 1.
	self session registerObjectForBacktracking: self.! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnFirstPage
	^ currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnLastPage
	^ currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items _ aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/29/2003 16:39'!
maxPages
	^ (items size / batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
nextPage
	self isOnLastPage ifFalse: [currentPage _ currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
previousPage
	self isOnFirstPage ifFalse: [currentPage _ currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:26'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html divNamed: 'batch' with: [
			self renderPreviousOn: html.
			self renderPagesOn: html. 
			self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:31'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			currentPage = index
				ifFalse: [html anchorWithAction: [self currentPage: index] text: index]
				ifTrue: [html bold: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:09'!
startIndex
	^ (currentPage - 1) * batchSize + 1! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WABrowser class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:35'!
fullOnClass: aClass
	^ self new model: (Browser new setClass: aClass selector: nil)! !

!WABrowser methodsFor: 'actions' stamp: 'avi 4/28/2004 11:40'!
accept
	|save|
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message _ nil.
	save _ contents.
	model contents: contents notifying: self.
	contents _ save.
! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents _ aString! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 01:45'!
initialize
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model _ aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents _ model contents.! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message _ aString allButLast: 3! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols _ #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 12/12/2002 00:39'!
renderContentPaneOn: html
	html form: [
		html
			textAreaOn: #contents of: self;
			break;
			submitButtonOn: #accept of: self.
	]! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 2/16/2003 00:26'!
renderMessageOn: html
	message ifNotNil: [html bold: message]! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:09'!
renderModeButtonsOn: html
	html form: [
		html
			submitButtonWithAction: [ self showInstance ] text: 'instance';
			submitButtonWithAction: [ self showHelp ] text: 'help';
			submitButtonWithAction: [ self showClass ] text: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser methodsFor: 'rendering' stamp: 'mb 2/17/2005 18:20'!
style

	^ '

	#contents {width: 100%; height: 300px; font-family: serif; font-size: 14pt}

	'! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents _ model contents! !

WAComponent subclass: #WACacheTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACacheTest methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2004 15:41'!
renderContentOn: html
	Smalltalk garbageCollect.  
	html heading: ResponseContinuation allInstances size.
	html heading: AnswerContinuation allInstances size.
	html heading: EscapeContinuation allInstances size.
	html anchorWithAction: [self inform: 'answer'] text: 'call'.
	html break.
	html anchorWithAction: [self call: self class new] text: 'keep calling'.! !

WAComponent subclass: #WACallbackTest
	instanceVariableNames: 'transcript counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACallbackTest methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 17:50'!
children

	^ Array with: counter.! !

!WACallbackTest methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 17:50'!
initialize
	transcript _ String new writeStream.
	counter := WACounter new.! !

!WACallbackTest methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 17:50'!
renderContentOn: html
	html anchorWithCallback: [] do: 'Idempotent'.
	html space.
	html anchorWithAction: [] do: 'Side Effect'.
	
	html form: [
		html defaultAction: [transcript cr; nextPutAll: 'default action'].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text: ', v printString].
		html textInputWithValue: '' callback: [:v | transcript cr; nextPutAll: 'text2: ', v printString].
		html break.
		html submitButton.
		html space.
		html submitButtonWithAction: [transcript cr; nextPutAll: 'go'] text: 'Go'.
		html space.
		html cancelButtonWithAction: [transcript cr; nextPutAll: 'cancel'].
	].
	html preformatted: transcript contents.
	html horizontalRule.
	html render: counter.! !

WAComponent subclass: #WACanvasTest
	instanceVariableNames: 'count selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACanvasTest methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:06'!
decrease
	count _ count - 1! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:06'!
increase
	count _ count + 1! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: 'lr 9/26/2005 15:21'!
initialize
	count := 0.
	selected := Array new.! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: 'lr 9/26/2005 15:12'!
renderContentOn: html
	html div style: 'background-color: lightblue'; with: [
		html text: count; break.
		html anchor callback: [self increase]; with: '++'.
		html space.
		html anchor callback: [self decrease]; with: '--'.
	].

	html table with: [
		html tableRow with: [
			html tableData with: [
				html form: [
					html select
						size: 10; 
						beMultiple; 
						beSubmitOnChange;
						list: Collection subclasses;
						selected: selected;
						callback: [ :value | selected := value ] ] ].
			html tableData with: [
				html unorderedList
					beMultiple;
					list: Collection subclasses;
					selected: selected;
					callback: [ :value | selected := value ] ] ] ].! !

!WACanvasTest methodsFor: 'as yet unclassified' stamp: 'lr 9/25/2005 14:10'!
rendererClass
	^ WARenderCanvas! !

WAComponent subclass: #WAChangePassword
	instanceVariableNames: 'username password confirmation authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 22:37'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:10'!
cancel
	self answer: false! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:09'!
changePassword
	password = confirmation
		ifFalse: [^ self inform: 'Sorry, the password and confirmation did not match.'].
	authenticator setPassword: password forUser: username.
	self answer: true
	! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:10'!
renderContentOn: html

	html form: [
		html table: [
			html
				tableRowWithLabel: 'Username'
				column: username.
			html
				tableRowWithLabel: 'Password'
				column: [html passwordInputWithCallback: [:v | password _ v]].
			html
				tableRowWithLabel: 'Confirm Password'
				column: [html passwordInputWithCallback: [:v | confirmation _ v]].
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #changePassword of: self.
				html space.
				html submitButtonOn: #cancel of: self
			] span: 2.
		]
	]! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 22:37'!
username: aString
	username _ aString! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:43'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:08'!
go
	|i|
	i _ 1.
	#(a b c) do: [:each | self inform: each displayString, ' ', i displayString. i _ i + 1]! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:47'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
applicationWithPath: aString
	| app |
	app _ WAApplication path: aString.
	app configuration addAncestor: WARenderLoopConfiguration new.
	app preferenceAt: #rootComponent put: self.
	^ app! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 16:16'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."
	
	^ false! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 13:57'!
new
	^ self basicNew initializeDecoration initialize! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:10'!
registerAsApplication: appName
	|app|
	app _ self applicationWithPath: appName.
	WADispatcher default registerEntryPoint: app at: appName.
	^ app! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 11/16/2005 23:33'!
registerAsAuthenticatedApplication: appName
	| app user password |
	app _ self registerAsApplication: appName.
	app configuration addAncestor: WAAuthConfiguration new.
	
	[user _ FillInTheBlank
		request: ('Please choose an administrator\username for the application ''', appName displayString , '''') withCRs.

		" Or can we do this instead ????

		request: ('Please choose an administrator\username for the application ', appName printString) withCRs.

		"
	user = ''] whileTrue.
		
	[password _ FillInTheBlank
		request: 'Please enter a password for ', user printString.
	password = ''] whileTrue.
		
	app preferenceAt: #login put: user.
	app preferenceAt: #password put: password.
	
	^ app
	! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 6/25/2005 15:22'!
renderSampleInstance: aBlock
|session root context docRoot document|
session := WASession application: WAApplication new.
^ WACurrentSession use: session during:
	[root := self new.
	aBlock value: root.
	context := WARenderingContext new request: WARequest new.
	context actionUrl: (WAUrl new addToPath: 'action').
	docRoot := WAHtmlRoot new.
	root visiblePresentersDo: [:ea | ea updateRoot: docRoot].
	document := WAHtmlStreamDocument root: docRoot.
	context document: document.
	root decorationChainDo: [:ea | ea renderWithContext: context].
	document close.
	document stream contents]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 6/2/2004 22:16'!
addDecoration: newDecoration
	| prev dec |
	prev _ nil.
	dec _ self decoration.
	[dec ~~ self and: [self decoration: dec shouldWrap: newDecoration]] whileTrue:
		[prev _ dec.
		dec _ dec owner].
	newDecoration owner: dec.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration].
	^ newDecoration! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:53'!
addMessage: aString
	self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:55'!
allDecorationsDo: aBlock
	| ea |
	ea _ self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea _ ea owner]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
answer: anObject
	self decorationChainDo: [:ea | ea handleAnswer: anObject]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 00:55'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock
! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 10/26/2004 15:40'!
call: aComponent
	^ AnswerContinuation currentDo: [:cc | self show: aComponent onAnswer: cc]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 16:17'!
children
	"This method is really important. It should return a collection of all subcomponents of the current component that will be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children."
	
	^ #()! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:57'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
confirm: aString
	^ self call: (WAYesOrNoDialog new addMessage: aString)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val _ aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:36'!
decoration
	decoration ifNil: [decoration _ WAStateHolder new contents: self].
	^ decoration contents! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:57'!
delegations
	| delegations |
	delegations _ OrderedCollection new.
	self allDecorationsDo: [:ea | ea isDelegation ifTrue: [delegations add: ea]].
	^ delegations! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:13'!
handleAnswer: anObject
	^ false! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:56'!
home
	self delegations do: [:ea | self removeDecoration: ea]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
inform: aString
	self call: (WAFormDialog new addMessage: aString)
! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 13:59'!
initializeDecoration
	decoration _ WAStateHolder new contents: self! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn _ WATransaction new.
	val _ self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:59'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 6/8/2004 01:14'!
onAnswer: aBlock
	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 10:40'!
removeDecoration: aDecoration
	| dec |
	dec _ self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec owner.
		^ self].
	
	[dec notNil] whileTrue:
		[dec owner = aDecoration
			ifTrue: [dec owner: aDecoration owner.  ^ self]
			ifFalse: [dec _ dec owner]]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 16:19'!
renderOn: aRenderer
	"Do not override this methods on your component, override instead #renderContentOn: and in addition to not invoke directly renderContentOn: on subcomponent in such method but use instead html render: subcomponent."

	self decorationChainDo: [ :each | each renderWithContext: aRenderer context ].! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString)
				addMessage: requestString)! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:26'!
script
	^ nil! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 3/29/2004 16:07'!
show: aComponent
	self show: aComponent onAnswer: [:v]! !

!WAComponent methodsFor: 'call/answer' stamp: 'avi 7/6/2004 10:41'!
show: aComponent onAnswer: aBlock
	| delegation event |
	delegation _ WADelegation new delegate: aComponent.
	event _ nil.
	event _ aComponent onAnswer: [:v | delegation remove. event remove. aBlock value: v].
	self addDecoration: delegation.
	WARenderNotification raiseSignal! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
style
	^ nil! !

!WAComponent methodsFor: 'convenience' stamp: 'cds 7/25/2005 10:24'!
validateWith: aBlock
	^self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:58'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WAConfigurationEditor subclass: #WAApplicationEditor
	instanceVariableNames: 'application library'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 6/24/2004 00:30'!
addLibrary
	application libraries add: library! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 6/24/2004 00:24'!
allLibraries
	^ WAStyleLibrary subclasses, WAScriptLibrary subclasses! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:32'!
application: anApplication
	application _ anApplication.
	configuration _ application configuration.! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 6/24/2004 00:23'!
libraryOptions
	^ self allLibraries difference: application libraries! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 14:37'!
renderContentOn: html
	html heading: 'Application: ', application name.

	super renderContentOn: html.! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 6/24/2004 00:23'!
renderFormOn: html
		html text: 'Base Path: '.
		html textInputOn: #basePath of: application.
		
		html heading: 'Libraries' level: 2.
		self libraryOptions isEmpty ifFalse:
			[html text: 'Add Library: '.
			html
				selectFromList: self libraryOptions
				selected: nil
				callback: [:v | library _ v].
			html space.
			html submitButtonWithAction: [self addLibrary] text: 'Add'.].
		html list: application libraries do:
			[:ea |
			html text: ea.
			html space.
			html anchorWithAction: [application libraries remove: ea] text: '(remove)'].
		
		super renderFormOn: html! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:30'!
configuration
	^ configuration! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:02'!
configuration: aConfiguration
	configuration _ aConfiguration! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 15:06'!
done
	self answer! !

!WAConfigurationEditor methodsFor: 'initialization' stamp: 'avi 1/30/2004 16:46'!
initialize
	configuration _ WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 6/13/2004 23:23'!
renderAncestryListFor: aConfiguration seen: aSet on: html
	aConfiguration ancestors isEmpty ifTrue: [^ self].
	
	html list: aConfiguration ancestors do:
		[:ea |
		self renderParent: ea on: html.
		(aSet includes: ea) ifFalse:
			[aSet add: ea.
			self renderAncestryListFor: ea seen: aSet on: html]].
! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 15:12'!
renderAncestryOn: html
	html attributes style: 'border: 1px solid black; background: lightgrey'.
	html div: [
		html table: [
			html heading: 'Configuration Ancestors' level: 2.

			configuration potentialAncestors isEmpty ifFalse:
				[html text: 'Add ancestor: '.
				self renderParentSelectorOn: html].
			self renderAncestryListFor: configuration seen: Set new on: html]].! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'mb 2/17/2005 10:47'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (self labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [self renderUnspecifiedAttribute: anAttribute on: html]
				ifNotNil: 
					[(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [self renderOverridenAttribute: anAttribute on: html]
						ifFalse: [self renderInheritedAttribute: anAttribute on: html]]
		].
		self renderInheritanceForAttribute: anAttribute on: html]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 6/13/2004 23:23'!
renderContentOn: html
	html form: [
		self renderFormOn: html.
		
		html break.
		html submitButtonOn: #save of: self.
		html submitButtonOn: #done of: self.
	]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'mb 2/17/2005 10:47'!
renderFormOn: html
	self renderAncestryOn: html.
	html break.
	html attributes style: 'border: 1px solid black'.
	html div: [
		html table: [
			configuration groupedAttributes
				do: [:assoc |
					html tableRowWith: [html heading: (self labelForSelector: assoc key) level: 3] span: 2.
					assoc value do:
						[:attr | self renderAttribute: attr on: html]]]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 15:08'!
renderInheritanceForAttribute: anAttribute on: html
	configuration inheritedValueAndSourceAt: anAttribute key do:
		[:value :source |
		(configuration hasLocalValueForAttribute: anAttribute)
			ifTrue:
				[html tableData: [
					html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'revert'.
					html text: ' to: ', value printString].
				html tableData: [
					html text: 'overriden from ', source name]]
			ifFalse:
				[html tableData: [html anchorWithAction: [configuration overrideAttribute: anAttribute] text: 'override'].
				html tableData: [html text: 'inherited from ', source name]].
		^ self].
	(configuration hasLocalValueForAttribute: anAttribute)
		ifTrue: [html tableData: [html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'clear']]
		ifFalse:
		[html tableData: [
			html attributes style: 'color: #ff0000'.
			html span: [html text: '(unspecified)']
		]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderInheritedAttribute: anAttribute on: html
	html text: (configuration valueForAttribute: anAttribute) printString! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'jf 2/8/2004 16:13'!
renderInheritedValueForAttribute: anAttribute on: html
	| inheritedValue |
	inheritedValue _ (configuration lookupValueAt: anAttribute key).
	inheritedValue
		ifNil: 
			[html attributes style: 'color: #ff0000'.
			html span: [html text: '(unspecified)']]
		ifNotNil: [html text: inheritedValue printString]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 13:06'!
renderLinkToAncestor: aConfiguration on: html
	"html anchorWithAction: [self call: (WAConfigurationEditor new configuration: aConfiguration)] text: aConfiguration"
	html text: aConfiguration! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderOverrideForAttribute: anAttribute on: html
	html anchorWithAction: [configuration overrideAttribute: anAttribute] text: 'edit'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderOverridenAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 11/16/2005 23:48'!
renderParent: aConfiguration on: html
	html text: aConfiguration name.
	html space.
	(configuration hasMutableAncestry and: [configuration ancestors includes: aConfiguration]) ifTrue:
		[html
			anchorWithAction: [configuration removeAncestor: aConfiguration] 
			text: '(remove)']! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 11:53'!
renderParentSelectorOn: html
	|selectedAncestor|
	selectedAncestor _ ValueHolder new.
	html
		selectFromList: configuration potentialAncestors
		selected: nil
		callback: [:v | selectedAncestor contents: v]
		labels: [:ea | ea name].
	html
		submitButtonWithAction: [configuration addAncestor: selectedAncestor contents]
		text: 'Add'. ! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderRevertForAttribute: anAttribute on: html
	html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'clear'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderUnspecifiedAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:36'!
save! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:34'!
select: aConfiguration
	self call: (WAConfigurationEditor new configuration: aConfiguration)! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:40'!
trailName
	^ configuration name! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 4/13/2004 21:56'!
visitBooleanAttribute: anAttribute with: html
	html
		booleanMenuWithValue:  (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]
		labels: #(true false)! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'mbany 4/14/2005 12:56'!
visitListAttribute: anAttribute with: html
	html
		selectFromList: (Array with: nil), anAttribute options asArray
		selected: (configuration valueForAttribute: anAttribute)
		callback: [:v | (configuration takeValue: v forAttribute: anAttribute)]
		labels: [:ea | ea ifNil: ['None'] ifNotNil: [ea displayString]]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 1/31/2004 12:25'!
visitNumberAttribute: anAttribute with: html
	html attributes size: 5.
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v asNumber forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 4/13/2004 21:03'!
visitPasswordAttribute: anAttribute with: html
	html
		passwordInputWithCallback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 1/30/2004 17:14'!
visitStringAttribute: anAttribute with: html
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACounter class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:07'!
initialize
	(self registerAsApplication: 'counter')
! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:59'!
count
	^ count! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
decrease
  count _ count - 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
increase
	count _ count + 1! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 23:01'!
initialize
	self session registerObjectForBacktracking: self.
	count _ 0! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
renderContentOn: html
	html heading: count.
	html anchorWithAction: [self increase] text: '++'.
	html space.
	html anchorWithAction: [self decrease] text: '--'! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'cds 2/22/2005 14:22'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ Date newDay: day monthNumber: month year: year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day _ aDate dayOfMonth.
	month _ aDate monthIndex.
	year _ aDate year.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'avi 2/17/2004 14:52'!
initialize
	startYear _ Date today year - 1.
	endYear _ Date today year + 5.
	self date: Date today.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'avi 7/11/2005 12:44'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| maxDay |
	theMonth > 0 & (theMonth <= 12) ifFalse: [^false].
	maxDay := Month daysInMonth: theMonth forYear: theYear.
	^theDay > 0 & (theDay <= maxDay)! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
renderContentOn: html
	html selectFromList: self months selected: month callback: [:i | month _ i] labels: [:ea | self labelForMonth: ea].
	html selectFromList: self days selected: day callback: [:i | day _ i] labels: [:ea | self labelForDay: ea].
	html selectFromList: self yearRange selected: year callback: [:i | year _ i] labels: [:ea | self labelForYear: ea].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:32'!
renderValidationErrorOn: html
	html spanClass: 'error' with: 'invalid date'! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month _ datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month _ date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count _ 0.
	self
		datesDo: [:ea | count _ count + 1. last _ ea]
		separatedBy: [aBlock value: last month value: count.
						count _ 0]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 15:12'!
renderContentOn: html
	html attributes border: 1.
	html cssClass: 'DateTable'; table: [
		html tableRow: [self renderMonthHeadingsOn: html].
		html tableRow: [self renderDayHeadingsOn: html].
		rows withIndexDo:
			[:ea :i|
			html tableRow: [self renderRow: ea index: i on: html]].
	]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:20'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date | html cssClass: 'DayHeading'; tableHeading: [html text: date dayOfMonth]]
		separatedBy: [self renderHeadingSpacerOn: html]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:50'!
renderHeadingForRow: anObject on: html
	html cssClass: 'RowHeading'; tableHeading: [html text: anObject]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:14'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo:
		[:month :length |
		self renderHeadingSpacerOn: html.
		html
			cssClass: 'MonthHeading';
			attributeAt: 'colspan' put: length;
			tableHeading: [html text: month name; space; text: month year]]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:51'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [:date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [	self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows _ aCollection! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache _ OrderedCollection new.
	date _ startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date _ date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart _ dateSelectionEnd _ rowSelectionStart _ rowSelectionEnd _ nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:41'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	|text|
	html attributeAt: 'bgcolor' put: (self colorForDate: aDate rowIndex: aNumber).
	html attributeAt: 'align' put: 'center'.
	html tableData: [
		text _ cellBlock value: anObject value: aDate.
		html anchorWithAction: [self selectDate: aDate rowIndex: aNumber] text: text.
	]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock _ aBlock! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart _ startDate.
	dateSelectionEnd _ endDate.
	rowSelectionStart _ 1.
	rowSelectionEnd _ rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart _ dateSelectionEnd _ aDate. rowSelectionStart _ rowSelectionEnd _ rowIndex]
		ifTrue: [dateSelectionEnd _ aDate. rowSelectionEnd _ rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WAComponent subclass: #WADefaultFormTest
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADefaultFormTest methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:32'!
renderContentOn: html
	html formWithDefaultAction: [self inform: 'Default: ', value displayString] do: 
		[
		html submitButtonWithAction: [self inform: 'Before'] text: 'Before'.
		html break.
		html textInputWithValue: '' callback: [:v | value _ v].
		html break.
		html submitButtonWithAction: [self inform: 'After'] text: 'After']! !

WAComponent subclass: #WADelayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WADelayTest methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:39'!
go
	self call: (WAComponent new
				addMessage: '3 seconds';
				addDecoration: (WADelayedAnswerDecoration new delay: 3);
				yourself)! !

!WADelayTest methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:35'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:56'!
canBeRoot 
	^ true! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:08'!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'ab 8/26/2003 21:49'!
addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [^ self inform: 'You must enter a path.'].
	entryPoint _ type new.
	dispatcher registerEntryPoint: entryPoint at: path.
	self configure: entryPoint! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'avi 3/24/2004 12:17'!
configure: anEntryPoint
	anEntryPoint configurationComponent ifNotNilDo: [:c | self call: c]! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:13'!
dispatcher: aDispatcher
	dispatcher _ aDispatcher! !

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'initialization' stamp: 'ab 8/26/2003 21:49'!
initialize
	dispatcher _ WADispatcher default.
	type _ WAApplication.
	path _ ''.! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'ab 8/26/2003 21:34'!
remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'avi 11/16/2005 23:34'!
renderContentOn: html
	html heading: 'Seaside'.
	
	html bold: dispatcher basePath.
		html table: [
			dispatcher entryPoints keysSortedSafely do:
				[:name |
				self
					renderRowForEntryPoint: (dispatcher entryPoints at: name)
					named: name
					on: html].
		].
	html paragraph.
	html form: [
		html bold: 'default entry point: '.
		html
			selectFromList: dispatcher entryPoints keysSortedSafely
			selected: dispatcher defaultPath
			callback: [:v | dispatcher defaultPath: v].
		html space.
		html submitButton.
	].
	html paragraph.
	
	html bold: 'add entry point: '.
	html form: [
		html table: [
			html tableRowWithLabel: 'Path:' column: [html textInputWithValue: '' callback: [:n | path _ n]].
			html tableRowWithLabel: 'Type:' column:
				[html selectFromList: self entryPointClasses selected: type callback: [:c | type _ c] labels: [:ea | ea description].
				html space.
				html submitButtonWithAction: [self addEntryPoint] text: 'Add']
		]
	].

	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchorWithAction: [self clearCaches] text: 'Clear Caches'.
	! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'ab 8/26/2003 21:33'!
renderRowForEntryPoint: anEntryPoint named: aString on: html
	html
		tableRowWith: [html anchorWithUrl: anEntryPoint basePath do: aString]
		with: [
			html anchorWithAction: [self configure: anEntryPoint] text: 'configure'.
			html space; anchorWithAction: [self remove: anEntryPoint] text: 'remove'.
		].! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'avi 3/16/2004 12:29'!
verifyPassword: pass forUser: user
	^ user = 'fooz' and: [pass = 'bar']! !

WAComponent subclass: #WAEmailConfirmation
	instanceVariableNames: 'from to subject body notice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
body: aString
	body _ aString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
from: fromString
	from _ fromString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
notice: aString
	notice _ aString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:41'!
renderContentOn: html
	| url |
	url _ html urlForAction: [self answer].
	self sendMessageWithUrl: url.
	html divClass: 'notice' with: notice! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:09'!
sendMessageWithUrl: urlString
	SeasidePlatformSupport
		deliverMailFrom: from
		to: (Array with: to)
		text: (urlString, '
		
', body)! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
subject: aString
	subject _ aString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
to: toString
	to _ toString! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAEncodingTest methodsFor: 'as yet unclassified' stamp: 'jf 2/18/2004 15:15'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html text: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAErrorTest methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:24'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'.
	html break.
	html anchorWithAction: [self notify: 'Really?'. self inform: 'Ok!!'] text: 'Raise warning'.! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExampleBrowser commentStamp: '<historical>' prior: 0!
I browse all the examples available in the system ie all the results of class methods beginning with #example... 

point your browser to localhost:xxx/seaside/examples

If you want to see these examples

/seaside/config app:
- add a new application named "examples"
- choose WAExampleBrowser as the root component
!

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 16:20'!
initialize
	self registerAsApplication: 'examplebrowser'.! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:01'!
allClasses
	^ (WAComponent allSubclasses select: [:ea | ea class selectors anySatisfy: [:s | s beginsWith: self selectorPrefix]])
		asSortedCollection: [:a :b | a name < b name]! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:01'!
allSelectors
	^ (class class selectors select: [:s | s beginsWith: self selectorPrefix])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:21'!
children
	^ Array with: component! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'pmm 6/23/2005 08:52'!
class: aClass
	class := aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:33'!
component: aComponent
	component _ aComponent.
	hasAnswer _ false.
	answer _ nil.
	component onAnswer: [:v | hasAnswer _ true. answer _ v].
! !

!WAExampleBrowser methodsFor: 'initialize' stamp: 'ab 6/14/2003 18:53'!
initialize
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'rendering' stamp: 'pmm 6/23/2005 08:52'!
renderContentOn: html
	html cssId: 'test-forms'; table: [
		html tableRowWith: [
			html form: [
				html selectFromList: self allClasses selected: class callback: [:c | self class: c].
				html submitButtonWithText: 'OK'.
			].
		] with: [
			html form: [
				html selectFromList: self allSelectors selected: selector callback: [:s | self selector: s].
			 	html submitButtonWithText: 'OK'.
			]
		].
	].
	html horizontalRule.
	html render: component.
	hasAnswer ifTrue:
		[html horizontalRule.
		html bold: 'Answer '; text: answer printString]! !

!WAExampleBrowser methodsFor: 'accessing' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector _ aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'helper' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

WAComponent subclass: #WAExpiryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpiryTest class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:25'!
install
	(self registerAsApplication: 'expiry')
		 preferenceAt: #sessionClass put: WAExpirySession! !

!WAExpiryTest methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2005 11:20'!
renderContentOn: html
	html table: [
		html tableRowWithLabel: 'Live session instances' column: WAExpirySession allInstances size.
		html tableRowWithLabel: 'Live component instances' column: self class allInstances size.
		html tableRowWithLabel: 'Sessions created' column: WAExpirySession created.
		html tableRowWithLabel: 'Sessions unregistered' column: WAExpirySession unregistered.
	].
	html anchorWithUrl: self session newSessionUrl do: 'New Session'.
	html break.
	html anchorWithAction: [self session expire] text: 'Expire'.
	html break.
	html anchorWithAction: [WAExpirySession resetCounters] text: 'Reset Counters'.
	html break.
	html anchorWithAction: [Smalltalk garbageCollect] text: 'Garbage Collect'.
	html break.
	html anchorWithAction: [self session application clearHandlers. Smalltalk garbageCollect] text: 'Clear Handlers'.
	html break.
	html anchorWithAction: [self session application clearHandlers. WAExpirySession resetCounters. 	Smalltalk garbageCollect.
] text: 'Reset All'.
	html form: [
		html text: 'Expiry seconds:'.
		html
			textInputWithValue: (self session application preferenceAt: #sessionExpirySeconds)
			callback: [:v | self session application preferenceAt: #sessionExpirySeconds put: v].
		html space.
		html submitButton]
	! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChoiceDialog class methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options _ aCollection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
renderContentOn: html
	html selectFromList: options selected: nil  callback: [:v | selection _ v]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:45'!
addForm
	form _ WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 14:06'!
initialize
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:35'!
renderContentOn: html
	html hiddenInputWithCallback: [validationError _ nil].
	validationError ifNotNil:
		[self renderValidationError: validationError on: html].
	html divClass: self divClass with: [self renderDialogOn: html].! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:20'!
renderSpacerRowOn: html
	html divClass: 'dialog-spacer' with: [html space]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:28'!
renderValidationError: aString on: html
	html spanClass: 'dialog-validation' with: aString! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError _ aString! !

WAFormDialog subclass: #WAGridDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:47'!
columns
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/17/2004 15:05'!
cssClassForItem: anObject
	^ 'dialog-row'! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:47'!
items
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:59'!
renderColumn: aSymbol for: anObject on: html
	| renderSelector |
	renderSelector _ self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: anObject with: html]
		ifFalse: [self renderDefaultColumn: aSymbol for: anObject on: html]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:00'!
renderDefaultColumn: aSymbol for: anObject on: html
	html text: (anObject perform: aSymbol)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:02'!
renderDialogOn: html
	html table: [
		self renderHeadingsOn: html.
		self items do:
			[:ea | 
			self renderRowForItem: ea on: html].
	]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:51'!
renderHeadingForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:51'!
renderHeadingsOn: html
	self columns do: [:ea |
		html cssClass: ea.
		html tableHeading: [self renderHeadingForSelector: ea on: html]]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/17/2004 15:04'!
renderRowForItem: anObject on: html
	html cssClass: (self cssClassForItem: anObject).
	html tableRow: [
		self columns do:
			[:ea |
			html cssClass: ea.
			html tableData: [self renderColumn: ea for: anObject on: html]]
	]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:59'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'For:on:') asSymbol! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:03'!
style
	^ '
	.dialog-buttons {text-align: center}
	'! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

WALabelledFormDialog subclass: #WAEditDialog
	instanceVariableNames: 'model snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEditDialog class methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:21'!
model: anObject
	^ self new model: anObject! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:10'!
buttons
	^ #(save cancel)! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
cancel
	self rollback.
	self answer: false! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
model
	^ model! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
model: anObject
	model _ anObject.
	self snapshot.! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
rollback
	model copyFrom: snapshot! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
save
	self validate.
	self isValid ifTrue: [self answer: true]! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
snapshot
	snapshot _ model clone! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:10'!
validate
	! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:07'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInputOn: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector _ self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:06'!
renderRowForSelector: aSymbol on: html
	html cssClass: 'dialog-row'.
	html divNamed: aSymbol with: 
		[html spanClass: 'dialog-form-label' with: [self renderLabelForSelector: aSymbol on: html].
		html spanClass: 'dialog-form-field' with: [self renderFieldForSelector: aSymbol on: html]].
! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:39'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WALabelledFormDialog subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreAddressEditor commentStamp: 'avi 1/1/2004 09:56' prior: 0!
A component for editing WAStoreAddress instances.  When called, it will create a new address instance, present a form for the user to modify it, and then answer the instance on submit.  Used by WAStoreTask>>getBillingAddress and getShippingAddress.!

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:55'!
countries
	^ #(Canada USA)! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:39'!
initialize
	address _ WAStoreAddress new.
	super initialize.! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 11:14'!
labelForSelector: aSymbol

	aSymbol == #name ifTrue: [^'Your name'].
	aSymbol == #street ifTrue: [^'The street'].
	aSymbol == #city ifTrue: [^'The city'].
	aSymbol == #ok ifTrue: [^'Continue'].
	^ super labelForSelector: aSymbol! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:38'!
model
	^ address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:04'!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:40'!
renderCountryOn: html
	html
		selectFromList: self countries
		selected: address country
		callback: [:v | address country: v]! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:11'!
rows
	^ #(name street city country)
! !

WALabelledFormDialog subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStorePaymentEditor commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for editing WAStoreCreditCard instances.  When called, it presents a form for the user to choose credit card type, and enter name, number, and expiry date.  On submit, it will create and answer an instance of the appropiate credit card subclass.  Note the difference with WAStoreAddressEditor, where the form modifies the address instance directly.  Used by WAStoreTask>>getPaymentInfo.!

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:06'!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:59'!
months
	^ (1 to: 12)! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:27'!
ok
	self answer:
		(cardType new
			name: name;
			number: cardNumber;
			expiry: (Date newDay: 1 monthNumber: month year: year))! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:15'!
renderCardNumberOn: html
	html textInputWithValue: cardNumber callback: [:v | cardNumber _ v]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
renderCardTypeOn: html
	html
		selectFromList: self cardTypes
		selected: cardType
		callback: [:v | cardType _ v]
		labels: [:ea | ea abbreviation]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:15'!
renderExpirationDateOn: html 
	html selectFromList: self months selected: month callback: [:m | month _ m].
	html selectFromList: self years selected: year callback: [:y | year _ y]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
renderNameOn: html
	html textInputWithValue: name callback: [:v | name _ v]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
rows
	^ #(cardType name cardNumber expirationDate)! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:45'!
years
	^ (Date today year to: Date today year + 5)! !

WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAViewer class methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:13'!
on: aPresenter
	^ self new presenter: aPresenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
buttons
	^ #(save)! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
model
	^ presenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:13'!
presenter: aPresenter
	presenter _ aPresenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:12'!
renderContentOn: html
	html heading: presenter displayString level: 3.
	super renderContentOn: html! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:17'!
renderCssOn: html
	html attributes rows: 20; cols: 80.
	html textAreaWithValue: presenter style callback:
		[:css |
		presenter class compile: 'style ^ ', css printString]! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
rows
	^ #(css)! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:23'!
save
	! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:22'!
script
	^ 'self.opener.location=self.opener.location'! !

WAFormDialog subclass: #WANoteDialog
	instanceVariableNames: 'note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:48'!
buttons
	^ #(ok cancel)! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:48'!
cancel
	self answer: nil! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:46'!
ok
	self answer: note! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:45'!
renderDialogOn: html
	html cssId: 'dialog-note'.
	html textAreaWithValue: note callback: [:v | note _ v].! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:50'!
style
	^ ' 
	#dialog-note {width: 80%; height: 200px}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WAComponent subclass: #WAFrameComponent
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

WAFrameComponent subclass: #WAAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAAllTests commentStamp: 'sd 11/28/2004 14:42' prior: 0!
If you want to see these examples:

/seaside/config app:
- add a new application named "tests"
- choose WAAllTests as the root component
!

!WAAllTests class methodsFor: 'testing' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAAllTests class methodsFor: 'initialize' stamp: 'lr 11/29/2004 15:55'!
initialize
	self registerAsApplication: 'alltests'.! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: 'avi 8/23/2005 12:18'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAInputTest new label: 'Input';
		add: WAHtmlTest new label: 'Html';
		add: WAEncodingTest new label: 'Encoding';
		add: WAErrorTest new label: 'Error';
		add: WAExceptionTest new label: 'Exception';
		add: WAClosureTest new label: 'Closure';
		add: WATransactionTest new label: 'Transaction';
		add: WAUploadTest new label: 'Upload';
		add: (WAParentTest new parent: self) label: 'Parent';
		add:  WAPathTest new label: 'Path';
		add: WATaskTest new label: 'Task';
		add: WACookieTest new label: 'Cookies';
		add: WACallbackTest new label: 'Callbacks';
		add: WACanvasTest new label: 'Canvas';
		add: WAImageTest new label: 'Images';
		add: WAHomeTest new label: 'Home';
		add: WACacheTest new label: 'Cache';
		add: WADefaultFormTest new label: 'Default Form';
		add: WALinkSubmitTest new label: 'Submit';
		yourself)! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:38'!
renderContentOn: html
	html heading: 'Test Components'.
	html render: contents! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:45'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Seaside Tests: ', contents selection displayString! !

!WAFrameComponent class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 20:01'!
on: aComponent
	^ self new contents: aComponent! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
children
	^ Array with: contents! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
contents
	^ contents! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:56'!
contents: aComponent
	contents _ aComponent! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
renderContentOn: html
	html render: contents! !

WAFrameComponent subclass: #WAPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
initialize
	self contents: WACounter new! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 12:06'!
renderContentOn: html
	html anchorWithName: contents count.
	html render: contents.! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 11:58'!
updateUrl: aUrl
	aUrl addToPath: contents count displayString.
	aUrl fragment: contents count displayString.! !

WAFrameComponent subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:14'!
renderContentOn: html
	| data |
	data _ SeasidePlatformSupport profileSendsDuring: [html render: contents].
	html horizontalRule.
	html preformatted: data.! !

WAFrameComponent subclass: #WAToolFrame
	instanceVariableNames: 'showHalos processTime renderTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAToolFrame class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:26'!
on: aComponent
	^ self new contents: aComponent! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:23'!
actions
	^ #(configure toggleHalos)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:21'!
initialize
	showHalos _ WAStateHolder new contents: false! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:13'!
openTool: aToolClass
	self call: (aToolClass new
				root: contents;
				addDecoration: (WAWindowDecoration new title: aToolClass title);
				yourself)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 12:30'!
processCallbackStream: aCallbackStream
	processTime _ Time millisecondClockValue.
	super processCallbackStream: aCallbackStream! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 12:33'!
renderChildOn: html
	showHalos contents ifTrue: [html context debugMode].
	processTime _ processTime ifNil: [0] ifNotNil: [Time millisecondClockValue - processTime].
	renderTime _ Time millisecondsToRun: [html render: contents].
	html context clearMode.! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:21'!
renderContentOn: html 
	html divNamed: 'frameContent' with: [self renderChildOn: html].
	self renderToolbarOn: html.! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2005 11:20'!
renderToolbarOn: html
   html paragraph.
   html
       divNamed: 'toolbar'
       with:
           [html anchorWithUrl: self session newSessionUrl do: [html text: 'New Session']; space.
           self actions do:
               [:ea |
               html anchorOn: ea of: self; space].
           self tools do:
               [:ea |
               html anchorWithAction: [self openTool: ea] text: ea linkText; space].
		 html anchorWithUrl: (html context actionUrl withParameter: 'terminate' value: '1') do: 'Terminate'.
		html space.
          html anchorWithUrl: 'http://validator.w3.org/check/referer' do: 'XHTML'.
		html space.
		html text: renderTime displayString, '/', processTime displayString, ' ms'
	]! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'pmm 12/23/2005 16:23'!
style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt; z-index: 20}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	.halo {border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa}
	.halo-header {font-size: 10pt; background-color: #cccccc; margin-bottom: 4px}
	.halo-mode {float: right}
	.halo-icons {float: left}
	.halo-contents {clear: both} 
'
! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:55'!
toggleHalos
	WAHalo initialize.
	showHalos contents: showHalos contents not.
! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:52'!
tools
	^ WATool allSubclasses! !

WAComponent subclass: #WAHalo
	instanceVariableNames: 'target mode'
	classVariableNames: 'Halos'
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAHalo class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:46'!
for: aComponent
	^ Halos at: aComponent ifAbsentPut: [self new target: aComponent]! !

!WAHalo class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:46'!
initialize
	Halos _ SeasidePlatformSupport weakDictionaryOfSize: 20.
! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:48'!
findStyles
	| context |
	context _ WARenderingContext new
				document: WAStyleCollector new;
				actionUrl: WAUrl new;
				request: self session currentRequest.
	self target renderWithContext: context.
	^ String streamContents:
		[:s |
		context document styles do: [:ea | s nextPutAll: ea; space]]! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 18:06'!
initialize
	mode _ WAStateHolder new contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:48'!
render: html
	self target renderContentOn: html! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:49'!
renderContentOn: html
	| haloHtml |
	haloHtml := self rendererClass 
					context: html context 
					callbacks: html callbacks. 
	haloHtml divClass: 'halo' with: [
		haloHtml divClass: 'halo-header' with: [
			haloHtml divClass: 'halo-icons' with: [
			haloHtml divClass: 'halo-mode' with: [
			haloHtml text: '['.
			haloHtml anchorWithAction: [self renderMode] text: 'R'.
			haloHtml text: ' | '.
			haloHtml anchorWithAction: [self sourceMode] text: 'S'.
			haloHtml text: ']'].
			haloHtml text: self target class name.
			haloHtml space.
			self
				renderHalo: 'Halo-Debug'
				withWindow: [WABrowser fullOnClass: self target class]
				titled: 'System Browser'
				on: haloHtml.
			self
				renderHalo: 'Halo-View'
				withWindow: [WAInspector on: self target]
				titled: 'Inspector'
				on: haloHtml.
			self renderHalo: 'Halo-Paint'
				withWindow: [WAViewer on: self target]
				titled: 'Style Editor'
				on: haloHtml.
			].
		].
		haloHtml divClass: 'halo-contents' with: [self perform: mode contents with: html].
	].
	haloHtml close.
	html close.

! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 13:22'!
renderHalo: iconKey withAction: aBlock on: html
	html
		anchorWithAction: aBlock
		text:  [html imageWithForm: (ScriptingSystem formAtKey: iconKey)].
! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 17:56'!
renderHalo: iconKey withWindow: componentBlock titled: aString on: html
	html attributes at: 'title' put: aString.
	html attributes at: 'label' put: aString.
	self
		renderHalo: iconKey
		withAction: [WARenderLoop new call: (componentBlock value
												addDecoration: (WAWindowDecoration new title: aString);
												yourself)]
		on: html
! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 4/16/2004 17:33'!
renderMode
	mode contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:48'!
source: html
	| context haloHtml | 
	haloHtml := self rendererClass
					context: html context
					callbacks: html callbacks. 
	context := haloHtml context copy.	
	context clearMode.
	context document: (WAPrettyPrintedDocument renderer: haloHtml).
	haloHtml divClass: 'halo-source' with: [self target renderWithContext: context]. 
	haloHtml close. ! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 18:07'!
sourceMode
	mode contents: #source:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:54'!
target
	^ target! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:54'!
target: aComponent
	target _ aComponent! !

WAComponent subclass: #WAHomeTest
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHomeTest methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:53'!
children
	^ Array with: main! !

!WAHomeTest methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:52'!
initialize
	main _ WATaskTest new.
	! !

!WAHomeTest methodsFor: 'as yet unclassified' stamp: 'avi 10/19/2004 15:53'!
renderContentOn: html
	html anchorWithAction: [main home] text: 'Home'.
	html div: main! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:42'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:43'!
initialize
	message _ 'Hello world!!'.
	booleanList _ #(a b c d) collect: [:k | k -> ((Array with: true with: false) atRandom)].
	number _ 10 atRandom.! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:58'!
renderCheckboxesOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc |
			html text: assoc key; space.
			html checkboxWithValue: assoc value callback: [:b | assoc value: b].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'left' with: [self perform: selB with: html]
		]]
! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:58'!
renderRadioButtonsOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc | |group|
			group _ html radioGroup.
			html text: assoc key; space.
			html radioButtonInGroup: group selected: assoc value callback: [assoc value: true].
			html radioButtonInGroup: group selected: assoc value not callback: [assoc value: false].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:58'!
renderSelectsOn: html
		html text: number.
		html paragraph.
		html form: [
			html selectFromList: (1 to: 10) selected: number callback: [:i | number _ i].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:58'!
renderSubmitButtonsOn: html
		html text: number.
		html paragraph.
		html form: [
			(1 to: 10) do:
				[:i |
				html submitButtonWithAction: [number _ i] text: i.
				html space]
		]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:59'!
renderTextAreaOn: html
		html form: [
			html text: message.
			html paragraph.
			html textAreaWithValue: message callback: [:v | message _ v].
			html break; submitButton.
		]! !

!WAHtmlTest methodsFor: 'rendering' stamp: 'ab 10/8/2002 20:06'!
renderTextInputOn: html
		html form: [
			html text: message.
			html paragraph.
			html textInputWithValue: message callback: [:v | message _ v].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:07'!
renderZ: html
	html space! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 11/23/2002 12:19'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

WAComponent subclass: #WAImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAImageTest methodsFor: 'as yet unclassified' stamp: 'avi 9/2/2004 14:38'!
renderContentOn: html
	html form: [
		html submitButtonWithAction: [self inform: 'ok'] image: (ScriptingSystem formAtKey: 'Halo-Debug')]! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:41'!
default: aString
	value _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
label
	^ label ifNil: [label _ 'OK']! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:10'!
label: aString
	label _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'avi 12/12/2004 13:07'!
renderContentOn: html
	html form: [
		html defaultAction: [self answer: value].
		html textInputWithValue: value callback: [:v | value _ v].
		html space.
		html submitButtonWithText: self label.
	]! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAInputTest class methodsFor: 'example' stamp: 'sd 11/28/2004 15:43'!
example

	^ self new! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString
	^emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString: anObject
	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction
	^fraction! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction: anObject
	fraction := anObject! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 23:04'!
initialize
	nilString _ nil.
	emptyString _ ''.
	integer _ 42.
	fraction _ 1/3.! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer
	^integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer: anObject
	integer := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString
	^nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString: anObject
	nilString := anObject! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:38'!
renderContentOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString].
		].
		html submitButton.
	]
! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAInspector class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 18:18'!
canInspect: anObject
	^ [
	anObject isNumber or: [(Array with: nil with: true with: false) includes: anObject]
	] on: Error do: [ :ex | false ].! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:34'!
children
	^ Array with: path! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'pmm 7/4/2005 15:37'!
evaluate: aString
	^self object class evaluatorClass new
		evaluate: aString
		in: nil
		to: self object.! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:11'!
initialize
	path _ WAPath new! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'pmm 7/4/2005 15:38'!
renderContentOn: html 
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash displayString; break; break.
	self renderMembersOn: html.
	self renderEditAreaOn: html.! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'pmm 7/4/2005 16:03'!
renderEditAreaOn: html
	| input |
	input := ValueHolder new.
	html break.
	html form: [
		html attributeAt: 'rows' put: 6.
		html attributeAt: 'cols' put: 60.
		html
			textAreaWithValue: ''
			callback: [ :value |
				input contents: value].
		html break.
		html
			submitButtonWithAction: [
				self evaluate: input contents ]
			text: 'do it'.
		html
			submitButtonWithAction: [
				self inform: (self evaluate: input contents) ]
			text: 'print it'.
		html
			submitButtonWithAction: [
				WARenderLoop new call:
					((WAInspector on: (self evaluate: input contents))
					addDecoration: (WAWindowDecoration new title: 'Inspector');
					yourself) ]
			text: 'inspect it'. ].! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:28'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html bold: 'Members: '.
	html attributeAt: 'border' put: 1.
	html table: 
			[members associationsDo: 
					[:assoc | 
					self 
						renderRowForObject: assoc value
						named: assoc key
						on: html]]! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'pmm 7/4/2005 16:03'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchorWithAction: [self chooseObject: anObject named: aString] text: aString ]
		].
		html tableData: [
			html attributeAt: 'style' put: 'margin-bottom: 0pt'.
			html form: [
				html attributeAt: 'rows' put: 1.
				html attributeAt: 'cols' put: 30.
				html
					textAreaWithValue: (anObject printStringLimitedTo: 100)
					callback: [ :value |
						self object
							instVarNamed: aString
							put: (self evaluate: value) ].
				html submitButtonWithAction: [] text: 'accept' ] ] ]! !

WAComponent subclass: #WALibraryBrowser
	instanceVariableNames: 'group selector library hits search'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:50'!
find: aString
	| inst |
	self libraries do:
		[:ea |
		inst _ ea new.
		ea selectors do: 
			[:sel |
			((inst perform: sel) includesSubString: aString)
				ifTrue: [(hits at: (Array with: ea with: sel) ifAbsentPut: [SortedCollection new]) add: aString]]]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:49'!
findAll: aString
	hits _ Dictionary new.
	(aString findTokens: ' ') do: [:ea | self find: ea].
	hits isEmpty ifFalse: [self goto: self orderedHits first]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:51'!
goto: anArray
	library _ anArray first.
	selector _ anArray second! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:37'!
hits
	^ hits ifNil: [#()]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:28'!
libraries
	^ (WAStyleLibrary subclasses, WAScriptLibrary subclasses) asSortedCollection: [:a :b | a name <= b name]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:28'!
library
	^ library! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:28'!
library: aLibraryClass
	library _ aLibraryClass.
	selector _ nil.! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:50'!
orderedHits
	^ hits keys asSortedCollection: [:a :b | (hits at: a) size >= (hits at: b) size]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:29'!
renderColumnsOn: html
	html attributes
			size: 10;
			submitOnChange.
		html
			selectFromList: self libraries
			selected: self library
			callback: [:v | self library: v].
		html attributes
			size: 10;
			submitOnChange.
		html
			selectFromList: self selectors
			selected: self selector
			callback: [:v | self selector: v].! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:58'!
renderContentOn: html
	html divClass: 'stylebrowser-columns' with: [
		html form: [self renderColumnsOn: html].
	].
	html divClass: 'stylebrowser-search' with: [
		html form: [
			html textInputWithValue: search callback: [:v | search _ v].
			html space.
			html submitButtonWithAction: [self findAll: search] text: 'Search'.
		].
		html list: self orderedHits do:
			[:pair |
			self renderHit: pair on: html].
	].
	html divClass: 'stylebrowser-editor' with: [
		html form: [
			self renderEditorOn: html.
			html paragraph.
			html submitButtonWithAction: [self save] text: 'Save'.
		]
	].! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 10:58'!
renderEditorOn: html
	html attributes
		rows: 20;
		cols: 80.
	html textAreaWithValue: self string callback: [:v | self string: v].
! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:54'!
renderHit: anArray on: html
	| text |
	text _ String streamContents:
			[:s |
			s nextPutAll: anArray first name.
			s nextPutAll: '>>'.
			s nextPutAll: anArray second.
			s space.
			s nextPutAll: '('.
			(hits at: anArray)
				do: [:ea | s nextPutAll: ea]
				separatedBy: [s nextPutAll: ', '].
			s nextPutAll: ')'].
	html anchorWithAction: [self goto: anArray] text: text.
	! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 5/24/2004 14:55'!
save! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 11:08'!
search: aString
	search _ aString.
	self findAll: search! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 5/24/2004 14:46'!
selector
	^ selector! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:32'!
selector: aSymbol
	(library selectors includes: aSymbol) ifTrue: [selector _ aSymbol]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 00:28'!
selectors
	^ library ifNil: [#()] ifNotNil: [library selectors]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 10:58'!
string
	^ self selector ifNotNilDo: [:s | library new perform: s]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 10:58'!
string: aString
	self selector ifNotNilDo:
		[:sel |
		library compile: (sel, '
	^ ', aString printString)]! !

!WALibraryBrowser methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 18:32'!
style
	^ '
	.stylebrowser-search {float: left}
	.stylebrowser-columns {float: left}
	.stylebrowser-columns select {width: 250px}
	.stylebrowser-editor {clear: both}
	'! !

WAComponent subclass: #WALinkSubmitTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALinkSubmitTest methodsFor: 'as yet unclassified' stamp: 'avi 4/2/2005 23:42'!
initialize
	count _ 0! !

!WALinkSubmitTest methodsFor: 'as yet unclassified' stamp: 'avi 4/2/2005 23:42'!
renderContentOn: html
	html attributes name: 'myform'.
	html form:
		[html textInputWithValue: count callback: [:v | count _ v].
		html break.
		html anchorWithAction: [count _ count - 1] text: '--' submitFormNamed: 'myform'.
		html space.
		html anchorWithAction: [count _ count + 1] text: '++' submitFormNamed: 'myform']! !

WAComponent subclass: #WALoginDialog
	instanceVariableNames: 'username password authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:55'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:56'!
cancel
	self answer: nil! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:56'!
login
	(authenticator verifyPassword: password forUser: username) ifTrue: [self answer: username]! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 10/25/2003 14:24'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWithLabel: 'Username:' column: [html textInputWithValue: username callback: [:v | username _ v]].
			html tableRowWithLabel: 'Password:' column: [html passwordInputWithCallback: [:v | password _ v]].
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #login of: self.
				html space.
				html submitButtonOn: #cancel of: self] span: 2.
		]
	]! !

WAComponent subclass: #WALotsaLinks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WALotsaLinks methodsFor: 'as yet unclassified' stamp: 'avi 5/3/2005 21:27'!
renderContentOn: html
	html list: (1 to: 5000) do:
		[:ea |
		html anchorWithAction: [self inform: ea] text: ea]! !

WAComponent subclass: #WAMemoryUse
	instanceVariableNames: 'instances sizes table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:36'!
buildTable
	^ WATableReport new
			rowPeriod: 1;
			rowColors: #('lightgrey' 'white');
			rows: sizes keys asSortedCollection;
			columns: 
				(Array with: (WAReportColumn selector: #yourself title: 'Class')
				with: ( WAReportColumn new
					title: 'Instances';
					valueBlock: [:ea | instances at: ea])
				with:
				 (WAReportColumn new
					title: 'Total Size';
					valueBlock: [:ea | sizes at: ea]))
! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:15'!
children
	^ Array with: table! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:33'!
renderContentOn: html
	html bold: self totalInstances displayString, ' instances in ', self totalSizeString.
	html render: table.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ac 9/23/2005 13:29'!
root: anObject
	|segment results|
	segment _ ImageSegment new copyFromRoots: (Array with: anObject) sizeHint: 100000.
	results _ segment doSpaceAnalysis.
	instances _ results first.
	sizes _ results second.
	table _ self buildTable.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size _ self totalSize.
	unit _ 'bytes'.
	size > 1024 ifTrue:
		[size _ size / 1024.
		unit _ 'kB'.
		size > 1024 ifTrue:
			[size _ size / 1024.
			unit _ 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAMiniCalendar class methodsFor: 'as yet unclassified' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'as yet unclassified' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'avi 10/24/2003 14:38'!
canSelect: aDate
	^ canSelectBlock notNil and: [canSelectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock _ aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 12/12/2004 13:39'!
date: aDate
	date contents: aDate.
	month contents: aDate month! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'avi 10/23/2003 22:56'!
initialize
	month _ WAStateHolder new contents: Date today month.
	date _ WAStateHolder new.! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 22:56'!
month: aMonth
	^ month contents: aMonth! !

!WAMiniCalendar methodsFor: 'private' stamp: 'mbany 4/14/2005 12:44'!
monthHeading
	^ self month name, ' ', self month year displayString! !

!WAMiniCalendar methodsFor: 'private' stamp: 'dc 12/29/2005 11:41'!
months
	^ (1 to: 12) collect: [:i | Month month: i year: self year]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'avi 10/25/2003 13:14'!
renderCellForDate: aDate on: html
	html tableData: [
		aDate month = self month ifTrue:
			[html cssClass: (self date = aDate ifTrue: ['calendarArchiveDate']).
			html span: [
			(self canSelect: aDate)
				ifTrue: [html anchorWithAction: [self select: aDate] text: aDate dayOfMonth]
				ifFalse: [html text: aDate dayOfMonth]
			]]
	]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dc 12/29/2005 11:58'!
renderContentOn: html
	html divClass: 'calendar' with: [
	html spanClass: 'calendarCaption' with:  [self renderMonthHeadingOn: html].
	html table: [
		html cssClass: 'calendarTitle'; tableRow: [
			self weekDays do: [:ea | html tableData: ea].
		].
		self month weeksDo: [:week | self renderRowForWeek: week on: html].
	].
	self renderMonthNavigationOn: html.
	html space; space.
	self renderYearNavigationOn: html.
	]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dc 12/29/2005 12:01'!
renderMonthHeadingOn: html
	html form: [
		html selectFromList: self months selected: self month callback: [:selectedMonth | self month: selectedMonth] labels: [:eachMonth | eachMonth name].
		html textInputWithValue: self year callback: [:choosedYear | self  year: choosedYear] maxLength: 4.
		html submitButtonWithText: 'Refresh'].! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'avi 10/25/2003 13:14'!
renderMonthNavigationOn: html
	html spanClass: 'calendarPrevious' with: [
		html
			anchorWithAction: [self month: self month previous]
			text: (self month previous name first: 3).
	].
	html space.
	html spanClass: 'calendarNext' with: [
		html
			anchorWithAction: [self month: self month next]
			text: (self month next name first: 3).
	]
	! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'avi 10/23/2003 14:23'!
renderRowForWeek: aWeek on: html
	html tableRow: [
		aWeek do: [:ea | self renderCellForDate: ea on: html].
	]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'dc 12/29/2005 11:51'!
renderYearNavigationOn: html
	html spanClass: 'calendarPrevious' with: [
		html
			anchorWithAction: [self year: self year - 1]
			text: (self year - 1) ].
	html space.
	html spanClass: 'calendarNext' with: [
		html
			anchorWithAction: [self year: self year + 1]
			text: (self year + 1) ].
	! !

!WAMiniCalendar methodsFor: 'action' stamp: 'avi 10/23/2003 17:40'!
select: aDate
	self date: aDate.
	selectBlock ifNotNil: [selectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock _ aBlock! !

!WAMiniCalendar methodsFor: 'private' stamp: 'avi 10/23/2003 14:25'!
weekDays
	^ (1 to: 7) collect: [:i | (Date nameOfDay: i) first: 3]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:44'!
year
	^ self month year! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dc 12/29/2005 11:51'!
year: anInteger
	self month: (Month month: self month monthIndex year: anInteger)! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^true! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:08'!
initialize
	self registerAsApplication: 'multi'! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 21:50'!
children
	^ counters! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
initialize
	counters _ (1 to: 5) collect: [:i | WACounter new]! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
renderContentOn: html
	counters 
		do: [:ea | html render: ea]
		separatedBy: [html horizontalRule]! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:28'!
initialize
	selection _ WAStateHolder new! !

!WANavigation methodsFor: 'query' stamp: 'mbany 4/14/2005 12:12'!
labelForOption: anObject
	^ anObject displayString! !

!WANavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 5/21/2004 18:15'!
renderContentOn: html
	html divClass: 'kalsey' with: [
		html divClass: 'navigation-options' with: [self renderOptionsOn: html].
		html divClass: 'navigation-content' with: [self renderSelectionOn: html].
	]! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 5/21/2004 18:17'!
renderOptionsOn: html
	html
		unorderedList: self options
		selected: self selection
		callback: [:v | self select: v]
		labels: [:ea | self labelForOption: ea]
! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selectionChanged
	! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WASimpleNavigation commentStamp: 'lr 11/29/2004 16:30' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:!

!WASimpleNavigation class methodsFor: 'example' stamp: 'lr 11/29/2004 16:32'!
example
	^self new
		add: WACounter example label: 'Counter'; 
		add: WAPath example label: 'Path';
		select: 'Counter';
		yourself.! !

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:27'!
children
	^Array with: self selectedComponent.! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components _ OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/16/2004 19:34'!
options
	^ components collect: [:ea | ea key]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'avi 3/15/2004 19:25'!
selectedComponent
	^ (components detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector mOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector _ aSymbol! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:13'!
initialize
	actionsSelector _ #actions! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:33'!
owner: anObject
	mOwner _ anObject! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:43'!
renderContentOn: html
	self actions do:
		[:symbol |
		symbol numArgs = 0
			ifTrue: [self renderLink: symbol on: html]
			ifFalse: [self renderInput: symbol on: html]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:45'!
renderInput: aSymbol on: html
	html form: [
		html bold: aSymbol capitalized.
		html space.
		html textInputWithValue: '' callback: [:v | self target perform: aSymbol with: v].
	]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:44'!
renderLink: aSymbol on: html
	html anchorOn: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:33'!
target
	^ mOwner activeComponent! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent _ aComponent! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAPath commentStamp: '<historical>' prior: 0!
I represent a path navigation such as the one that is displayed on the top of the web inspector when you toggle on the halos.

Here is an example of path:

	xxx >> yyy >> zzz

Useful methods are 
	- #currentSegment returns zzz
	- pushSegment: anObject name: 'lulu'!

!WAPath class methodsFor: 'example' stamp: 'lr 11/29/2004 16:24'!
example
	^self new 
		pushSegment: 123 name: 'xxx'; 
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself.! !

!WAPath methodsFor: 'behavior' stamp: 'lr 11/29/2004 16:26'!
choose: anAssociation
	"Install a new stack of navigation from the old one and the specified association."
	
	| newStack |
	newStack := Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack := newStack contents. ^ self]]
! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialize' stamp: 'ab 5/31/2003 15:09'!
initialize
	stack _ #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack _ stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'sd 11/28/2004 18:31'!
renderContentOn: html

	stack isEmpty ifTrue: [^ self].	
		
	html divNamed: 'path' with: [
		stack allButLast do:
			[:assoc |
			html anchorWithAction: [self choose: assoc] text: assoc key.
			html text: ' >> '].
		
		html bold: stack last key].! !

WAComponent subclass: #WAPopupTest
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPopupTest methodsFor: 'initialize-release' stamp: 'mjr 8/17/2005 17:45'!
initialize
	url := 'http://www.seaside.st'! !

!WAPopupTest methodsFor: 'rendering' stamp: 'mjr 8/17/2005 17:45'!
renderContentOn: html

	html form: [
		html text: 'URL:'.
		html space.
		html textInputWithValue: url callback: [:v | url _ v].
		html submitButtonWithText: 'Update'
	].
	html anchorWithPopupUrl: url
		extent: 400@400
		text: 'popup'.
	html space.
	html text: '(', url, ')'! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReport methodsFor: 'initialize' stamp: 'ab 10/26/2002 22:29'!
initialize
	rows _ #().
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows _ anArray! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns _ anArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'jf 2/18/2004 15:45'!
renderColumn: aColumn row: aRow on: html
	|text|
	text _ aColumn textForRow: aRow.
	text isEmpty ifTrue: [text _ ' '].
	html tableData: [
		aColumn canChoose
			ifFalse: [html text: text]
			ifTrue: [html anchorWithAction: [self chooseRow: aRow column: aColumn] text: text]
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 11/12/2002 14:32'!
renderFooterForColumn: aColumn on: html
	html tableHeading: [ html text: (aColumn totalForRows: rows)]
! !

!WATableReport methodsFor: 'rendering' stamp: 'JF 2/3/2003 00:01'!
renderHeaderForColumn: aColumn on: html
	html tableHeading: [
		aColumn canSort
			ifTrue: [
				html anchorWithAction: [self sortColumn: aColumn] text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderRowNumber: index item: row on: html
	html attributeAt: 'bgcolor' put: (self colorForRowNumber: index).
	html tableRow: [ columns do: [:ea | self renderColumn: ea row: row on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableFooterOn: html
	html tableRow: [ columns do: [ :ea | self renderFooterForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableHeaderOn: html
	html tableRow: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors _ colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod _ aNumber! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r _ self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'AC 1/31/2003 11:46'!
sortColumn: anObject 
	anObject = self sortColumn
		ifTrue: [isReversed _ isReversed not]
		ifFalse: [isReversed _ false].
	sortColumn contents: anObject! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button text zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAScreenshot class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:48'!
buttonCode
	^ button = #red ifTrue: [4] ifFalse: [button = #blue ifTrue: [2] ifFalse: [1]]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:48'!
click: aPoint
	|evt|
	evt _ Sensor createMouseEvent.
	evt at: 3 put: aPoint x.
	evt at: 4 put: aPoint y.
	evt at: 5 put: self buttonCode.
	Sensor processEvent: evt.	
	evt at: 5 put: 0.
	Sensor processEvent: evt.
	button _ #red.! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:18'!
form
	^ zoom ifFalse: [Display copy] ifTrue: [self topWindow imageForm]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:16'!
initialize
	button _ #red.
	zoom _ false! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:42'!
offset
	^ zoom ifTrue: [self topWindow position] ifFalse: [0@0]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:42'!
renderContentOn: html
	| group |
	html table: [
		html tableRow: [
		html tableData: [
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Button: '.
	
				group _ html radioGroup.
				#(red yellow blue) do:
					[:ea |
					html attributes at: 'bgcolor' put: ea.
					html tableData: [
						html radioButtonInGroup: group selected: (button = ea) callback: [button _ ea].
					]].
				html tableData: [html submitButtonWithText: 'Set']
			]
		]
	].
	].
	html tableData: [
	html anchorWithAction: [self toggleZoom] text: self toggleZoomText.	
	].
	html tableData: [
	html anchorWithAction: [self toggleUIProcess] text: self toggleUIText.
	]]].
	html imageMapWithAction: [:pt | self click: pt + self offset] form: self form.
	html horizontalRule.
	! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: ['Suspend UI Process']
		ifTrue: ['Resume UI Process']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:15'!
toggleZoom
	zoom _ zoom not! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:15'!
toggleZoomText
	^ zoom ifTrue: ['Zoom out'] ifFalse: ['Zoom in']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:18'!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

WAComponent subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WASelection methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:13'!
initialize
	items _ #().
	labelBlock _ [:ea | ea displayString].! !

!WASelection methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items _ aCollection! !

!WASelection methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock _ aBlock! !

!WASelection methodsFor: 'as yet unclassified' stamp: 'avi 7/5/2004 20:25'!
renderContentOn: html
	html list: items do:
		[:ea |
		html anchorWithAction: [self answer: ea] text: (labelBlock value: ea)]! !

WAComponent subclass: #WASpotProfileReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WASpotProfileReport methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 13:06'!
renderContentOn: html
	html table:
		[html tableHeadings: #('Selector' 'Total Time' 'Time/Req' 'Readings/Req' 'Time/Reading' '').
		WASpotProfiler profilers keysAndValuesDo:
			[:sel :prof |
			html tableHeading: sel.
			prof allReadings isEmpty ifFalse:
				[html tableData: prof totalTime.
				html tableData: prof averageRequestTime.
				html tableData: prof averageReadingsPerRequest.
				html tableData: prof averageReadingTime.
				html tableData: [html anchorWithAction: [prof reset] text: 'reset']]]]! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStore commentStamp: 'avi 1/1/2004 10:06' prior: 0!
This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.!

!WAStore class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
initialize
	self registerAsApplication: 'store'! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: task! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:59'!
initialize
	task _ WAStoreTask new.! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:50'!
renderContentOn: html
	html cssId: 'banner'.
	html table: [
		html tableRowWith: [
			html divNamed: 'title' with: self title.
			html divNamed: 'subtitle' with: self subtitle.
		]
	].
	html divNamed: 'body' with: task! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:11'!
style
	^ '
	body {margin: 0px; font-family: sans-serif}
	#banner {width: 100%}	
	#banner tr {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#body {padding: 5px}
	.validation-error {color: red; font-size: 9pt; padding: 5px}
	'
! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
title
	^ 'sushiNet'! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartConfirmation commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for confirming the contents of a WAStoreCart.  The caller must provide a cart instance with #cart: .  When called, it will display a summary of the items in the cart, along with two buttons: "Proceed with checkout" and "Modify cart".  Answers true if the user presses the first button, false if the user presses the seecond.  Used by WAStoreTask>>confirmContentsOfCart.!

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:35'!
cart: aCart
	cart _ aCart! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:16'!
renderContentOn: html
	html attributes border: 0.
	html table: [
		html tableHeadings: #(Item Price Count Total).
		cart countsAndItems do:
			[:assoc | |count item|
			count := assoc key.
			item := assoc value.
			html tableRow: [
				html cssClass: 'item-title'.
				html tableData: item title.
				html cssClass: 'item-price'.
				html tableData: item price printStringAsCents.
				html cssClass: 'item-count'.
				html tableData: count displayString.
				html cssClass: 'item-price'.
				html tableData: (item price * count) printStringAsCents.
			]].
		html cssClass: 'cart-total'.
		html tableRowWith: cart totalPrice printStringAsCents span: 4.
	].
	html paragraph.
	html form: [
		html submitButtonWithAction: [self answer: true] text: 'Proceed with checkout'.
		html break.
		html submitButtonWithAction: [self answer: false] text: 'Modify my order'.
	]! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'mb 2/17/2005 18:16'!
style
	^'
.item-title {	text-align: left; padding: 0 40px 0 0;}
.item-count { text-align: right;}
.item-price { text-align: right; padding: 0 0 0 10px;}
.cart-total { text-align: right; font-weight: bold; height: 50px;}
'! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartView commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component for displaying and modifying a WAStoreCart.  Intended to be embedded rather than called.  The parent must provide a cart instance with #cart:.  Displays a list of items in the cart, and allows individual items to be removed.  Used by WAStoreFillCart.!

!WAStoreCartView methodsFor: 'accessing' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart _ aCart! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'avi 12/8/2003 14:03'!
renderContentOn: html
	cart hasItems ifFalse: [^ self].
	html divNamed: 'cart' with: [
		html small: [html bold: 'Your cart:'].
		html table: [
			cart countsAndItems do:
				[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
			html spacerRow.
			html
				tableRowWith: ''
				with: ''
				with: [html bold: cart totalPrice printStringAsCents].
		]
	]! !

!WAStoreCartView methodsFor: 'rendering' stamp: 'mbany 4/14/2005 12:06'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString _ (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber displayString, ') '].
	html
		tableRowWith: [html anchorWithAction: [cart remove: anItem] text: '-']
		with: countString, anItem title 
		with: (aNumber * anItem price) printStringAsCents! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreFillCart commentStamp: 'avi 1/1/2004 10:10' prior: 0!
This component provides the main UI for browsing the store inventory and filling the cart.  The caller must provide a shopping cart instance with #cart:.  The component presents a navigation bar with options to browse and search on the left, and embeds a WACartView showing the cart contents on the right.  In the middle is initially embedded a WAStoreInfo.  Browsing and searching will replace this with a stock WABatchSelection component for listing items (see #displatItems:), or a WAStoreItemView for displaying individual items.  This answers back to the caller when the user chooses "checkout" from the nav bar.!

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
cart: aCart
	cart _ aCart.
	cartView cart: aCart.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: cartView with: main! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
displayItem: anItem
	main call: (WAStoreItemView new item: anItem; cart: cart)! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:25'!
displayItems: aCollection
	| list |
	aCollection size = 1 ifTrue: [^ self displayItem: aCollection first].
	list _ WABatchSelection
			 items: aCollection
			 link: #title
			 text: #subtitle.
	[self displayItem: (main call: list)] repeat
	! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:53'!
initialize
	main _ WAStoreInfo new.
	cartView _ WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:00'!
renderContentOn: html
	html table: [
"		html tableRowWith: trail span: 3."
		html tableRow: [
			html cssId: 'nav'; tableData: [self renderNavBarOn: html].
			html cssId: 'main'; tableData: main.
			html cssId: 'side'; tableData: cartView.
		]
	]! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:14'!
renderNavBarOn: html
	html form: [
		html bold: 'Search:'.
		html space.
		html textInputWithValue: '' callback: [:v | self search: v].
	].
	html anchorWithAction: [self browse] text: 'Browse'.
	cart hasItems ifTrue: 
		[html break.
		html anchorWithAction: [self checkout] text: 'Checkout']! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
search: aString
	| results |
	results _ self inventory findItem: aString.
	results isEmpty
		ifTrue: [main inform: 'No items match ', aString printString]
		ifFalse: [self displayItems: results].! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 15:33'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreInfo commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component that displays simple informative text about this example.  Used by WAStoreFillCart.!

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 22:00'!
renderContentOn: html
	html html: self text! !

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:29'!
text
	^
'Welcome to the sushiNet online store.
<p>
This is a sample Seaside application.
<p>
Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreItemView commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.!

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
cart: aCart
	cart _ aCart! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item _ anItem! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 01:29'!
renderContentOn: html
	html heading: item title.
	html heading: item subtitle level: 3.
	html paragraph: item description.
	html italic: item price printStringAsCents.
	html form: [
		html submitButtonWithAction: [self addToCart] text: 'Add To Cart'.
		html space.
		html submitButtonWithAction: [self answer] text: 'Done'.
	]! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 01:01'!
updateUrl: aUrl
	aUrl addToPath: item name! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WATask commentStamp: '<historical>' prior: 0!
I am a subclass of WAComponent, specialized for defining workflow.  The difference between a task and a component is the following:

Both of them are reusable, embeddable, callable pieces of user interface. A component has state (instance variables), behavior (it may change its state, and it may also choose to display other components with #call:), and appearance (it renders HTML). A Task has only the first two - it doesn't render any HTML directly, but only through the components it calls. This is useful when what you want to encapsulate/embed/call is purely a process (show this component, then this one, then this one).

The key method for WATask is #go - as soon as a task is displayed, this method will get invoked, and will presumably #call: other components.

In terms of implementation, you can think of a WATask in the following way: it is a component which renders two things:
- a link whose callback invokes the #go method
- a header that immediately redirects to the URL of that link
!

WATask subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACookieTest methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:54'!
go
	[self session checkForCookies]
		whileFalse: [self inform: 'You must have cookies enabled to proceed.'].
	self session redirectWithCookie:
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom displayString;
			expireIn: (Duration seconds: 60);
			yourself).
	self inform: self session currentRequest cookies displayString.! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExceptionTest methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e displayString]! !

WATask subclass: #WAOnceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:47'!
go
	1 to: 3 do: [:i | self inform: i displayString].
! !

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:41'!
initialize
	self addDecoration: WAOnce new! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreTask commentStamp: 'avi 1/1/2004 10:19' prior: 0!
This task models the main application flow of the store example.  Most of the other components in the example are called from here.  The flow is defined by the #go method.  After creating a WAStoreCart instance, this calls WAStoreFillCart to allow the user to add items to it.  It then calls WAStoreCartConfirmation, WAStoreAddressEditor, and WAStorePaymentEditor in succession for the checkout process.  Many of the components it calls are wrapped with informative messages (#withMessage:) and validation (#validateWith:).  It also makes use of WASession>>isolate: to ensure that once the checkout process starts, backtracking to modify the cart is forbidden.  Used by WAStore.!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:37'!
confirmContentsOfCart
	^ self call:
		((WAStoreCartConfirmation new cart: cart)
			addMessage: 'Please verify your order:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:28'!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:51'!
fillCart
	self call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 16:35'!
getAddressWithMessage: aString
	^ self call:
		(WAStoreAddressEditor new
			validateWith: [:a | a validate];
			addMessage: aString;
			yourself)
				! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 18:55'!
getPaymentInfo
	^ self call:
		(WAStorePaymentEditor new
			validateWith: [:p | p validate];
			addMessage: 'Please enter your payment information:';
			yourself)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 11/6/2005 00:38'!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 21:58'!
go
	| shipping billing creditCard |
	cart _ WAStoreCart new.
	self isolate:
		[[self fillCart.
		self confirmContentsOfCart]
			whileFalse].

	self isolate:
		[shipping _ self getShippingAddress.
		billing _ (self useAsBillingAddress: shipping)
					ifFalse: [self getBillingAddress]
					ifTrue: [shipping].
		creditCard _ self getPaymentInfo.
		self shipTo: shipping billTo: billing payWith: creditCard].

	self displayConfirmation.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:04'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"no-op"! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:44'!
useAsBillingAddress: anAddress
	^ self confirm: 'Do you wish to use ', anAddress street printString, ' as your billing address?'! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

!WATask methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 6/2/2004 21:02'!
renderContentOn: html
	self session redirectTo: (html urlForAction: [[self answer: self go] repeat])! !

WATask subclass: #WATool
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WATool subclass: #WAMemoryUseTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Memory Use'! !

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'Memory Use'! !

!WAMemoryUseTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAMemoryUse new root: self session)! !

WATool subclass: #WAProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
linkText
	^ 'Profile'! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
title
	^ 'Profiler'! !

!WAProfilerTool methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:13'!
go
	self call: (WAProfiler new contents: root)! !

WATool subclass: #WASpotProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WASpotProfilerTool class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 13:00'!
linkText
	^ 'Spot'! !

!WASpotProfilerTool class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 13:00'!
title
	^ 'Spot Profiler'! !

!WASpotProfilerTool methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 13:00'!
go
	self call: (WASpotProfileReport new)! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
linkText
	^ self name! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

!WATool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:42'!
root: aComponent
	root _ aComponent! !

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATransactionTest methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 15:16'!
go
	self inform: 'Before parent txn'.
	self isolate: 
			[self inform: 'Inside parent txn'.
			self isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

WAComponent subclass: #WATaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATaskTest methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 14:05'!
renderContentOn: html
	html anchorWithAction: [self call: WAExceptionTest new] text: 'go'.
! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATrail class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 22:15'!
renderContentOn: html
	|last selected|
	html cssClass: 'trail'.
	html unorderedList: [
		root visiblePresentersDo: 
			[:ea |
			(ea isDecoration and: [ea isDelegation]) ifTrue:
				[(ea component respondsTo: #trailName) ifTrue:
					[last _ ea.
					html listItem: [
						html anchorWithAction: [ea remove] text: ea component trailName.
					]]]].
		selected _ last ifNil: [root] ifNotNil: [last delegate].
		(selected respondsTo: #trailName) ifTrue:
			[html listItem: selected trailName].
	]
! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root _ anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 22:16'!
style
^'	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}
	
	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }
        
	ul.trail li.first:before {
        content: " ";
        }
'! !

WAComponent subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATree class methodsFor: 'examples' stamp: 'lr 3/28/2005 21:19'!
example
	| component |
	^(component := self new)
		root: Object;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		selectBlock: [ :class | component call: (WABrowser fullOnClass: class) ];
		canSelectBlock: [ :class | class category beginsWith: (self category copyUpTo: $-) ];
		yourself.! !

!WATree class methodsFor: 'instance creation' stamp: 'lr 4/4/2005 18:13'!
root: aRootStructure selected: aStructure
	^self new
		root: aRootStructure;
		selected: aStructure;
		expandAll: (aStructure isNil
			ifTrue: [ Array new ]
			ifFalse: [ aStructure parents ]);
		childrenBlock: [ :structure | 
			structure hasChildren 
				ifTrue: [ structure children sorted ] ];
		yourself.! !

!WATree methodsFor: 'testing' stamp: 'lr 3/7/2005 17:39'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 2/19/2005 16:05'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^children isNil
		ifTrue: [ Array new ]
		ifFalse: [ children ].! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 16:03'!
collapse: aNode
	expanded remove: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 2/19/2005 11:20'!
expand: aNode
	expanded add: aNode.! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:15'!
expandAll: aCollection
	expanded addAll: aCollection.! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 16:25'!
hasChildren: aNode
	^(self childrenOf: aNode) 
		isEmpty not.! !

!WATree methodsFor: 'initialization' stamp: 'lr 3/28/2005 21:14'!
initialize
	super initialize.
	self session registerObjectForBacktracking: (expanded := Set new).
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node asLabel ].! !

!WATree methodsFor: 'testing' stamp: 'lr 2/19/2005 11:18'!
isExpanded: aNode
	^expanded includes: aNode.! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 2/19/2005 12:06'!
labelOf: aNode
	^self labelBlock value: aNode.! !

!WATree methodsFor: 'rendering' stamp: 'lr 2/19/2005 11:41'!
renderContentOn: html
	self renderTreeOn: html.! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 11:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 3/19/2005 19:46'!
renderNodeButton: aNode on: html
	| isExpanded |
	html spanClass: 'button' with: [
		(self hasChildren: aNode) ifTrue: [
			isExpanded := self isExpanded: aNode.
			self 
				renderNodeButtonLink: aNode 
				action: (MessageSend 
					receiver: self 
					selector: (isExpanded
						ifTrue: [ #collapse: ]
						ifFalse: [ #expand: ])
					argument: aNode)
				text: (isExpanded
					ifTrue: [ '-' ]
					ifFalse: [ '+' ])
				on: html ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 16:11'!
renderNodeButtonLink: aNode action: aBlock text: aString on: html
	html anchorWithAction: aBlock text: aString.! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 16:07'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 3/19/2005 19:46'!
renderNodeLabel: aNode on: html
	| label |
	self selected = aNode
		ifTrue: [ html cssClass: 'active' ].
	html spanClass: 'label' with: [
		label := self labelOf: aNode.
		(self canSelect: aNode)
			ifFalse: [ html render: label ]
			ifTrue: [
				self renderNodeLabelLink: aNode
				action: (MessageSend
					receiver: self 
					selector: #select:
					argument: aNode)
				text: label on: html ] ].! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 2/19/2005 16:12'!
renderNodeLabelLink: aNode action: aBlock text: aString on: html
	html anchorWithAction: aBlock text: aString.! !

!WATree methodsFor: 'rendering' stamp: 'lr 3/7/2005 16:30'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ].! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 3/28/2005 21:13'!
select: aNode
	(self canSelect: aNode) ifTrue: [
		self selected: aNode.
		self selectBlock isNil
			ifFalse: [ self selectBlock value: aNode ] ].! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAUploadTest methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:14'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file _ f].
		html submitButton.
	].

	file ifNotNil:
		[html anchorWithDocument: file contents mimeType: file contentType fileName: file fileName text:file fileName.
		html preformatted: file contents contents].! !

WAComponent subclass: #WAVNCController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVNCController class methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:52'!
initialize
	(Smalltalk hasClassNamed: 'RFBServer') ifTrue: [self registerAsApplication: 'vnc']! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:48'!
currentDisplay
	^ RFBServer server displayNumber asString! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:06'!
renderContentOn: html
	html heading: 'VNC Server'.
	RFBServer server
		ifNil: [self renderStartOn: html]
		ifNotNil: [self renderStopOn: html].
	html heading: 'UI Process'.
	Project uiProcess isSuspended
		ifFalse: [self renderSuspendOn: html]
		ifTrue: [self renderResumeOn: html]! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:51'!
renderResumeOn: html
	html form:
		[html text: 'UI Process is suspended.  '.
		html submitButtonWithAction: [self resume] text: 'Resume']! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:33'!
renderStartOn: html
	html form:
		[html text: 'Start VNC on display: '.
		html textInputWithValue: 0 callback: [:v | self startOn: v].
		html submitButtonWithText: 'Start']! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:46'!
renderStopOn: html
	html form:
		[html text: 'Stop VNC (running on ', self currentDisplay, ') '.
		html submitButtonWithAction: [self stop] text: 'Stop']! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:51'!
renderSuspendOn: html
	html form:
		[html text: 'UI Process is running.  '.
		html submitButtonWithAction: [self suspend] text: 'Suspend']! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:51'!
resume
	Project uiProcess resume! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:49'!
startOn: aNumber
	self resume.
	RFBServer start: aNumber! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:49'!
stop
	RFBServer stop! !

!WAVNCController methodsFor: 'as yet unclassified' stamp: 'avi 10/20/2005 23:53'!
suspend
	Project uiProcess suspend.
	self stop! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVersionUploader class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadFile
	| reader version |
	reader _ MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version _ reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadURL
	| stream version |
	stream _ url asUrl retrieveContents content asByteArray readStream .
	version _ (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:34'!
newVersion: aWorkingCopy
	| version s |
	version _ [aWorkingCopy newVersion]
				on: MCVersionNameAndMessageRequest 
				do: [:n | n resume: (Array with: n suggestedName with: '')].
	s _ RWBinaryOrTextStream on: String new.
	version fileOutOn: s.
	self session respond:
		[:u |
		u addToPath: version fileName.
		WAResponse redirectTo: u displayString].
	self session returnResponse: (WAResponse new
									contentType: 'application/octet-stream';
									nextPutAll: s contents;
									yourself)! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2004 11:24'!
renderContentOn: html
	html bold: 'Loaded versions:'.
	html list: MCWorkingCopy allManagers do:
		[:ea |
		html anchorWithAction: [self newVersion: ea] text: 'Save'.
		html space.
		html text: ea description].
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html bold: 'Load version from file: '; break.
		html fileUploadWithCallback: [:f | file _ f].
		html space.
		html submitButtonWithAction: [self loadFile] text: 'Load'.
	].
	html form: [
		html bold: 'Load version from URL: '; break.
		html attributes size: 60.
		html textInputWithValue: 'http://' callback: [:u | url _ u].
		html space.
		html submitButtonWithAction: [self loadURL] text: 'Load'.
	].
	html anchorWithAction: [self saveImage] text: 'Save Image'. ! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'ab 8/30/2003 20:55'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception fullstack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAWalkback methodsFor: 'actions' stamp: 'avi 11/10/2003 01:54'!
debug
	self answer! !

!WAWalkback methodsFor: 'accessing' stamp: 'avi 10/26/2004 14:05'!
exception: anException
	exception _ anException! !

!WAWalkback methodsFor: 'actions' stamp: 'lr 3/28/2005 17:52'!
fullstack
	fullstack _ true
	! !

!WAWalkback methodsFor: 'initialization' stamp: 'lr 3/28/2005 17:55'!
initialize
	super initialize.
	fullstack _ false.! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 3/28/2005 17:53'!
renderContentOn: html
	html anchorWithAction: [self debug] text: 'Debug'; space.
	html anchorWithAction: [self fullstack] text: 'Full Stack'.
	self renderWalkbackOn: html.! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 3/30/2005 23:29'!
renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString := (SeasidePlatformSupport isProxy: anObject)
					ifTrue: [anObject printString]
					ifFalse: [anObject printStringLimitedTo: 100]]
		on: Error
		do: [:err | objectString := '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRowWithLabel: aString column: [
		html html: objectString ].! !

!WAWalkback methodsFor: 'rendering' stamp: 'avi 1/1/2005 15:06'!
renderStackFrame: aContext on: html
	| receiver |
	html listItem: [
		html text: aContext fullPrintString.
		html blockquote: [ html table: [
			receiver := aContext receiver.
			self renderObject: receiver labelled: 'self' on: html.
			html tableRowWith: [html bold: 'temps'] span: 2.
			aContext tempNames withIndexDo:
			[:name :index |
			self renderObject: (aContext tempAt: index) labelled: name on: html].
			receiver isNil ifFalse: [
				((SeasidePlatformSupport isProxy: receiver) not and: [receiver class instSize > 0]) ifTrue:
					[html tableRowWith: [html bold: 'inst vars'] span: 2.
					receiver class allInstVarNames withIndexDo:
					[:name :index |
					self renderObject: (receiver instVarAt: index) labelled: name on: html]]].
		]]
	]
! !

!WAWalkback methodsFor: 'rendering' stamp: 'lr 3/28/2005 17:56'!
renderWalkbackOn: html
	| context count |
	html heading: exception description.
	html unorderedList: [
		context _ thisContext. count _ 0.
		[context receiver isKindOf: Exception] whileFalse: [context _ context sender].
		[context receiver isKindOf: Exception] whileTrue: [context _ context sender].
		[context notNil and: [ fullstack or: [ count < 5 ] ] ] whileTrue: [
			self renderStackFrame: context on: html.
			context _ context sender.
			count _ count + 1].
	]! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADecoration commentStamp: '<historical>' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #processChildCallbacks: to intercept the callback processing of the owner.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'event block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerHandler methodsFor: 'as yet unclassified' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block _ aBlock! !

!WAAnswerHandler methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	block value: anObject! !

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 00:04'!
realm
	^ realm ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm _ aString! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:03'!
renderContentOn: html
	(self verifyRequest: html request)
		ifTrue: [self renderOwnerOn: html]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
respondWithChallenge
	self session returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:42'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password  forUser: aRequest user! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:02'!
handleAnswer: anObject
	(self owner handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 12:43'!
nextPresentersDo: aBlock
	aBlock value: self owner! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:20'!
owner
	^ next ifNotNil: [next contents]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:20'!
owner: aPresenter
	next ifNil: [next _ WAStateHolder new].
	next contents: aPresenter! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'avi 3/27/2004 21:07'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | owner renderWithContext: html context]! !

WADecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADelayedAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:34'!
delay
	^ delay ifNil: [1]! !

!WADelayedAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay _ aNumber! !

!WADelayedAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:32'!
updateRoot: aRoot
	| callbacks url element |
	callbacks _ WACallbackRegistry context: aRoot context owner: self.
	url _ aRoot context actionUrl withParameter: (callbacks registerActionCallback: [self component answer]).
	element _ (WAHtmlElement named: 'meta')
				attributeAt: 'http-equiv' put: 'refresh';
				attributeAt: 'content' put: self delay displayString, ';URL=',url asString;
				yourself.
	aRoot addHeadElement: element! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate _ aComponent! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons _ selectorArray! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 8/23/2005 11:46'!
renderButtonForSelector: aSymbol on: html
	html submitButtonOn: aSymbol of: self owner! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:34'!
renderButtonsOn: html
	html divClass: 'dialog-buttons' with: [
		self buttons do:
			[:ea |
			html spanNamed: ea with: [self renderButtonForSelector: ea on: html]]
	]! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:36'!
renderContentOn: html
	html form: [
		self renderOwnerOn: html.
		self renderButtonsOn: html.
	]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message _ aString! !

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 00:49'!
renderContentOn: html
	html heading: message level: 3.
	self renderOwnerOn: html.! !

WADecoration subclass: #WASessionProtector
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 18:49'!
isGlobal
	^true! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:36'!
processChildCallbacks: aStream
	(self verifyRequest: self session currentRequest)
		ifTrue: [ super processChildCallbacks: aStream ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:32'!
remoteAddressFromRequest: aRequest
	^aRequest 
		headerAt: 'x-forwarded-for'
		ifAbsent: [ aRequest nativeRequest remoteAddress ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:36'!
renderContentOn: html
	(self verifyRequest: html request)
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self respondNotVerified ]! !

!WASessionProtector methodsFor: 'forwarding' stamp: 'lr 8/31/2004 19:37'!
respondNotVerified
	self session redirectTo: self session application basePath.! !

!WASessionProtector methodsFor: 'accessing' stamp: 'lr 8/31/2004 19:38'!
storedRemoteAddress
	remoteAddress isNil
		ifTrue: [ remoteAddress _ self remoteAddressFromRequest: self session currentRequest ].
	^remoteAddress! !

!WASessionProtector methodsFor: 'testing' stamp: 'lr 8/31/2004 19:31'!
verifyRequest: aRequest
	^(self remoteAddressFromRequest: aRequest) = self storedRemoteAddress! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
close
	active _ false! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
initialize
	active _ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'avi 6/8/2004 00:56'!
processChildCallbacks: aStream
	^ active
		ifTrue: [super processChildCallbacks: aStream]
		ifFalse: [self session pageExpired].
	! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'avi 9/8/2004 12:18'!
renderContentOn: html
	active
		ifTrue: [ self renderOwnerOn: html ]
		ifFalse: [ self session pageExpired ]! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:18'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass _ WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass _ aClass! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/12/2004 00:23'!
handleAnswer: anObject
	(super handleAnswer: anObject) ifFalse:
		[^ (self validate: anObject) not].
	^ true! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:50'!
initialize
	message _ WAStateHolder new! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:05'!
renderContentOn: html
	message contents ifNotNilDo:
		[:msg |
		html divClass: 'validation-error' with: msg].
	self renderOwnerOn: html.! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:19'!
validate: anObject
	[validationBlock value: anObject.
	message contents: ''.
	^ true]
		on: Error
		do: [:e | message contents: e messageText].
	^ false! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock _ aBlock! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:12'!
renderCloseButtonOn: html
	html anchorWithAction: [self component answer] text: 'close'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 6/21/2004 20:57'!
renderContentOn: html
	html divClass: 'window-titlebar' with: [
		html spanClass: 'window-close' with: [self renderCloseButtonOn: html].		
		html spanClass: 'window-title' with: title.
	].
	html divClass: 'window-content' with: [self renderOwnerOn: html].! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:04'!
style
	^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title _ aString! !

!WAPresenter class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:36'!
classForSection: aSymbol
	^ (aSymbol copyFrom: 7 to: (aSymbol size - 1)) withFirstCharacterDownshifted ! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 11/7/2005 11:53'!
initialRequest: aRequest! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 6/8/2004 00:58'!
nextPresentersDo: aBlock
	self subclassResponsibility ! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 02:00'!
processCallbackStream: aCallbackStream
	aCallbackStream processCallbacksWithOwner: self.
	self processChildCallbacks: aCallbackStream.
	aCallbackStream processCallbacksWithOwner: self.
! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 6/8/2004 00:54'!
processChildCallbacks: aStream
	self nextPresentersDo: [:ea | ea processCallbackStream: aStream]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 20:59'!
renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/18/2005 22:11'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks _ aRenderingContext callbacksFor: self.
	html _ (self rendererClass context: aRenderingContext callbacks: callbacks)
				painter: self.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) renderContentOn: html]
		ifFalse: [self renderContentOn: html].
	html close.! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:25'!
rendererClass
	^ WAHtmlRenderer! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 6/21/2004 16:05'!
script
	^ nil! !

!WAPresenter methodsFor: 'convenience' stamp: 'avi 4/13/2004 19:48'!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:27'!
showHalo
	^ true! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/28/2004 20:57'!
style
	^ nil! !

!WAPresenter methodsFor: 'path' stamp: 'avi 6/21/2004 16:04'!
updateRoot: anHtmlRoot
	self script ifNotNilDo: [:script | anHtmlRoot addScript: script].
	self style ifNotNilDo: [:style | anHtmlRoot addStyle: style].
	
! !

!WAPresenter methodsFor: 'path' stamp: 'avi 3/22/2004 01:00'!
updateUrl: aUrl
! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'timeout responseSem mutex process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAProcessMonitor class methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:53'!
new
	^ super new initialize! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'avi 1/16/2005 00:38'!
critical: aBlock ifError: errorBlock
	|value|
	mutex critical:
		[responseSem _ Semaphore new.
		process _ [[value _ aBlock on: Error do: errorBlock]
			ensure: [responseSem signal]] fork.
		responseSem wait].
	process _ nil.
	^ value! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'jf 3/4/2004 00:49'!
initialize
	timeout _ 5.
	mutex _ Semaphore forMutualExclusion.! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'avi 1/16/2005 00:38'!
terminate
	process ifNotNil: [process terminate]! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 14:50'!
timeout
	^ timeout! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:54'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

Object subclass: #WARadioGroup
	instanceVariableNames: 'canvas key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Canvas'!

!WARadioGroup class methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 11:30'!
canvas: aRenderCanvas
	^ self basicNew initializeWithCanvas: aRenderCanvas! !

!WARadioGroup methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 11:31'!
initializeWithCanvas: aRenderCanvas
	canvas _ aRenderCanvas.
	key _ aRenderCanvas callbacks registerDispatchCallback.! !

!WARadioGroup methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 11:32'!
key
	^ key! !

!WARadioGroup methodsFor: 'as yet unclassified' stamp: 'ac 7/6/2005 11:31'!
radioButton
	^ canvas radioButton group: self! !

Object subclass: #WAReadWriteLock
	instanceVariableNames: 'sem mutex readers'
	classVariableNames: 'Global'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAReadWriteLock class methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:38'!
global
	^ Global ifNil: [Global _ self new]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:37'!
initialize
	sem _ Semaphore forMutualExclusion.
	mutex _ Semaphore forMutualExclusion.
	readers _ 0! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
lockForReading
	mutex critical:
		[readers = 0 ifTrue: [sem wait].
		readers _ readers + 1]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
lockForWriting
	sem wait! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:35'!
read: aBlock
	self lockForReading.
	^ aBlock ensure: [self unlockForReading]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:39'!
readers
	^ readers! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:33'!
unlockForReading
	mutex critical:
		[readers _ readers - 1.
		readers = 0 ifTrue: [sem signal]]! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:34'!
unlockForWriting
	sem signal! !

!WAReadWriteLock methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2005 00:35'!
write: aBlock
	self lockForWriting.
	^ aBlock ensure: [self unlockForWriting]! !

Object subclass: #WARender
	instanceVariableNames: 'root context request document url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARender methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:29'!
application
	^ self session application! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:51'!
buildDocRoot
	|docRoot|
	docRoot _ WARenderedHtmlRoot context: context.
	docRoot resourceBaseUrl:
		(self application preferenceAt: #resourceBaseUrl).
	docRoot bodyAttributes at: 'onLoad' put: 'onLoad()'.
	root visiblePresentersDo: [:ea | ea updateRoot: docRoot].
	self session updateRoot: docRoot.				
	^ docRoot! !

!WARender methodsFor: 'rendering' stamp: 'avi 1/6/2006 14:03'!
buildResponse
	| response |
	self updateUrl: url.
	context actionUrl: url. 
	response _ self newResponse.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document _ WAHtmlStreamDocument root: self buildDocRoot.
	document stream: response stream.
	context document: document.
	root decorationChainDo: [:ea | ea renderWithContext: context].		
	self writeOnLoadOn: document.
	document close.
	^ response! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:31'!
go
	self withPageExpiredHandler:
		[self withRenderNowHandler: [self render].
		self shouldRedirect ifTrue: [self redirect]]! !

!WARender methodsFor: 'rendering' stamp: 'avi 1/6/2006 14:02'!
newResponse
	| s |
	s _ self session currentRequest ifNotNilDo: [:r | r responseStream].
	^ s
		ifNil: [WAResponse new]
		ifNotNil: [WAStreamResponse new stream: s]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:48'!
processCallbacks
	| lastPosition callbackStream |
	callbackStream _ context callbackStreamForRequest: request.
	lastPosition _ nil.
	[callbackStream position = lastPosition] whileFalse:
		[lastPosition _ callbackStream position.
		root decorationChainDo: [:ea | ea processCallbackStream: callbackStream]].
	callbackStream atEnd
		ifTrue: [WARenderNotification raiseSignal]
		ifFalse: [self unprocessedCallbacks: callbackStream upToEnd].! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
redirect	
	self session respond:
		[:u |
		self updateUrl: u.
		WAResponse redirectTo: u displayString]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:34'!
render
	self session clearJumpTo.
	context _ WARenderingContext new request: self session currentRequest.
	request _ self session respond: [:u | url _ u.  self buildResponse].
	self processCallbacks! !

!WARender methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:30'!
root: aComponent
	root _ aComponent! !

!WARender methodsFor: 'as yet unclassified' stamp: 'avi 11/27/2005 17:29'!
session
	^ WACurrentSession value! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:38'!
shouldRedirect
	^ request isGet not or: [(request fields includesKey: '_n') not]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
unprocessedCallbacks: aCollection
	| owners |
	owners _ (aCollection collect: [:ea | ea owner]) asSet asArray.
	self error: 'Components not found while processing callbacks: ', owners displayString! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
updateUrl: aUrl
	root visiblePresentersDo: [:c | c updateUrl: aUrl]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withPageExpiredHandler: aBlock
	^ aBlock on: WAPageExpired do: [:n |]! !

!WARender methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:29'!
withRenderNowHandler: aBlock
	^ aBlock on: WARenderNotification do: [:n | n]! !

!WARender methodsFor: 'rendering' stamp: 'ac 12/20/2005 12:35'!
writeOnLoadOn: anHtmlDocument
	| attributes |
	attributes _ WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	anHtmlDocument openTag: 'script' attributes: attributes.
	anHtmlDocument text: 'function onLoad() {'.
	self session onLoadScripts
		do: [:ea | anHtmlDocument text: ea]
		separatedBy: [anHtmlDocument text: ';'].
	anHtmlDocument text: '}'.
	anHtmlDocument closeTag: 'script'.
	self session clearLoadScripts! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:39'!
application
	^ self session application! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
basicRoot: aComponent
	root _ aComponent! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 14:00'!
call: aComponent
	^ self call: aComponent withToolFrame: true! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 13:59'!
call: aComponent withToolFrame: aBoolean
	aBoolean ifTrue: [self root: aComponent] ifFalse: [self basicRoot: aComponent].
	aComponent onAnswer: [:v | ^ v].
	self run! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
root: aComponent
	self basicRoot: ((self application preferenceAt: #deploymentMode)
					ifFalse: [WAToolFrame on: aComponent]
					ifTrue: [aComponent])! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 11/27/2005 17:37'!
run
	[(WARender new root: root) go] repeat! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:28'!
session
	^ WACurrentSession value! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderingContext class methodsFor: 'as yet unclassified' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl _ anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key _ self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:07'!
callbackAt: aString
	^ callbacks at: aString! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode _ nil! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode _ #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
increaseKey
	count _ count + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'avi 6/24/2004 00:27'!
initialize
	count _ 1.
	callbacks _ Dictionary new! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mbany 4/14/2005 12:14'!
nextKey
	^ count displayString! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:52'!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request: aRequest
	request _ aRequest! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response: aResponse
	response _ aResponse! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 9/2/2004 14:46'!
storeCallback: aCallback	
	| key |
	key _ self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:04'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'mbany 4/14/2005 12:14'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) displayString! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 21:50'!
new
	^ super new initialize! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:08'!
canSort
	^ sortBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock _ aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal _ aBoolean ! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock _ [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'mbany 4/14/2005 12:15'!
initialize
	formatBlock _ [:x | x displayString].
	sortBlock _ [:a :b | a <= b].
	valueBlock _ [:row | nil].
	clickBlock _ nil.
	title _ 'Untitled'.
	hasTotal _ false.! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock _ [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs _ anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs _ assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title _ aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock _ aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest responseStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 8/29/2005 21:19'!
blankRequest
	^ self
			method: 'GET'
			url: ''
			headers: Dictionary new
			fields: Dictionary new
			cookies: Dictionary new! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict)
		nativeRequest: anObject;
		yourself! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:15'!
cookies
	^ cookies ifNil: [cookies _ Dictionary new]! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'avi 5/9/2005 13:13'!
isPrefetch
	^ (self headerAt: 'HTTP_X_MOZ') = 'prefetch'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest _ aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream
	^ responseStream! !

!WARequest methodsFor: 'accessing' stamp: 'avi 1/6/2006 13:23'!
responseStream: aStream
	responseStream _ aStream! !

!WARequest methodsFor: 'private' stamp: 'avi 3/19/2004 13:52'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method _ methodString.
	url _ urlString.
	headers _ headDict.
	fields _ fieldDict.
	cookies _ cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WADocumentHandler class methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:41'!
= other
	^ (other species = self species
		and: [other document = self document])
		and: [other mimeType = self mimeType]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:52'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document _ anObject.
	mimeType _ mimeString.
	fileName _ fileString.! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:43'!
isActive
	^ true! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:51'!
mimeDocument
	^ mimeDocument ifNil: [mimeDocument _ document asMIMEDocument ]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'lr 5/17/2005 08:38'!
response
	| response |
	response _ WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename="' , fileName , '"'].
	^ response! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'JF 9/15/2003 14:40'!
default
	default ifNil: [default _ self new].
	default basePath ifNil: [default basePath: '/seaside'].
	
	^ default! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Subdirectory'! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:09'!
new
	^ super new initialize! !

!WADispatcher methodsFor: 'public' stamp: 'avi 7/5/2004 11:44'!
basePath: newPath
	| base |
	basePath _ newPath.
	base _ (newPath isEmpty or: [newPath last ~= $/])
				ifTrue: [newPath, '/']
				ifFalse: [newPath].
	entryPoints keysAndValuesDo: [:key :component | component basePath: base, key]! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher methodsFor: 'public' stamp: 'avi 11/12/2005 12:25'!
defaultPath
	^ default! !

!WADispatcher methodsFor: 'public' stamp: 'avi 11/12/2005 12:25'!
defaultPath: aString
	default _ aString! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WADispatcher methodsFor: 'public' stamp: 'avi 5/9/2005 13:15'!
handleRequest: aRequest
	aRequest isPrefetch ifTrue: [^ WAResponse forbidden: aRequest url].
	^ (self handlerForRequest: aRequest) handleRequest: aRequest! !

!WADispatcher methodsFor: 'private' stamp: 'mb 2/17/2005 17:55'!
handlerForRequest: aRequest
	^ self handlerForRequest: aRequest relativeTo: basePath! !

!WADispatcher methodsFor: 'private' stamp: 'avi 11/12/2005 12:25'!
handlerForRequest: aRequest relativeTo: base
	| path name relativePath |
	path := aRequest url.
	(base isEmpty or: [path beginsWith: base]) ifTrue:
		[relativePath _ path allButFirst: base size.
		(relativePath notEmpty and: [relativePath first = $/]) ifTrue:
			[name _ (relativePath findTokens: '/') at: 1 ifAbsent: [default]].
              entryPoints
				at: name
				ifPresent: [:n | ^ n]].
       ^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:08'!
initialize
	entryPoints _ Dictionary new! !

!WADispatcher methodsFor: 'public' stamp: 'avi 5/10/2005 14:32'!
registerEntryPoint: entryPoint at: aString
	| path |
	entryPoints at: aString displayString put: entryPoint.
	path := (basePath isEmpty or: [basePath last ~= $/])
		ifTrue: [basePath, '/', aString]
		ifFalse: [basePath, aString].
	entryPoint basePath: path
! !

!WADispatcher methodsFor: 'public' stamp: 'avi 6/7/2005 23:42'!
removeEntryPoint: anObject
	entryPoints removeKey: (entryPoints keyAtValue: anObject).
	anObject unregistered! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:51'!
concreteSubclasses
	^ self allSubclasses reject: [:ea | ea isAbstract]! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath: aString
	basePath _ aString! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 00:48'!
baseUrl
	^ WAUrl new
		addToPath: basePath;
		yourself! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint methodsFor: 'printing' stamp: 'JF 9/22/2003 20:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self basePath, ')'! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 6/7/2005 23:42'!
unregistered! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration libraries sessionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Seaside Application'! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
path: pathString
	^ self new basePath: pathString! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:48'!
baseUrl
	^ super baseUrl
		port: (self preferenceAt: #serverPort);
		hostname: (self preferenceAt: #serverHostname);
		scheme: (self preferenceAt: #serverProtocol);
		yourself! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:45'!
configuration
	^ configuration ifNil: [configuration _ WAUserConfiguration new addAncestor: self defaultAncestor] ! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 11/16/2005 23:32'!
defaultAncestor
	"yes, breaking layering"
	^ WARenderLoopConfiguration new! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:30'!
defaultLibraries
	^ Array with: WAStandardScripts with: WAStandardStyles! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:06'!
handleDefaultRequest: aRequest
	|session|
	session _ self sessionClass application: self.
	^ session handleRequest: aRequest! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 11/12/2005 21:36'!
handleExpiredRequest: aRequest
	| response |
	response _ super handleExpiredRequest: aRequest.
	response cookieAt: self name put: ''.
	^ response! !

!WAApplication methodsFor: 'request handling' stamp: 'tonyg 12/15/2005 14:27'!
handleRequest: aRequest
	aRequest cookies at: self name ifPresent:
		[:v |
		aRequest fields at: self handlerField ifAbsentPut: v].
	^ super handleRequest: aRequest! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 6/24/2004 00:29'!
libraries
	^ libraries ifNil: [libraries _ OrderedCollection withAll: self defaultLibraries]! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 7/26/2004 12:49'!
name
	| segments |
	segments _ basePath findTokens: '/'.
	^ segments isEmpty
		ifTrue: ['']
		ifFalse: [segments last ]! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAApplication methodsFor: 'basic configuration' stamp: 'avi 1/31/2004 18:19'!
sessionClass
	^ configuration valueAt: #sessionClass! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	anHtmlRoot title = '' ifTrue: [anHtmlRoot title: self basePath].
	self libraries do: [:ea | ea updateRoot: anHtmlRoot]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
new
	^ super new initialize! !

!WARegistry methodsFor: 'private' stamp: 'avi 6/7/2005 23:17'!
clearHandlers
	self mutex critical:
		[handlersByKey ifNotNil:
			[handlersByKey do: [:ea | [ea unregistered] fixTemps fork]].

		handlersByKey _ Dictionary new.
		keysByHandler _ Dictionary new].! !

!WARegistry methodsFor: 'public' stamp: 'avi 11/12/2005 21:22'!
ensureKeyForHandler: anObject
	^ (self keyOrNilForHandler: anObject) ifNil: [self registerRequestHandler: anObject]! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'avi 11/27/2005 20:48'!
handleExpiredRequest: aRequest
	| url |
	url _ WAUrl new.
	url addToPath: aRequest url.
	url takeServerParametersFromRequest: aRequest.
	aRequest isGet ifTrue:
		[aRequest fields keysAndValuesDo:
			[:k :v |
			(url isSeasideField: k) ifFalse: [url addParameter: k value: v]]]. 
	
	^ WAResponse redirectTo: url displayString! !

!WARegistry methodsFor: 'private' stamp: 'avi 7/5/2004 11:47'!
handleKeyRequest: aRequest
	|key handler|
	key _ [WAExternalID fromString: (aRequest at: self handlerField)] on: Error do: [:e | nil].
	handler _ handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry methodsFor: 'public' stamp: 'avi 3/19/2004 13:52'!
handleRequest: aRequest
	^ (aRequest fields includesKey: self handlerField)
		ifTrue: [self handleKeyRequest: aRequest]
		ifFalse: [self handleDefaultRequest: aRequest]
! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
initialize
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
isSeasideField: aString
	^ aString first  = $_! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 19:06'!
keyOrNilForHandler: anObject
	^ self mutex critical: [keysByHandler at: anObject ifAbsent: [nil]]! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:48'!
mutex
	^ mutex ifNil: [mutex _ Semaphore forMutualExclusion]! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:59'!
registerRequestHandler: anObject
	|key|
	key _ WAExternalID new: 16.
	self shouldCollectHandlers ifTrue: [self unregisterExpiredHandlers].
	self mutex critical:
		[handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/14/2005 14:56'!
unregisterExpiredHandlers
	"This method is a little ugly, but using #associationsDo: to build a new
	dictionary is 200 times faster than iterating over them with #removeKey:
	or even using #keysAndValuesRemove:"

	| expired newHandlersByKey newKeysByHandler |
	self mutex critical:
		[expired _ OrderedCollection new.
		newHandlersByKey _ Dictionary new.
		handlersByKey associationsDo:
			[:assoc |
			assoc value isActive
				ifTrue: [newHandlersByKey add: assoc]
				ifFalse: [expired add: assoc value]].
		newKeysByHandler _ Dictionary new.
		keysByHandler associationsDo:
                       [:assoc |
                       (newHandlersByKey includesKey: assoc value) ifTrue:
						[newKeysByHandler add: assoc]].
		handlersByKey _ newHandlersByKey.
		keysByHandler _ newKeysByHandler].
	
	expired do: [:ea | [ea unregistered] fixTemps fork]! !

!WARegistry methodsFor: 'private' stamp: 'avi 6/7/2005 23:43'!
unregistered
	self clearHandlers ! !

!WARegistry methodsFor: 'public' stamp: 'avi 11/12/2005 21:22'!
urlForRequestHandler: anObject
	|key url |
	key _ self ensureKeyForHandler: anObject.
	url _ self baseUrl.
	url addParameter: self handlerField value: key displayString.
	^ url! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expire
	expired _ true! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expired
	^ expired ifNil: [false]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess _ Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
incomingRequest: aRequest
	self subclassResponsibility ! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
isActive
	^ self expired not and: [self secondsSinceLastAccess < self timeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
lastAccess
	^ lastAccess ifNil: [lastAccess _ Time totalSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds
	^ timeout ifNil: [self defaultTimeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation monitor state currentRequest scripts jumpTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASession commentStamp: '<historical>' prior: 0!
I am a Seaside session. A new instance of me gets created when an user accesses an application for the first time and is persistent as long as the user is interacting with it.

If the session has not been used for #defaultTimeoutSeconds, it is garbage collected by the system. To manually expire a session call #expire.!

WASession subclass: #WAExpirySession
	instanceVariableNames: ''
	classVariableNames: 'Created Unregistered'
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:30'!
created
	^ Created! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:24'!
initialize
	self resetCounters! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:24'!
resetCounters
	Unregistered _ 0.
	Created _ 0.! !

!WAExpirySession class methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:30'!
unregistered
	^ Unregistered! !

!WAExpirySession methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:24'!
initialize
	super initialize.
	Created _ Created + 1! !

!WAExpirySession methodsFor: 'as yet unclassified' stamp: 'avi 9/30/2004 16:24'!
unregistered
	Unregistered _ Unregistered + 1! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'avi 7/2/2004 17:32'!
application: anApplication
	^ self basicNew initializeWithApplication: anApplication! !

!WASession methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:04'!
actionField
	^ '_k'! !

!WASession methodsFor: 'responding' stamp: 'avi 2/3/2004 00:43'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: aContinuation)! !

!WASession methodsFor: 'responding' stamp: 'avi 11/27/2005 14:56'!
actionUrlForKey: aString
	| url |
	url _ self useSessionCookie
			ifTrue: [application baseUrl]
			ifFalse: [application urlForRequestHandler: self].
	url takeServerParametersFromRequest: currentRequest.
	url addParameter: self actionField value: aString.
	jumpTo ifNotNil: [url fragment: jumpTo].
	^ url! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 18:42'!
addLoadScript: aString
	^ (scripts ifNil: [scripts _ OrderedCollection new]) add: aString! !

!WASession methodsFor: 'accessing' stamp: 'ab 3/20/2003 11:43'!
application
	^ application! !

!WASession methodsFor: 'cookies' stamp: 'mbany 4/14/2005 11:56'!
checkForCookies
	| check |
	check _ WAExternalID new displayString.
	self redirectWithCookie: 
		(WACookie new
			key: check;
			value: 'yes';
			expireIn: (Duration seconds: 2);
			yourself).
	^ currentRequest cookies includesKey: check! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:09'!
clearJumpTo
	jumpTo _ nil! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
clearLoadScripts
	scripts _ nil! !

!WASession methodsFor: 'responding' stamp: 'ac 12/23/2004 04:09'!
closePopup
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=self.opener.location';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
closePopupAndContinue
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=',url displayString printString;
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'responding' stamp: 'ac 9/27/2005 19:40'!
closePopupWithoutReloadingOpener
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: '</script></html>';
			yourself]! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/13/2004 21:47'!
currentRequest
	^ currentRequest! !

!WASession methodsFor: 'expiring' stamp: 'avi 8/29/2004 14:10'!
defaultTimeoutSeconds
	^(self application preferenceAt: #sessionExpirySeconds)
		ifNil: [super defaultTimeoutSeconds]! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:52'!
errorHandler
	^ application preferenceAt: #errorHandler! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/16/2005 00:41'!
incomingRequest: aRequest
	((aRequest fields includesKey: 'terminate')
		and: [(self application preferenceAt: #deploymentMode) not])
			ifTrue: [monitor terminate.  ^ WAResponse new nextPutAll: 'Process terminated'].
			
	^ monitor
		critical: [self responseForRequest: aRequest]
		ifError: [:e | WAResponse internalError: e]! !

!WASession methodsFor: 'initializing' stamp: 'ab 5/26/2003 01:53'!
initialize! !

!WASession methodsFor: 'initializing' stamp: 'avi 4/13/2004 20:29'!
initializeWithApplication: anApplication
	application _ anApplication.
	continuations _ WALRUCache new.
	monitor _ WAProcessMonitor new.
	state _ WAStateRegistry new.
	self initialize.! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 21:08'!
jumpToAnchor: aString
	jumpTo _ aString! !

!WASession methodsFor: 'accessing' stamp: 'avi 2/5/2004 12:21'!
mainClass
	^ application preferenceAt: #mainClass! !

!WASession methodsFor: 'responding' stamp: 'avi 11/29/2005 11:20'!
newSessionUrl
	| url |
	url _ self application baseUrl.
	url takeServerParametersFromRequest: currentRequest.
	^ url asString! !

!WASession methodsFor: 'scripts' stamp: 'avi 9/24/2005 20:00'!
onLoadScripts
	^ scripts ifNil: [#()]! !

!WASession methodsFor: 'expiring' stamp: 'avi 9/2/2004 16:28'!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired raiseSignal.
! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'request handling' stamp: 'cwp 3/26/2004 23:23'!
performRequest: aRequest
	| key continuation |
	key _ aRequest fields at: self actionField ifAbsent: [^ self start: aRequest].
	continuation _ continuations at: key ifAbsent: [^ self unknownRequest: aRequest].
	continuation value: aRequest
! !

!WASession methodsFor: 'printing' stamp: 'mbany 4/14/2005 11:57'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', (application urlForRequestHandler: self) displayString, ')'! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:55'!
redirect
	^ self respond: [:url | WAResponse redirectTo: url displayString]! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirectTo: urlString
	self returnResponse: (WAResponse redirectTo: urlString)! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 22:57'!
redirectWithCookie: aCookie
	self redirectWithCookies: (Array with: aCookie)! !

!WASession methodsFor: 'cookies' stamp: 'mbany 4/14/2005 11:57'!
redirectWithCookies: aCollection
	| response |
	self respond:
		[:url |
		response _ WAResponse redirectTo: url displayString.
		aCollection do: [:ea | response addCookie: ea].
		response]! !

!WASession methodsFor: 'responding' stamp: 'mbany 4/14/2005 11:56'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WAResponse
			refreshWithMessage: aString
			location: url displayString
			delay: aNumber].
! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:51'!
registerObjectForBacktracking: anObject
	state registerObject: anObject! !

!WASession methodsFor: 'responding' stamp: 'avi 11/12/2005 21:25'!
respond: responseBlock
	|request snapshotHolder response oldEscape |
	snapshotHolder _ ValueHolder new.
	oldEscape _ escapeContinuation.
	escapeContinuation _
		[:v |
		snapshotHolder contents: state snapshot.
		oldEscape value: v].
	request _ 
	ResponseContinuation currentDo:
		[:cc ||url|
		url _ self actionUrlForContinuation: cc.
		response _ responseBlock value: url.
		self useSessionCookie ifTrue: [response addCookie: self sessionCookie].
		self returnResponse: response].
	state restoreSnapshot: snapshotHolder contents.
	^ request 
	! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/28/2004 11:46'!
responseForRequest: aRequest
	currentRequest _ aRequest.
	^ self withEscapeContinuation:
		[WACurrentSession use: self during: [self withErrorHandler: [self performRequest: aRequest]]]! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

!WASession methodsFor: 'responding' stamp: 'avi 3/13/2004 01:21'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'responding' stamp: 'avi 11/12/2005 21:27'!
sessionCookie
	^ WACookie key: self application name value: (self application ensureKeyForHandler: self) displayString! !

!WASession methodsFor: 'request handling' stamp: 'avi 11/12/2005 21:37'!
start: aRequest
	self useSessionCookie ifTrue: [self redirectWithCookie: self sessionCookie].
	self mainClass new start: aRequest! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/20/2006 01:41'!
unknownRequest: aRequest
	self start: aRequest! !

!WASession methodsFor: 'responding' stamp: 'avi 9/24/2005 19:56'!
updateRoot: anHtmlRoot
	self application updateRoot: anHtmlRoot! !

!WASession methodsFor: 'cookies' stamp: 'avi 11/12/2005 21:41'!
useSessionCookie
	^ self application preferenceAt: #useSessionCookie! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/27/2004 14:25'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'request handling' stamp: 'avi 10/26/2004 15:40'!
withEscapeContinuation: aBlock
	^ EscapeContinuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RequestHandler'!

!WANotFoundHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:33'!
handleRequest: aRequest
	self subclassResponsibility! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 7/23/2004 15:11'!
isActive
	^ true! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'avi 6/16/2004 22:55'!
unregistered! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 22:49'!
document: anObject mimeType: mimeType
	|doc|
	doc _ anObject asMIMEDocument.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 21:02'!
document: anObject mimeType: mimeString fileName: fileString
	^ (self document: anObject mimeType: mimeString)
		attachmentWithFileName: fileString;
		yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/9/2005 13:14'!
forbidden: locationString
	^ self new
		forbidden;
		nextPutAll: '<h1> Error: you are forbidden to access "', locationString, '". </h1>';
		yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 7/9/2005 14:36'!
internalError: anError
	| response |
	response _ self new internalError.
	response
		nextPutAll: '<h1> Internal Error</h1>';
		nextPutAll: '<h2>';
		nextPutAll: anError displayString;
		nextPutAll: '</h2>'.
	(anError signalerContext sender stackOfSize: 20) do: [:ctx | response nextPutAll: '<br>'. ctx printOn: response].
	^ response! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:15'!
notFound: locationString
	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 12:50'!
refreshWithMessage: aString location: locationString delay: aNumber
	^ self new nextPutAll:
		 ('<html>
			<head>
			<meta http-equiv="refresh" content="',aNumber displayString,';URL=',locationString,'">
			<title>',aString,'</title>
			</head>
			<body>
			<h1>',aString,'</h1>
			You are being redirected to <a href="',locationString,'">',locationString,'</a>
			</body>
		</html>');
		yourself
	! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:31'!
root: anHtmlRoot render: renderBlock
	| canvas |
	canvas _ WAStaticHtmlCanvas root: anHtmlRoot.
	renderBlock value: canvas.
	^ self new nextPutAll: canvas document stream contents! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 9/10/2005 17:32'!
updateRoot: rootBlock render: renderBlock
	| root |
	root _ WAHtmlRoot new.
	rootBlock value: root.
	^ self root: root render: renderBlock! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:27'!
addCookie: aCookie
	cookies ifNil: [cookies _ OrderedCollection new].
	cookies add: aCookie! !

!WAResponse methodsFor: 'convenience' stamp: 'al 5/25/2005 14:35'!
attachmentWithFileName: aString
	self headerAt: 'Content-Dispostion' put: 'attachment; filename="', aString, '"'! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType _ mimeTypeString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream _ aStream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:23'!
cookieAt: key put: value
	self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
cookies
	^ cookies ifNil: [#()]! !

!WAResponse methodsFor: 'convenience' stamp: 'ac 9/11/2005 12:46'!
doNotCache
	self headerAt: 'Cache-Control' put: 'no-cache'.! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/9/2005 13:14'!
forbidden
	self status: 403! !

!WAResponse methodsFor: 'accessing' stamp: 'mb 2/17/2005 18:13'!
headerAt: key put: value
	headers ifNil: [headers := OrderedCollection new].
	headers add: (Association key: key value: value).! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
headers
	^ headers ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/22/2004 15:24'!
initialize
	stream _ SeasidePlatformSupport readWriteStream.
	status _ '200'.
	contentType _ 'text/html; charset=utf-8'.
! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 11/27/2005 15:19'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect.! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 16:01'!
release
	stream _ cookies _ headers _ nil! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'mbany 4/14/2005 12:51'!
status: statusString
	status _ statusString displayString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream _ aStream! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:53'!
writeHeadersOn: aStream
	self headers associationsDo:
		[:assoc |
		aStream nextPutAll: assoc key; nextPutAll: ': '; nextPutAll: assoc value asString.
		aStream crlf].
	aStream nextPutAll: 'Content-Type: ', self contentType.
	aStream crlf! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:52'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	aStream crlf.
	aStream nextPutAll: stream contents! !

!WAResponse methodsFor: 'writing' stamp: 'avi 1/6/2006 12:51'!
writeStatusOn: aStream
	aStream nextPutAll: 'HTTP/1.0 ', self status asString.
	aStream crlf! !

WAResponse subclass: #WAStreamResponse
	instanceVariableNames: 'writtenHeaders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAStreamResponse methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 13:25'!
hasWrittenHeaders
	^ writtenHeaders ifNil: [false]! !

!WAStreamResponse methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 13:31'!
stream
	self writeOn: stream.
	^ stream! !

!WAStreamResponse methodsFor: 'as yet unclassified' stamp: 'avi 1/6/2006 14:11'!
writeOn: aStream
	self hasWrittenHeaders ifFalse:
		[self writeStatusOn: aStream.
		self writeHeadersOn: aStream.
		aStream crlf.
		writtenHeaders _ true]! !

Object subclass: #WASpotProfiler
	instanceVariableNames: 'readings'
	classVariableNames: 'Profilers'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WASpotProfiler class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 13:01'!
initialize
	Profilers _ Dictionary new! !

!WASpotProfiler class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:51'!
profile: aBlock
	| profiler |
	profiler _ Profilers at: thisContext sender selector ifAbsentPut: [self new].
	^ profiler profile: aBlock! !

!WASpotProfiler class methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:59'!
profilers
	^ Profilers! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:56'!
allReadings
	^ readings gather: [:ea | ea]! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
averageReadingTime
	^ self allReadings average! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:55'!
averageReadingsPerRequest
	^ (readings collect: [:ea | ea size]) average! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:53'!
averageRequestTime
	^ self requestTimes average! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:51'!
initialize
	self reset! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:50'!
profile: aBlock
	| time value |
	time _ Time millisecondsToRun: [value _ aBlock value].
	(readings at: Processor activeProcess ifAbsentPut: [OrderedCollection new]) add: time.
	^ value! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
readingCount
	^ self allReadings size! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
requestCount
	^ self requestTimes size! !

!WASpotProfiler methodsFor: 'private' stamp: 'avi 11/7/2005 12:53'!
requestTimes
	^ readings collect: [:ea | ea sum]! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:52'!
reset
	readings _ Dictionary new! !

!WASpotProfiler methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2005 12:54'!
totalTime
	^ self requestTimes sum! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'hash contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateHolder commentStamp: '<historical>' prior: 0!
I am a ValueHolder whose contents will properly track the user's use of the back button.  Use me to wrap any values that you wish to backtrack when the back button is used.

Sometimes it might be more convenient to register your business object directly:

	WACurrentSession value registerObjectForBacktracking: businessObject.

or even to register a component for backtracking, as seen in WACounter:

	WACounter>>initialize
		self session registerObjectForBacktracking: self.!

!WAStateHolder class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 19:48'!
new
	|inst|
	inst _ super new.
	WACurrentSession value registerObjectForBacktracking: inst.
	^ inst! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents _ anObject! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'lr 5/3/2005 08:50'!
hash
	^ hash ifNil: [ hash := SmallInteger maxVal atRandom ].! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistry class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:38'!
new
	^ super new initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
initialize
	objects _ SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:17'!
registerObject: anObject
	objects at: anObject put: anObject snapshotCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:28'!
restoreLastSnapshot
	lastSnapshot ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:18'!
restoreObject: object fromSnapshot: copy
	object restoreFromSnapshot: copy.
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 9/1/2004 21:21'!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(obj isIdenticalToSnapshot: copy)
			ifTrue: [lastSnapshot at: obj put: copy]
			ifFalse: [lastSnapshot at: obj put: obj snapshotCopy]].
	^ lastSnapshot
! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreAddress commentStamp: 'avi 1/1/2004 07:36' prior: 0!
A simple model of a billing or shipping address.  Stores strings for a person's name, street, city, and country.  Apart from accessors for these, the only behavior this provides is a #validate method which will throw errors if street, city, or country is nil.!

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
city
	^ city! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
city: aString
	city _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country
	^ country! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country: aString
	country _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
name
	^ name! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
name: aString
	name _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
street
	^ street! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
street: aString
	street _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:20'!
validate
	street ifNil: [self validationError: 'You must provide a street address.'].
	city ifNil: [self validationError: 'You must provide a city.'].
	country ifNil: [self validationError: 'You must provide a country.'].! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCart commentStamp: 'avi 1/1/2004 07:44' prior: 0!
A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.!

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items _ Bag new].
	items add: anObject! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:01'!
hasItems
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCreditCard commentStamp: 'avi 1/1/2004 07:47' prior: 0!
Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.!

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
expiry
	! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:03'!
expiry: aDate
	expiry _ aDate! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
name
	^ name! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:01'!
name: aString
	name _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number
	^ number! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number: aString
	number _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:20'!
validate
	name ifNil: [self validationError: 'You must provide the name of the credit card owner.'].
	number ifNil: [self validationError: 'You must provide a credit card number.'].
	expiry ifNil: [self validationError: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self validationError: 'The expiry date must not be in the past'].
	! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreMasterCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds MasterCard-specific validation to WAStoreCreditCard.!

!WAStoreMasterCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'MC'! !

!WAStoreMasterCard methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:20'!
validate
	super validate.
	number first = $5 ifFalse: [self validationError: 'Mastercard numbers must start with "5"'].
! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreVisaCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds VISA-specific validation to WAStoreCreditCard.!

!WAStoreVisaCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'as yet unclassified' stamp: 'cds 7/25/2005 10:20'!
validate
	super validate.
	number first = $4 ifFalse: [self validationError: 'Visa card numbers must start with "4"'].
! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory commentStamp: 'avi 1/1/2004 09:33' prior: 0!
The list of inventory items.  In a real application, this would probably have to deal with persistence, maintaining inventory counts, etc.  In this example, it just builds a collection of WAStoreItems from a hardcoded data set, and provides #allItems and #findItem: for accessing these.!

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:26'!
default
	^ default ifNil: [default _ self new]! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:17'!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
initialize
	items _ OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreItem commentStamp: 'avi 1/1/2004 09:34' prior: 0!
Models a single item of inventory - stores a title, subtitle, fill description, and price.  The only real behavior is #matches:, which is used for search.!

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price _ cents! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
printString
	^ self title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'avi 8/29/2004 14:12'!
subtitle: aString
	subtitle _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title _ aString! !

Object subclass: #WAStringLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStringLibrary subclass: #WAScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAScriptLibrary class methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	self new do: [:ea | anHtmlRoot addScript: ea]! !

WAScriptLibrary subclass: #WAStandardScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardScripts methodsFor: 'as yet unclassified' stamp: 'ac 11/19/2005 08:55'!
misc
	^ 'function swapDisplay(a, b) {
			var tmp = document.getElementById(a).style.display;
			document.getElementById(a).style.display = document.getElementById(b).style.display;
			document.getElementById(b).style.display = tmp;
	}

	function submitFormTriggeringCallback(formName, callbackKey, value) {
		var ele = document.createElement("input");
		ele.type = "hidden";
		ele.name = callbackKey;
		ele.value = value;
		document.forms[formName].appendChild(ele);
		document.forms[formName].submit();
	}
	
	function chooseOther(select, hiddenId, p) {
		value = prompt(p);
		document.getElementById(hiddenId).value = value;
		select.options[select.options.length-1].text = value;
	}
	
	function enableChoice(enableID, disableID) {
		document.getElementById(enableID).disabled = false;
		document.getElementById(disableID).disabled = true;
	}
'! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:28'!
asString
	^ self class name! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol
	^ self perform: aSymbol! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:13'!
at: aSymbol put: aString
	self class compile: aSymbol, '
	^ ', aString printString! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'mbany 4/14/2005 13:01'!
displayString
	^ self class name! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:13'!
do: aBlock
	self keys do: [:ea | aBlock value: (self at: ea)]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 21:52'!
keys
	^ (self class selectors select: [:ea | ea isUnary]) asSortedCollection! !

WAStringLibrary subclass: #WAStyleLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

WAStyleLibrary subclass: #WAStandardStyles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Libraries'!

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: 'lr 9/26/2005 15:15'!
basics
	^ 'div.clearer {clear: both}
.option-selected {font-weight: bold}'! !

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: 'avi 12/12/2004 13:41'!
kalseyTabs
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options #option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}
'! !

!WAStandardStyles methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 13:57'!
sourceStyle
	^'
.halo-source .html-source {
	font-family: courier, serif;
	font-size: 9pt;
}

.halo-source .xmlDeclaration {
	color: limegreen;
	font-style: italic;
}

.halo-source .doctype {
	color: skyblue;
	font-style: italic;
}

.halo-source .tag-known {
	color: purple;
	font-weight: bold;
}

.halo-source .attribute-known {
	font-weight: bold;
}

.halo-source .attribute-value {
	color: blue;
}

.halo-source .template {
	color: blue;
	font-weight: bold;
}

'! !

!WAStyleLibrary class methodsFor: 'as yet unclassified' stamp: 'avi 6/24/2004 00:34'!
updateRoot: anHtmlRoot
	self new do: [:ea | anHtmlRoot addStyle: ea]! !

Object subclass: #WAUrl
	instanceVariableNames: 'host port scheme path params fragment parameterString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HTTP'!

!WAUrl class methodsFor: 'as yet unclassified' stamp: 'avi 3/18/2004 16:07'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addParameter: aString
	self addParameter: aString value: nil
! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:09'!
addParameter: keyString value: valueString
	params at: keyString put: valueString.
	parameterString _ nil! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addToPath: aString
	path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/22/2004 00:42'!
asString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 4/15/2004 11:35'!
copy
	| copy |
	copy _ self class new.
	copy hostname: host; port: port; scheme: scheme; fragment: fragment.
	copy addToPath: self pathString.
	params keysAndValuesDo: [:k :v | copy addParameter: k value: v].
	^ copy! !

!WAUrl methodsFor: 'private' stamp: 'avi 3/22/2004 00:47'!
defaultPortForScheme: aSymbol
	^ aSymbol = #http
		ifTrue: [80]
		ifFalse: [aSymbol = #https
					ifTrue: [443]]! !

!WAUrl methodsFor: 'printing' stamp: 'mbany 4/14/2005 13:02'!
displayString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment
	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment: aString
	fragment _ aString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:35'!
fragmentString
	^ fragment ifNil: [''] ifNotNil: ['#', fragment]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname
	^ host! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname: aString
	host _ aString! !

!WAUrl methodsFor: 'initialize-release' stamp: 'avi 3/22/2004 00:48'!
initialize
	path _ OrderedCollection new.
	params _ Dictionary new.
	scheme _ #http! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 12:25'!
isSeasideField: aString
	^ aString first  = $_ or: [aString allSatisfy: [:ea | ea isDigit]]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 12:26'!
orderedParameterKeys 
	| keys |
	keys _ OrderedCollection new.
	params keys do: [:ea | (self isSeasideField: ea) ifTrue: [keys addLast: ea] ifFalse: [keys addFirst: ea]].
	^ keys! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 13:08'!
parameterString
	| v |
	^ parameterString ifNil: [parameterString _ String streamContents:
		[:s |
		params isEmpty ifFalse:
			[s nextPut: $?.
			self orderedParameterKeys do:
				[:k |
				v _ params at: k.
				s nextPutAll: k encodeForHTTP.
				v ifNotNil: [s nextPut: $=; nextPutAll: v encodeForHTTP].
				s nextPut: $&].
			s skip: -1]]]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 13:11'!
parameters
	^ params! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:46'!
path
	^ path! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 5/3/2005 08:51'!
pathString
	^ String streamContents: [ :stream | 
		stream nextPut: $/.
		path 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream nextPut: $/ ] ]
! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
port
	^ port ifNil: [self defaultPortForScheme: scheme]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/18/2004 16:07'!
port: aNumber
	port _ aNumber! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/7/2005 12:31'!
queryString
	^ self parameterString, self fragmentString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme
	^ scheme! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme: aSymbol
	scheme _ aSymbol! !

!WAUrl methodsFor: 'printing' stamp: 'avi 11/28/2005 16:07'!
serverString
	host ifNil: [^ ''].
	
	^ String streamContents:
		[:stream |
		stream nextPutAll: scheme.
		stream nextPutAll: '://'.
		stream nextPutAll: host.
		
		((self defaultPortForScheme: scheme) = self port)
			ifFalse: [stream nextPutAll: ':', port displayString]]! !

!WAUrl methodsFor: 'private' stamp: 'avi 11/7/2005 13:07'!
setParameterString: aString
	parameterString _ aString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 11/27/2005 15:17'!
takeServerParametersFromRequest: aRequest
	| httpHost |
	host ifNil:
		[httpHost _ aRequest headerAt: 'host' ifAbsent: [^ self]. 
		host _ httpHost copyUpTo: $:.
		(httpHost includes: $:) ifTrue:
			[port _ (httpHost copyAfter: $:) asNumber]]! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:36'!
urlString
	^ self serverString, self pathString, self fragmentString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 10/6/2005 10:00'!
urlWithQueryString
	^ String streamContents:
		[:s |
		s nextPutAll: self serverString.
		s nextPutAll: self pathString.
		s nextPutAll: self queryString]! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 11/7/2005 13:08'!
withParameter: aString
	^ self copy
		addParameter: aString;
		setParameterString: (self parameterString, '&', aString);
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Color methodsFor: '*seaside2' stamp: 'avi 4/29/2004 13:06'!
asHTMLColor
	^ '#', self hex! !

!Color methodsFor: '*seaside2' stamp: 'lr 5/4/2005 11:49'!
hex
	^ ((self red * 255) asInteger printPaddedWith: $0 to: 2 base: 16) ,
	  ((self green * 255) asInteger printPaddedWith: $0 to: 2 base: 16) ,
	  ((self blue * 255) asInteger printPaddedWith: $0 to: 2 base: 16).! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'al 6/29/2005 16:11'!
raiseSignal
	^ self signal
! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb _ Amb new! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results _ amb allValues:
				[x _ amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:31'!
testMaybe
	|x y z|
	x _ amb maybe.
	y _ amb maybe.
	z _ amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: x.
	self deny: y.
	self deny: z.! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x _ self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker _ amb oneOf: (1 to: 5).
	cooper _ amb oneOf: (1 to: 5).
	fletcher _ amb oneOf: (1 to: 5).
	miller _ amb oneOf: (1 to: 5).
	smith _ amb oneOf: (1 to: 5).
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.
"	! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher _ amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith _ amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper _ amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller _ amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker _ amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x _ amb oneOf: (1 to: 10).
	y _ amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockEscape
	|x|
	tmp _ 0.
	x _ [tmp _ tmp + 1. tmp2 value].
	self callcc: [:cc | tmp2 _ cc. x value].
	tmp2 _ [].
	x value.
	self assert: tmp = 2.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockTemps
	|y|
	#(1 2 3) do:
		[:i ||x|
			x _ i.
			tmp ifNil: [tmp2 _ (self callcc: [:cc | tmp _ cc. [:q]])].
			tmp2 value: x.
			x _ 17].
	y _ (self callcc: [:cc | tmp value: cc. 42]).
	self assert: y = 1.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockVars
	|continuation|
	tmp _ 0.
	tmp _ (self callcc: [:cc | continuation _ cc. 0]) + tmp.
	tmp2 
		ifNotNil: [tmp2 value]
		ifNil:
			[#(1 2 3) do:
				[:i |
				self callcc: [:cc | tmp2 _ cc. continuation value: i]]].
	self assert: tmp = 6.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 2/14/2003 01:17'!
testComprehension
	"What should this print out?
	
	|yin yang|
	yin := [:x | Transcript cr. x] value: Continuation current.
	yang := [:x | Transcript nextPut: $*. x] value: Continuation current.
	yin value: yang."! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testMethodTemps
	|i continuation|
	i _ 0.
	i _ i + (self callcc: [:cc | continuation _ cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [continuation value: 2].! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testSimpleCallCC
	|x continuation|
	x _ self callcc: [:cc | continuation _ cc. false].
	x ifFalse: [continuation value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:27'!
testSimplestCallCC
	|x|
	x _ self callcc: [:cc | cc value: true].
	self assert: x.! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:43'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root _ WAUserConfiguration new.
	boat _ WAUserConfiguration new addAncestor: root.
	dayBoat _ WAUserConfiguration new addAncestor: boat.
	wheelBoat _ WAUserConfiguration new addAncestor: boat.
	engineLess _ WAUserConfiguration new addAncestor: dayBoat.
	pedalWheelBoat _ WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat.
	smallMultihull _ WAUserConfiguration new addAncestor: dayBoat.
	smallCatamaran _ WAUserConfiguration new addAncestor: smallMultihull.
	pedalo _ WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry _ WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	snap2 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 _ registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:21'!
testGarbageCollection
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a _ nil.
	Smalltalk garbageCollect.
	self assert: registry size = 0.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	snap2 _ registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:31'!
asMIMEDocument
	^ self imageForm asMIMEDocument! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

TcpService subclass: #WAModLisp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:45'!
entryPoint
	^ WADispatcher default! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:45'!
handleRequest: aRequest
	^ (self entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:38'!
parseFields: aString
	| dict key value start end eqSignPos more |
	dict _ Dictionary new.
	aString isEmptyOrNil ifTrue: [^dict].
	more _ true.
	start _ 1.
	[end _ aString indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end _ aString size. more _ false]
		ifFalse: [end _ end - 1].
	eqSignPos _ aString indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key _ (key _ aString copyFrom: start to: end) unescapePercents.
			value _ '']
		ifFalse: [key _ (key _ aString copyFrom: start to: eqSignPos-1) unescapePercents.
			value _ (value _ aString copyFrom: eqSignPos+1 to: end) unescapePercents].
	dict at: key put: value.
	start _ end + 2.
	more] whileTrue.

	^dict! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:04'!
readHeadersFrom: aStream
	| headers key |
	headers _ Dictionary new.
	[(key _ (aStream upTo: Character lf)) = 'end'] whileFalse:
		[headers at: key put: (aStream upTo: Character lf)].
	^ headers! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:25'!
serve: aSocket
	| stream |
	stream _ SocketStream on: aSocket.
	[aSocket isConnected] whileTrue: [self serveOn: stream]! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:37'!
serveOn: aStream
	| headers request response content method url query fields |
	headers _ self readHeadersFrom: aStream.
	
	headers at: 'Content-Length' ifPresent:
		[:cl |
		content _ aStream next: cl asInteger].	
	method _ headers at: 'method'.
	url _ (headers at: 'url') copyUpTo: $?.
	query _ (headers at: 'url') copyAfter: $?.
	
	method asLowercase = 'get'
		ifTrue: [fields _ self parseFields: query]
		ifFalse: [fields _ self parseFields: content].
		
	request _ WARequest
				method: method
				url: url
				headers: headers
				fields: fields
				cookies: Dictionary new.

	response _ self handleRequest: request.
	self writeResponse: response on: aStream.
	aStream flush! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/10/2005 14:33'!
writeKey: keyString value: valueString on: aStream
	aStream nextPutAll: keyString displayString; nextPut: Character lf.
	aStream nextPutAll: valueString displayString; nextPut: Character lf! !

!WAModLisp methodsFor: 'as yet unclassified' stamp: 'avi 5/5/2005 13:30'!
writeResponse: aResponse on: aStream
	self writeKey: 'Status' value: aResponse status on: aStream.
	self writeKey: 'Content-Type' value: aResponse contentType on: aStream.
	aResponse headers keysAndValuesDo:
		[:k :v |
		self writeKey: k value: v on: aStream].
	self writeKey: 'Content-Length' value: aResponse contents size on: aStream.
	self writeKey: 'Keep-Socket' value: 1 on: aStream.
	aStream nextPutAll: 'end'; nextPut: Character lf.
	aStream nextPutAll: aResponse contents contents! !

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:13'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [:n | n resume: anObject]! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

!WADynamicVariable methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:12'!
defaultAction
	self resume: self class defaultValue! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

Notification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

!True methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'Yes'! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!Seaside2Info class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:19'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"]! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'cwp 4/25/2004 18:40'!
systemCategoryPrefix
	^ 'Seaside'! !

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'avi 3/20/2004 17:55'!
ignoredCategories
	^ #('Platform' 'Base-Connections' 'Rendering-Buttons' 'Components-Tools-Squeak')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'avi 3/20/2004 17:55'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:13'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString endsWith: 'squeak') not]! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:10'!
packageName
	^ 'SeasideVW'! !

!Form methodsFor: '*seaside2-squeak' stamp: 'avi 4/29/2004 13:00'!
asMIMEDocument 
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	GIFReadWriter putForm: (self asFormOfDepth: 8) onStream: aStream.
	^MIMEDocument contentType: 'image/gif' content: aStream contents! !

!Parser methodsFor: '*seaside2-squeak-override' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'avi 4/14/2004 23:39'!
asMIMEDocument
	^ MIMELocalFileDocument contentType: 'text/plain' contentStream:  self! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!Symbol methodsFor: '*seaside2' stamp: 'lr 9/13/2005 22:57'!
asMutator
	^ (self copyWith: $:) asSymbol.! !

!False methodsFor: '*seaside2' stamp: 'ac 3/22/2005 20:23'!
yesNoString
	^ 'No'! !

!String methodsFor: '*seaside2' stamp: 'avi 3/16/2004 16:33'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!String methodsFor: '*seaside2' stamp: 'ab 7/3/2003 13:04'!
asMIMEDocument 
	^ SeasidePlatformSupport mimeDocumentClass contentType: 'text/plain' content: self! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'jf 2/18/2004 15:21'!
renderOn: html indentLevel: level
	html text: self! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 10/10/2002 01:40'!
fixTemps! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 8/24/2003 16:38'!
valueWithPossibleArgs: anArray 

	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)

! !

!Integer methodsFor: '*seaside2' stamp: 'mbany 4/14/2005 12:09'!
printStringAsCents
	^ '$', (self // 100) displayString, '.', (self \\ 100) asTwoCharacterString! !

!Array methodsFor: '*seaside2' stamp: 'ab 10/26/2002 21:26'!
renderOn: html
	self do: [:ea | ea renderOn: html]! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 5/22/2004 12:57'!
homeReceiver
	^ self home receiver! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !
WAExternalID initialize!
WAAbstractHtmlBuilder initialize!
WACachedDocument initialize!
WAUserConfiguration initialize!
WAKom initialize!
WAListener initialize!
WACounter initialize!
WADispatcherEditor initialize!
WAExampleBrowser initialize!
WAAllTests initialize!
WAHalo initialize!
WAMultiCounter initialize!
WAStore initialize!
WAVNCController initialize!
WAExpirySession initialize!
WASpotProfiler initialize!
Seaside2Info initialize!
